/* SearchProvider.c generated by valac 0.56.17, the Vala compiler
 * generated from SearchProvider.vala, do not modify */

/* SearchProvider.vala
 *
 * Copyright (C) 2020-2024 Jerry Casiano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 *
 * If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.
*/

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <json-glib/json-glib.h>
#include "font-manager.h"
#include <sqlite3.h>

#define FONT_MANAGER_SEARCH_PROVIDER_SEARCH_PROVIDER_BUS_PATH "/com/github/FontManager/FontManager/SearchProvider"
#define FONT_MANAGER_SEARCH_PROVIDER_QUERY "SELECT filepath, findex, family, style from Fonts WHERE family LIKE \"" \
"%s%\" ORDER BY weight;"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define FONT_MANAGER_TYPE_SEARCH_PROVIDER (font_manager_search_provider_get_type ())
#define FONT_MANAGER_SEARCH_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_SEARCH_PROVIDER, FontManagerSearchProvider))
#define FONT_MANAGER_SEARCH_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_SEARCH_PROVIDER, FontManagerSearchProviderClass))
#define FONT_MANAGER_IS_SEARCH_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_SEARCH_PROVIDER))
#define FONT_MANAGER_IS_SEARCH_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_SEARCH_PROVIDER))
#define FONT_MANAGER_SEARCH_PROVIDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_SEARCH_PROVIDER, FontManagerSearchProviderClass))

typedef struct _FontManagerSearchProvider FontManagerSearchProvider;
typedef struct _FontManagerSearchProviderClass FontManagerSearchProviderClass;
typedef struct _FontManagerSearchProviderPrivate FontManagerSearchProviderPrivate;
enum  {
	FONT_MANAGER_SEARCH_PROVIDER_0_PROPERTY,
	FONT_MANAGER_SEARCH_PROVIDER_NUM_PROPERTIES
};
static GParamSpec* font_manager_search_provider_properties[FONT_MANAGER_SEARCH_PROVIDER_NUM_PROPERTIES];
typedef enum  {
	FONT_MANAGER_SEARCH_PROVIDER_ID_FILEPATH,
	FONT_MANAGER_SEARCH_PROVIDER_ID_INDEX,
	FONT_MANAGER_SEARCH_PROVIDER_ID_FAMILY,
	FONT_MANAGER_SEARCH_PROVIDER_ID_STYLE
} FontManagerSearchProviderID;

#define FONT_MANAGER_SEARCH_PROVIDER_TYPE_ID (font_manager_search_provider_id_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _Block13Data Block13Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _FontManagerSearchProviderGetInitialResultSetData FontManagerSearchProviderGetInitialResultSetData;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _FontManagerSearchProviderGetSubsearchResultSetData FontManagerSearchProviderGetSubsearchResultSetData;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _FontManagerSearchProviderGetInitialResultSetReadyData FontManagerSearchProviderGetInitialResultSetReadyData;
typedef struct _FontManagerSearchProviderGetSubsearchResultSetReadyData FontManagerSearchProviderGetSubsearchResultSetReadyData;

struct _FontManagerSearchProvider {
	GObject parent_instance;
	FontManagerSearchProviderPrivate * priv;
};

struct _FontManagerSearchProviderClass {
	GObjectClass parent_class;
};

struct _FontManagerSearchProviderPrivate {
	guint dbus_id;
};

struct _Block13Data {
	int _ref_count_;
	FontManagerSearchProvider* self;
	gchar** result_set;
	gint result_set_length1;
	gint _result_set_size_;
};

struct _FontManagerSearchProviderGetInitialResultSetData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FontManagerSearchProvider* self;
	gchar** terms;
	gint terms_length1;
	gchar** result;
	gint result_length1;
	gchar** result_set;
	gchar** _tmp0_;
	gint result_set_length1;
	gint _result_set_size_;
	gchar** _tmp1_;
	gint _tmp1__length1;
};

struct _FontManagerSearchProviderGetSubsearchResultSetData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FontManagerSearchProvider* self;
	gchar** previous_results;
	gint previous_results_length1;
	gchar** terms;
	gint terms_length1;
	gchar** result;
	gint result_length1;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gint _tmp8_;
	gchar** _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
};

struct _FontManagerSearchProviderGetInitialResultSetReadyData {
	GDBusMethodInvocation* _invocation_;
	gchar** terms;
	gint terms_length1;
};

struct _FontManagerSearchProviderGetSubsearchResultSetReadyData {
	GDBusMethodInvocation* _invocation_;
	gchar** previous_results;
	gint previous_results_length1;
	gchar** terms;
	gint terms_length1;
};

static gint FontManagerSearchProvider_private_offset;
static gpointer font_manager_search_provider_parent_class = NULL;

VALA_EXTERN GType font_manager_search_provider_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerSearchProvider, g_object_unref)
VALA_EXTERN guint font_manager_search_provider_register_object (void* object,
                                                    GDBusConnection* connection,
                                                    const gchar* path,
                                                    GError** error);
static GType font_manager_search_provider_id_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static gchar* font_manager_search_provider_get_search_term (FontManagerSearchProvider* self,
                                                     gchar** terms,
                                                     gint terms_length1);
static gchar** font_manager_search_provider_character_search (FontManagerSearchProvider* self,
                                                       const gchar* charset,
                                                       gint* result_length1);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void block13_data_unref (void * _userdata_);
static void __lambda208_ (Block13Data* _data13_,
                   JsonObject* obj,
                   const gchar* name,
                   JsonNode* node);
static void __lambda209_ (Block13Data* _data13_,
                   JsonObject* obj,
                   const gchar* name,
                   JsonNode* node);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void ___lambda209__json_object_foreach (JsonObject* object,
                                        const gchar* member_name,
                                        JsonNode* member_node,
                                        gpointer self);
static void ___lambda208__json_object_foreach (JsonObject* object,
                                        const gchar* member_name,
                                        JsonNode* member_node,
                                        gpointer self);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static gchar** font_manager_search_provider_database_search (FontManagerSearchProvider* self,
                                                      gchar** terms,
                                                      gint terms_length1,
                                                      gint* result_length1);
VALA_EXTERN FontManagerDatabase* font_manager_database_proxy_get_default_db (void);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void font_manager_search_provider_get_initial_result_set_data_free (gpointer _data);
VALA_EXTERN void font_manager_search_provider_get_initial_result_set (FontManagerSearchProvider* self,
                                                          gchar** terms,
                                                          gint terms_length1,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
VALA_EXTERN gchar** font_manager_search_provider_get_initial_result_set_finish (FontManagerSearchProvider* self,
                                                                    GAsyncResult* _res_,
                                                                    gint* result_length1,
                                                                    GError** error);
static gboolean font_manager_search_provider_get_initial_result_set_co (FontManagerSearchProviderGetInitialResultSetData* _data_);
static void font_manager_search_provider_get_subsearch_result_set_data_free (gpointer _data);
VALA_EXTERN void font_manager_search_provider_get_subsearch_result_set (FontManagerSearchProvider* self,
                                                            gchar** previous_results,
                                                            gint previous_results_length1,
                                                            gchar** terms,
                                                            gint terms_length1,
                                                            GAsyncReadyCallback _callback_,
                                                            gpointer _user_data_);
VALA_EXTERN gchar** font_manager_search_provider_get_subsearch_result_set_finish (FontManagerSearchProvider* self,
                                                                      GAsyncResult* _res_,
                                                                      gint* result_length1,
                                                                      GError** error);
static gboolean font_manager_search_provider_get_subsearch_result_set_co (FontManagerSearchProviderGetSubsearchResultSetData* _data_);
VALA_EXTERN GHashTable** font_manager_search_provider_get_result_metas (FontManagerSearchProvider* self,
                                                            gchar** results,
                                                            gint results_length1,
                                                            gint* result_length1,
                                                            GError** error);
static void _g_hash_table_unref0_ (gpointer var);
static void _g_free0_ (gpointer var);
static void _g_variant_unref0_ (gpointer var);
static GVariant* _variant_new1 (gchar* value);
static GVariant* _variant_new2 (const gchar* value);
static GVariant* _variant_new3 (const gchar* value);
static GHashTable** _vala_array_dup2 (GHashTable** self,
                               gssize length);
VALA_EXTERN void font_manager_search_provider_activate_result (FontManagerSearchProvider* self,
                                                   const gchar* _result_,
                                                   gchar** terms,
                                                   gint terms_length1,
                                                   guint32 timestamp,
                                                   GError** error);
VALA_EXTERN void font_manager_search_provider_launch_search (FontManagerSearchProvider* self,
                                                 gchar** terms,
                                                 gint terms_length1,
                                                 guint32 timestamp,
                                                 GError** error);
VALA_EXTERN void font_manager_search_provider_dbus_register (FontManagerSearchProvider* self,
                                                 GDBusConnection* conn);
VALA_EXTERN void font_manager_search_provider_dbus_unregister (FontManagerSearchProvider* self,
                                                   GDBusConnection* conn);
VALA_EXTERN FontManagerSearchProvider* font_manager_search_provider_new (void);
VALA_EXTERN FontManagerSearchProvider* font_manager_search_provider_construct (GType object_type);
static void font_manager_search_provider_finalize (GObject * obj);
static GType font_manager_search_provider_get_type_once (void);
static void _dbus_font_manager_search_provider_get_initial_result_set (FontManagerSearchProvider* self,
                                                                GVariant* _parameters_,
                                                                GDBusMethodInvocation* invocation);
static void _dbus_font_manager_search_provider_get_initial_result_set_ready (GObject * source_object,
                                                                      GAsyncResult * _res_,
                                                                      gpointer _user_data_);
static void _dbus_font_manager_search_provider_get_subsearch_result_set (FontManagerSearchProvider* self,
                                                                  GVariant* _parameters_,
                                                                  GDBusMethodInvocation* invocation);
static void _dbus_font_manager_search_provider_get_subsearch_result_set_ready (GObject * source_object,
                                                                        GAsyncResult * _res_,
                                                                        gpointer _user_data_);
static void _dbus_font_manager_search_provider_get_result_metas (FontManagerSearchProvider* self,
                                                          GVariant* _parameters_,
                                                          GDBusMethodInvocation* invocation);
static void _dbus_font_manager_search_provider_activate_result (FontManagerSearchProvider* self,
                                                         GVariant* _parameters_,
                                                         GDBusMethodInvocation* invocation);
static void _dbus_font_manager_search_provider_launch_search (FontManagerSearchProvider* self,
                                                       GVariant* _parameters_,
                                                       GDBusMethodInvocation* invocation);
static void font_manager_search_provider_dbus_interface_method_call (GDBusConnection* connection,
                                                              const gchar* sender,
                                                              const gchar* object_path,
                                                              const gchar* interface_name,
                                                              const gchar* method_name,
                                                              GVariant* parameters,
                                                              GDBusMethodInvocation* invocation,
                                                              gpointer user_data);
static GVariant* font_manager_search_provider_dbus_interface_get_property (GDBusConnection* connection,
                                                                    const gchar* sender,
                                                                    const gchar* object_path,
                                                                    const gchar* interface_name,
                                                                    const gchar* property_name,
                                                                    GError** error,
                                                                    gpointer user_data);
static gboolean font_manager_search_provider_dbus_interface_set_property (GDBusConnection* connection,
                                                                   const gchar* sender,
                                                                   const gchar* object_path,
                                                                   const gchar* interface_name,
                                                                   const gchar* property_name,
                                                                   GVariant* value,
                                                                   GError** error,
                                                                   gpointer user_data);
static void _font_manager_search_provider_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const GDBusArgInfo _font_manager_search_provider_dbus_arg_info_get_initial_result_set_terms = {-1, "terms", "as", NULL};
static const GDBusArgInfo _font_manager_search_provider_dbus_arg_info_get_initial_result_set_result = {-1, "result", "as", NULL};
static const GDBusArgInfo * const _font_manager_search_provider_dbus_arg_info_get_initial_result_set_in[] = {&_font_manager_search_provider_dbus_arg_info_get_initial_result_set_terms, NULL};
static const GDBusArgInfo * const _font_manager_search_provider_dbus_arg_info_get_initial_result_set_out[] = {&_font_manager_search_provider_dbus_arg_info_get_initial_result_set_result, NULL};
static const GDBusMethodInfo _font_manager_search_provider_dbus_method_info_get_initial_result_set = {-1, "GetInitialResultSet", (GDBusArgInfo **) (&_font_manager_search_provider_dbus_arg_info_get_initial_result_set_in), (GDBusArgInfo **) (&_font_manager_search_provider_dbus_arg_info_get_initial_result_set_out), NULL};
static const GDBusArgInfo _font_manager_search_provider_dbus_arg_info_get_subsearch_result_set_previous_results = {-1, "previous_results", "as", NULL};
static const GDBusArgInfo _font_manager_search_provider_dbus_arg_info_get_subsearch_result_set_terms = {-1, "terms", "as", NULL};
static const GDBusArgInfo _font_manager_search_provider_dbus_arg_info_get_subsearch_result_set_result = {-1, "result", "as", NULL};
static const GDBusArgInfo * const _font_manager_search_provider_dbus_arg_info_get_subsearch_result_set_in[] = {&_font_manager_search_provider_dbus_arg_info_get_subsearch_result_set_previous_results, &_font_manager_search_provider_dbus_arg_info_get_subsearch_result_set_terms, NULL};
static const GDBusArgInfo * const _font_manager_search_provider_dbus_arg_info_get_subsearch_result_set_out[] = {&_font_manager_search_provider_dbus_arg_info_get_subsearch_result_set_result, NULL};
static const GDBusMethodInfo _font_manager_search_provider_dbus_method_info_get_subsearch_result_set = {-1, "GetSubsearchResultSet", (GDBusArgInfo **) (&_font_manager_search_provider_dbus_arg_info_get_subsearch_result_set_in), (GDBusArgInfo **) (&_font_manager_search_provider_dbus_arg_info_get_subsearch_result_set_out), NULL};
static const GDBusArgInfo _font_manager_search_provider_dbus_arg_info_get_result_metas_results = {-1, "results", "as", NULL};
static const GDBusArgInfo _font_manager_search_provider_dbus_arg_info_get_result_metas_result = {-1, "result", "aa{sv}", NULL};
static const GDBusArgInfo * const _font_manager_search_provider_dbus_arg_info_get_result_metas_in[] = {&_font_manager_search_provider_dbus_arg_info_get_result_metas_results, NULL};
static const GDBusArgInfo * const _font_manager_search_provider_dbus_arg_info_get_result_metas_out[] = {&_font_manager_search_provider_dbus_arg_info_get_result_metas_result, NULL};
static const GDBusMethodInfo _font_manager_search_provider_dbus_method_info_get_result_metas = {-1, "GetResultMetas", (GDBusArgInfo **) (&_font_manager_search_provider_dbus_arg_info_get_result_metas_in), (GDBusArgInfo **) (&_font_manager_search_provider_dbus_arg_info_get_result_metas_out), NULL};
static const GDBusArgInfo _font_manager_search_provider_dbus_arg_info_activate_result_result = {-1, "result", "s", NULL};
static const GDBusArgInfo _font_manager_search_provider_dbus_arg_info_activate_result_terms = {-1, "terms", "as", NULL};
static const GDBusArgInfo _font_manager_search_provider_dbus_arg_info_activate_result_timestamp = {-1, "timestamp", "u", NULL};
static const GDBusArgInfo * const _font_manager_search_provider_dbus_arg_info_activate_result_in[] = {&_font_manager_search_provider_dbus_arg_info_activate_result_result, &_font_manager_search_provider_dbus_arg_info_activate_result_terms, &_font_manager_search_provider_dbus_arg_info_activate_result_timestamp, NULL};
static const GDBusArgInfo * const _font_manager_search_provider_dbus_arg_info_activate_result_out[] = {NULL};
static const GDBusMethodInfo _font_manager_search_provider_dbus_method_info_activate_result = {-1, "ActivateResult", (GDBusArgInfo **) (&_font_manager_search_provider_dbus_arg_info_activate_result_in), (GDBusArgInfo **) (&_font_manager_search_provider_dbus_arg_info_activate_result_out), NULL};
static const GDBusArgInfo _font_manager_search_provider_dbus_arg_info_launch_search_terms = {-1, "terms", "as", NULL};
static const GDBusArgInfo _font_manager_search_provider_dbus_arg_info_launch_search_timestamp = {-1, "timestamp", "u", NULL};
static const GDBusArgInfo * const _font_manager_search_provider_dbus_arg_info_launch_search_in[] = {&_font_manager_search_provider_dbus_arg_info_launch_search_terms, &_font_manager_search_provider_dbus_arg_info_launch_search_timestamp, NULL};
static const GDBusArgInfo * const _font_manager_search_provider_dbus_arg_info_launch_search_out[] = {NULL};
static const GDBusMethodInfo _font_manager_search_provider_dbus_method_info_launch_search = {-1, "LaunchSearch", (GDBusArgInfo **) (&_font_manager_search_provider_dbus_arg_info_launch_search_in), (GDBusArgInfo **) (&_font_manager_search_provider_dbus_arg_info_launch_search_out), NULL};
static const GDBusMethodInfo * const _font_manager_search_provider_dbus_method_info[] = {&_font_manager_search_provider_dbus_method_info_get_initial_result_set, &_font_manager_search_provider_dbus_method_info_get_subsearch_result_set, &_font_manager_search_provider_dbus_method_info_get_result_metas, &_font_manager_search_provider_dbus_method_info_activate_result, &_font_manager_search_provider_dbus_method_info_launch_search, NULL};
static const GDBusSignalInfo * const _font_manager_search_provider_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _font_manager_search_provider_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _font_manager_search_provider_dbus_interface_info = {-1, "org.gnome.Shell.SearchProvider2", (GDBusMethodInfo **) (&_font_manager_search_provider_dbus_method_info), (GDBusSignalInfo **) (&_font_manager_search_provider_dbus_signal_info), (GDBusPropertyInfo **) (&_font_manager_search_provider_dbus_property_info), NULL};
static const GDBusInterfaceVTable _font_manager_search_provider_dbus_interface_vtable = {font_manager_search_provider_dbus_interface_method_call, font_manager_search_provider_dbus_interface_get_property, font_manager_search_provider_dbus_interface_set_property};

static inline gpointer
font_manager_search_provider_get_instance_private (FontManagerSearchProvider* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerSearchProvider_private_offset);
}

 G_GNUC_NO_INLINE static GType
font_manager_search_provider_id_get_type_once (void)
{
	static const GEnumValue values[] = {{FONT_MANAGER_SEARCH_PROVIDER_ID_FILEPATH, "FONT_MANAGER_SEARCH_PROVIDER_ID_FILEPATH", "filepath"}, {FONT_MANAGER_SEARCH_PROVIDER_ID_INDEX, "FONT_MANAGER_SEARCH_PROVIDER_ID_INDEX", "index"}, {FONT_MANAGER_SEARCH_PROVIDER_ID_FAMILY, "FONT_MANAGER_SEARCH_PROVIDER_ID_FAMILY", "family"}, {FONT_MANAGER_SEARCH_PROVIDER_ID_STYLE, "FONT_MANAGER_SEARCH_PROVIDER_ID_STYLE", "style"}, {0, NULL, NULL}};
	GType font_manager_search_provider_id_type_id;
	font_manager_search_provider_id_type_id = g_enum_register_static ("FontManagerSearchProviderID", values);
	return font_manager_search_provider_id_type_id;
}

static GType
font_manager_search_provider_id_get_type (void)
{
	static volatile gsize font_manager_search_provider_id_type_id__once = 0;
	if (g_once_init_enter (&font_manager_search_provider_id_type_id__once)) {
		GType font_manager_search_provider_id_type_id;
		font_manager_search_provider_id_type_id = font_manager_search_provider_id_get_type_once ();
		g_once_init_leave (&font_manager_search_provider_id_type_id__once, font_manager_search_provider_id_type_id);
	}
	return font_manager_search_provider_id_type_id__once;
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 409 "SearchProvider.c"
}

static gchar*
font_manager_search_provider_get_search_term (FontManagerSearchProvider* self,
                                              gchar** terms,
                                              gint terms_length1)
{
	GString* search_term = NULL;
	GString* _tmp0_;
	GString* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
#line 38 "../src/font-manager/SearchProvider.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/font-manager/SearchProvider.vala"
	_tmp0_ = g_string_new ("");
#line 39 "../src/font-manager/SearchProvider.vala"
	search_term = _tmp0_;
#line 429 "SearchProvider.c"
	{
		gchar** term_collection = NULL;
		gint term_collection_length1 = 0;
		gint _term_collection_size_ = 0;
		gint term_it = 0;
#line 40 "../src/font-manager/SearchProvider.vala"
		term_collection = terms;
#line 40 "../src/font-manager/SearchProvider.vala"
		term_collection_length1 = terms_length1;
#line 40 "../src/font-manager/SearchProvider.vala"
		for (term_it = 0; term_it < term_collection_length1; term_it = term_it + 1) {
#line 441 "SearchProvider.c"
			gchar* _tmp1_;
			gchar* term = NULL;
#line 40 "../src/font-manager/SearchProvider.vala"
			_tmp1_ = g_strdup (term_collection[term_it]);
#line 40 "../src/font-manager/SearchProvider.vala"
			term = _tmp1_;
#line 448 "SearchProvider.c"
			{
				GString* _tmp2_;
				GString* _tmp3_;
				const gchar* _tmp4_;
#line 41 "../src/font-manager/SearchProvider.vala"
				_tmp2_ = search_term;
#line 41 "../src/font-manager/SearchProvider.vala"
				g_string_append (_tmp2_, " ");
#line 42 "../src/font-manager/SearchProvider.vala"
				_tmp3_ = search_term;
#line 42 "../src/font-manager/SearchProvider.vala"
				_tmp4_ = term;
#line 42 "../src/font-manager/SearchProvider.vala"
				g_string_append (_tmp3_, _tmp4_);
#line 40 "../src/font-manager/SearchProvider.vala"
				_g_free0 (term);
#line 465 "SearchProvider.c"
			}
		}
	}
#line 44 "../src/font-manager/SearchProvider.vala"
	_tmp5_ = search_term;
#line 44 "../src/font-manager/SearchProvider.vala"
	_tmp6_ = _tmp5_->str;
#line 44 "../src/font-manager/SearchProvider.vala"
	_tmp7_ = string_strip (_tmp6_);
#line 44 "../src/font-manager/SearchProvider.vala"
	result = _tmp7_;
#line 44 "../src/font-manager/SearchProvider.vala"
	_g_string_free0 (search_term);
#line 44 "../src/font-manager/SearchProvider.vala"
	return result;
#line 481 "SearchProvider.c"
}

static Block13Data*
block13_data_ref (Block13Data* _data13_)
{
#line 47 "../src/font-manager/SearchProvider.vala"
	g_atomic_int_inc (&_data13_->_ref_count_);
#line 47 "../src/font-manager/SearchProvider.vala"
	return _data13_;
#line 491 "SearchProvider.c"
}

static void
block13_data_unref (void * _userdata_)
{
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
#line 47 "../src/font-manager/SearchProvider.vala"
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
#line 501 "SearchProvider.c"
		FontManagerSearchProvider* self;
#line 47 "../src/font-manager/SearchProvider.vala"
		self = _data13_->self;
#line 47 "../src/font-manager/SearchProvider.vala"
		_data13_->result_set = (_vala_array_free (_data13_->result_set, _data13_->result_set_length1, (GDestroyNotify) g_free), NULL);
#line 47 "../src/font-manager/SearchProvider.vala"
		_g_object_unref0 (self);
#line 47 "../src/font-manager/SearchProvider.vala"
		g_slice_free (Block13Data, _data13_);
#line 511 "SearchProvider.c"
	}
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 51 "../src/font-manager/SearchProvider.vala"
	return self ? json_object_ref (self) : NULL;
#line 520 "SearchProvider.c"
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 54 "../src/font-manager/SearchProvider.vala"
	if ((*length) == (*size)) {
#line 54 "../src/font-manager/SearchProvider.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 54 "../src/font-manager/SearchProvider.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 535 "SearchProvider.c"
	}
#line 54 "../src/font-manager/SearchProvider.vala"
	(*array)[(*length)++] = value;
#line 54 "../src/font-manager/SearchProvider.vala"
	(*array)[*length] = NULL;
#line 541 "SearchProvider.c"
}

static void
__lambda209_ (Block13Data* _data13_,
              JsonObject* obj,
              const gchar* name,
              JsonNode* node)
{
	FontManagerSearchProvider* self;
	JsonObject* font = NULL;
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
#line 52 "../src/font-manager/SearchProvider.vala"
	self = _data13_->self;
#line 52 "../src/font-manager/SearchProvider.vala"
	g_return_if_fail (obj != NULL);
#line 52 "../src/font-manager/SearchProvider.vala"
	g_return_if_fail (name != NULL);
#line 52 "../src/font-manager/SearchProvider.vala"
	g_return_if_fail (node != NULL);
#line 53 "../src/font-manager/SearchProvider.vala"
	_tmp0_ = json_node_get_object (node);
#line 53 "../src/font-manager/SearchProvider.vala"
	_tmp1_ = _json_object_ref0 (_tmp0_);
#line 53 "../src/font-manager/SearchProvider.vala"
	font = _tmp1_;
#line 54 "../src/font-manager/SearchProvider.vala"
	_tmp2_ = json_object_get_string_member (font, "filepath");
#line 54 "../src/font-manager/SearchProvider.vala"
	_tmp3_ = json_object_get_string_member (font, "family");
#line 54 "../src/font-manager/SearchProvider.vala"
	_tmp4_ = json_object_get_string_member (font, "style");
#line 54 "../src/font-manager/SearchProvider.vala"
	_tmp5_ = g_strdup_printf ("%s::%i::%s::%s", _tmp2_, (gint) json_object_get_int_member (font, "findex"), _tmp3_, _tmp4_);
#line 54 "../src/font-manager/SearchProvider.vala"
	_vala_array_add1 (&_data13_->result_set, &_data13_->result_set_length1, &_data13_->_result_set_size_, _tmp5_);
#line 52 "../src/font-manager/SearchProvider.vala"
	_json_object_unref0 (font);
#line 584 "SearchProvider.c"
}

static void
___lambda209__json_object_foreach (JsonObject* object,
                                   const gchar* member_name,
                                   JsonNode* member_node,
                                   gpointer self)
{
#line 52 "../src/font-manager/SearchProvider.vala"
	__lambda209_ (self, object, member_name, member_node);
#line 595 "SearchProvider.c"
}

static void
__lambda208_ (Block13Data* _data13_,
              JsonObject* obj,
              const gchar* name,
              JsonNode* node)
{
	FontManagerSearchProvider* self;
	JsonObject* fonts = NULL;
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
#line 50 "../src/font-manager/SearchProvider.vala"
	self = _data13_->self;
#line 50 "../src/font-manager/SearchProvider.vala"
	g_return_if_fail (obj != NULL);
#line 50 "../src/font-manager/SearchProvider.vala"
	g_return_if_fail (name != NULL);
#line 50 "../src/font-manager/SearchProvider.vala"
	g_return_if_fail (node != NULL);
#line 51 "../src/font-manager/SearchProvider.vala"
	_tmp0_ = json_node_get_object (node);
#line 51 "../src/font-manager/SearchProvider.vala"
	_tmp1_ = _json_object_ref0 (_tmp0_);
#line 51 "../src/font-manager/SearchProvider.vala"
	fonts = _tmp1_;
#line 52 "../src/font-manager/SearchProvider.vala"
	json_object_foreach_member (fonts, ___lambda209__json_object_foreach, _data13_);
#line 50 "../src/font-manager/SearchProvider.vala"
	_json_object_unref0 (fonts);
#line 626 "SearchProvider.c"
}

static void
___lambda208__json_object_foreach (JsonObject* object,
                                   const gchar* member_name,
                                   JsonNode* member_node,
                                   gpointer self)
{
#line 50 "../src/font-manager/SearchProvider.vala"
	__lambda208_ (self, object, member_name, member_node);
#line 637 "SearchProvider.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 60 "../src/font-manager/SearchProvider.vala"
	if (length >= 0) {
#line 646 "SearchProvider.c"
		gchar** result;
		gssize i;
#line 60 "../src/font-manager/SearchProvider.vala"
		result = g_new0 (gchar*, length + 1);
#line 60 "../src/font-manager/SearchProvider.vala"
		for (i = 0; i < length; i++) {
#line 653 "SearchProvider.c"
			gchar* _tmp0_;
#line 60 "../src/font-manager/SearchProvider.vala"
			_tmp0_ = g_strdup (self[i]);
#line 60 "../src/font-manager/SearchProvider.vala"
			result[i] = _tmp0_;
#line 659 "SearchProvider.c"
		}
#line 60 "../src/font-manager/SearchProvider.vala"
		return result;
#line 663 "SearchProvider.c"
	}
#line 60 "../src/font-manager/SearchProvider.vala"
	return NULL;
#line 667 "SearchProvider.c"
}

static gchar**
font_manager_search_provider_character_search (FontManagerSearchProvider* self,
                                               const gchar* charset,
                                               gint* result_length1)
{
	Block13Data* _data13_;
	gchar** _tmp0_;
	JsonObject* fontset = NULL;
	JsonObject* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** result;
#line 47 "../src/font-manager/SearchProvider.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../src/font-manager/SearchProvider.vala"
	g_return_val_if_fail (charset != NULL, NULL);
#line 47 "../src/font-manager/SearchProvider.vala"
	_data13_ = g_slice_new0 (Block13Data);
#line 47 "../src/font-manager/SearchProvider.vala"
	_data13_->_ref_count_ = 1;
#line 47 "../src/font-manager/SearchProvider.vala"
	_data13_->self = g_object_ref (self);
#line 48 "../src/font-manager/SearchProvider.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 48 "../src/font-manager/SearchProvider.vala"
	_data13_->result_set = _tmp0_;
#line 48 "../src/font-manager/SearchProvider.vala"
	_data13_->result_set_length1 = 0;
#line 48 "../src/font-manager/SearchProvider.vala"
	_data13_->_result_set_size_ = _data13_->result_set_length1;
#line 49 "../src/font-manager/SearchProvider.vala"
	_tmp1_ = font_manager_get_available_fonts_for_chars (charset);
#line 49 "../src/font-manager/SearchProvider.vala"
	fontset = _tmp1_;
#line 50 "../src/font-manager/SearchProvider.vala"
	json_object_foreach_member (fontset, ___lambda208__json_object_foreach, _data13_);
#line 60 "../src/font-manager/SearchProvider.vala"
	_tmp2_ = (_data13_->result_set != NULL) ? _vala_array_dup1 (_data13_->result_set, _data13_->result_set_length1) : _data13_->result_set;
#line 60 "../src/font-manager/SearchProvider.vala"
	_tmp2__length1 = _data13_->result_set_length1;
#line 60 "../src/font-manager/SearchProvider.vala"
	_tmp3_ = _tmp2_;
#line 60 "../src/font-manager/SearchProvider.vala"
	_tmp3__length1 = _tmp2__length1;
#line 60 "../src/font-manager/SearchProvider.vala"
	if (result_length1) {
#line 60 "../src/font-manager/SearchProvider.vala"
		*result_length1 = _tmp3__length1;
#line 720 "SearchProvider.c"
	}
#line 60 "../src/font-manager/SearchProvider.vala"
	result = _tmp3_;
#line 60 "../src/font-manager/SearchProvider.vala"
	_json_object_unref0 (fontset);
#line 60 "../src/font-manager/SearchProvider.vala"
	block13_data_unref (_data13_);
#line 60 "../src/font-manager/SearchProvider.vala"
	_data13_ = NULL;
#line 60 "../src/font-manager/SearchProvider.vala"
	return result;
#line 732 "SearchProvider.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 70 "../src/font-manager/SearchProvider.vala"
	if ((*length) == (*size)) {
#line 70 "../src/font-manager/SearchProvider.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 70 "../src/font-manager/SearchProvider.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 747 "SearchProvider.c"
	}
#line 70 "../src/font-manager/SearchProvider.vala"
	(*array)[(*length)++] = value;
#line 70 "../src/font-manager/SearchProvider.vala"
	(*array)[*length] = NULL;
#line 753 "SearchProvider.c"
}

static gchar**
font_manager_search_provider_database_search (FontManagerSearchProvider* self,
                                              gchar** terms,
                                              gint terms_length1,
                                              gint* result_length1)
{
	gchar** result_set = NULL;
	gchar** _tmp0_;
	gint result_set_length1;
	gint _result_set_size_;
	gchar* search_term = NULL;
	gchar* _tmp1_;
	gchar** _tmp23_;
	gint _tmp23__length1;
	GError* _inner_error0_ = NULL;
	gchar** result;
#line 63 "../src/font-manager/SearchProvider.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 64 "../src/font-manager/SearchProvider.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 64 "../src/font-manager/SearchProvider.vala"
	result_set = _tmp0_;
#line 64 "../src/font-manager/SearchProvider.vala"
	result_set_length1 = 0;
#line 64 "../src/font-manager/SearchProvider.vala"
	_result_set_size_ = result_set_length1;
#line 65 "../src/font-manager/SearchProvider.vala"
	_tmp1_ = font_manager_search_provider_get_search_term (self, terms, (gint) terms_length1);
#line 65 "../src/font-manager/SearchProvider.vala"
	search_term = _tmp1_;
#line 786 "SearchProvider.c"
	{
		FontManagerDatabase* db = NULL;
		FontManagerDatabase* _tmp2_;
		FontManagerDatabase* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		FontManagerDatabase* _tmp20_;
#line 67 "../src/font-manager/SearchProvider.vala"
		_tmp2_ = font_manager_database_proxy_get_default_db ();
#line 67 "../src/font-manager/SearchProvider.vala"
		db = _tmp2_;
#line 68 "../src/font-manager/SearchProvider.vala"
		_tmp3_ = db;
#line 68 "../src/font-manager/SearchProvider.vala"
		_tmp4_ = search_term;
#line 68 "../src/font-manager/SearchProvider.vala"
		_tmp5_ = g_strdup_printf (FONT_MANAGER_SEARCH_PROVIDER_QUERY, _tmp4_);
#line 68 "../src/font-manager/SearchProvider.vala"
		_tmp6_ = _tmp5_;
#line 68 "../src/font-manager/SearchProvider.vala"
		font_manager_database_execute_query (_tmp3_, _tmp6_, &_inner_error0_);
#line 68 "../src/font-manager/SearchProvider.vala"
		_g_free0 (_tmp6_);
#line 68 "../src/font-manager/SearchProvider.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 68 "../src/font-manager/SearchProvider.vala"
			_g_object_unref0 (db);
#line 815 "SearchProvider.c"
			goto __catch0_g_error;
		}
		{
			FontManagerDatabaseIterator* _row_it = NULL;
			FontManagerDatabase* _tmp7_;
			FontManagerDatabaseIterator* _tmp8_;
#line 69 "../src/font-manager/SearchProvider.vala"
			_tmp7_ = db;
#line 69 "../src/font-manager/SearchProvider.vala"
			_tmp8_ = font_manager_database_iterator (_tmp7_);
#line 69 "../src/font-manager/SearchProvider.vala"
			_row_it = _tmp8_;
#line 69 "../src/font-manager/SearchProvider.vala"
			while (TRUE) {
#line 830 "SearchProvider.c"
				FontManagerDatabaseIterator* _tmp9_;
				sqlite3_stmt* row = NULL;
				FontManagerDatabaseIterator* _tmp10_;
				sqlite3_stmt* _tmp11_;
				sqlite3_stmt* _tmp12_;
				const gchar* _tmp13_;
				sqlite3_stmt* _tmp14_;
				sqlite3_stmt* _tmp15_;
				const gchar* _tmp16_;
				sqlite3_stmt* _tmp17_;
				const gchar* _tmp18_;
				gchar* _tmp19_;
#line 69 "../src/font-manager/SearchProvider.vala"
				_tmp9_ = _row_it;
#line 69 "../src/font-manager/SearchProvider.vala"
				if (!font_manager_database_iterator_next (_tmp9_)) {
#line 69 "../src/font-manager/SearchProvider.vala"
					break;
#line 849 "SearchProvider.c"
				}
#line 69 "../src/font-manager/SearchProvider.vala"
				_tmp10_ = _row_it;
#line 69 "../src/font-manager/SearchProvider.vala"
				_tmp11_ = font_manager_database_iterator_get (_tmp10_);
#line 69 "../src/font-manager/SearchProvider.vala"
				row = _tmp11_;
#line 70 "../src/font-manager/SearchProvider.vala"
				_tmp12_ = row;
#line 70 "../src/font-manager/SearchProvider.vala"
				_tmp13_ = (const gchar*) sqlite3_column_text (_tmp12_, (gint) FONT_MANAGER_SEARCH_PROVIDER_ID_FILEPATH);
#line 70 "../src/font-manager/SearchProvider.vala"
				_tmp14_ = row;
#line 70 "../src/font-manager/SearchProvider.vala"
				_tmp15_ = row;
#line 70 "../src/font-manager/SearchProvider.vala"
				_tmp16_ = (const gchar*) sqlite3_column_text (_tmp15_, (gint) FONT_MANAGER_SEARCH_PROVIDER_ID_FAMILY);
#line 70 "../src/font-manager/SearchProvider.vala"
				_tmp17_ = row;
#line 70 "../src/font-manager/SearchProvider.vala"
				_tmp18_ = (const gchar*) sqlite3_column_text (_tmp17_, (gint) FONT_MANAGER_SEARCH_PROVIDER_ID_STYLE);
#line 70 "../src/font-manager/SearchProvider.vala"
				_tmp19_ = g_strdup_printf ("%s::%i::%s::%s", _tmp13_, sqlite3_column_int (_tmp14_, (gint) FONT_MANAGER_SEARCH_PROVIDER_ID_INDEX), _tmp16_, _tmp18_);
#line 70 "../src/font-manager/SearchProvider.vala"
				_vala_array_add2 (&result_set, &result_set_length1, &_result_set_size_, _tmp19_);
#line 875 "SearchProvider.c"
			}
#line 69 "../src/font-manager/SearchProvider.vala"
			_g_object_unref0 (_row_it);
#line 879 "SearchProvider.c"
		}
#line 74 "../src/font-manager/SearchProvider.vala"
		_tmp20_ = db;
#line 74 "../src/font-manager/SearchProvider.vala"
		font_manager_database_end_query (_tmp20_);
#line 66 "../src/font-manager/SearchProvider.vala"
		_g_object_unref0 (db);
#line 887 "SearchProvider.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp21_;
		const gchar* _tmp22_;
#line 66 "../src/font-manager/SearchProvider.vala"
		e = _inner_error0_;
#line 66 "../src/font-manager/SearchProvider.vala"
		_inner_error0_ = NULL;
#line 76 "../src/font-manager/SearchProvider.vala"
		_tmp21_ = e;
#line 76 "../src/font-manager/SearchProvider.vala"
		_tmp22_ = _tmp21_->message;
#line 76 "../src/font-manager/SearchProvider.vala"
		g_warning ("SearchProvider.vala:76: %s", _tmp22_);
#line 66 "../src/font-manager/SearchProvider.vala"
		_g_error_free0 (e);
#line 907 "SearchProvider.c"
	}
	__finally0:
#line 66 "../src/font-manager/SearchProvider.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 66 "../src/font-manager/SearchProvider.vala"
		_g_free0 (search_term);
#line 66 "../src/font-manager/SearchProvider.vala"
		result_set = (_vala_array_free (result_set, result_set_length1, (GDestroyNotify) g_free), NULL);
#line 66 "../src/font-manager/SearchProvider.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 66 "../src/font-manager/SearchProvider.vala"
		g_clear_error (&_inner_error0_);
#line 66 "../src/font-manager/SearchProvider.vala"
		return NULL;
#line 922 "SearchProvider.c"
	}
#line 78 "../src/font-manager/SearchProvider.vala"
	_tmp23_ = result_set;
#line 78 "../src/font-manager/SearchProvider.vala"
	_tmp23__length1 = result_set_length1;
#line 78 "../src/font-manager/SearchProvider.vala"
	if (result_length1) {
#line 78 "../src/font-manager/SearchProvider.vala"
		*result_length1 = _tmp23__length1;
#line 932 "SearchProvider.c"
	}
#line 78 "../src/font-manager/SearchProvider.vala"
	result = _tmp23_;
#line 78 "../src/font-manager/SearchProvider.vala"
	_g_free0 (search_term);
#line 78 "../src/font-manager/SearchProvider.vala"
	return result;
#line 940 "SearchProvider.c"
}

static void
font_manager_search_provider_get_initial_result_set_data_free (gpointer _data)
{
	FontManagerSearchProviderGetInitialResultSetData* _data_;
	_data_ = _data;
#line 24 "../src/font-manager/SearchProvider.vala"
	_data_->result = (_vala_array_free (_data_->result, _data_->result_length1, (GDestroyNotify) g_free), NULL);
#line 24 "../src/font-manager/SearchProvider.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/font-manager/SearchProvider.vala"
	g_slice_free (FontManagerSearchProviderGetInitialResultSetData, _data_);
#line 954 "SearchProvider.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 24 "../src/font-manager/SearchProvider.vala"
	return self ? g_object_ref (self) : NULL;
#line 962 "SearchProvider.c"
}

void
font_manager_search_provider_get_initial_result_set (FontManagerSearchProvider* self,
                                                     gchar** terms,
                                                     gint terms_length1,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	FontManagerSearchProviderGetInitialResultSetData* _data_;
	FontManagerSearchProvider* _tmp0_;
#line 24 "../src/font-manager/SearchProvider.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/font-manager/SearchProvider.vala"
	_data_ = g_slice_new0 (FontManagerSearchProviderGetInitialResultSetData);
#line 24 "../src/font-manager/SearchProvider.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 24 "../src/font-manager/SearchProvider.vala"
	g_task_set_task_data (_data_->_async_result, _data_, font_manager_search_provider_get_initial_result_set_data_free);
#line 24 "../src/font-manager/SearchProvider.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/font-manager/SearchProvider.vala"
	_data_->self = _tmp0_;
#line 24 "../src/font-manager/SearchProvider.vala"
	_data_->terms = terms;
#line 24 "../src/font-manager/SearchProvider.vala"
	_data_->terms_length1 = terms_length1;
#line 24 "../src/font-manager/SearchProvider.vala"
	font_manager_search_provider_get_initial_result_set_co (_data_);
#line 992 "SearchProvider.c"
}

gchar**
font_manager_search_provider_get_initial_result_set_finish (FontManagerSearchProvider* self,
                                                            GAsyncResult* _res_,
                                                            gint* result_length1,
                                                            GError** error)
{
	gchar** result;
	FontManagerSearchProviderGetInitialResultSetData* _data_;
#line 24 "../src/font-manager/SearchProvider.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/font-manager/SearchProvider.vala"
	if (NULL == _data_) {
#line 24 "../src/font-manager/SearchProvider.vala"
		return NULL;
#line 1009 "SearchProvider.c"
	}
#line 24 "../src/font-manager/SearchProvider.vala"
	result = _data_->result;
#line 24 "../src/font-manager/SearchProvider.vala"
	*result_length1 = _data_->result_length1;
#line 24 "../src/font-manager/SearchProvider.vala"
	_data_->result = NULL;
#line 24 "../src/font-manager/SearchProvider.vala"
	return result;
#line 1019 "SearchProvider.c"
}

static gboolean
font_manager_search_provider_get_initial_result_set_co (FontManagerSearchProviderGetInitialResultSetData* _data_)
{
#line 83 "../src/font-manager/SearchProvider.vala"
	switch (_data_->_state_) {
#line 83 "../src/font-manager/SearchProvider.vala"
		case 0:
#line 1029 "SearchProvider.c"
		goto _state_0;
		default:
#line 83 "../src/font-manager/SearchProvider.vala"
		g_assert_not_reached ();
#line 1034 "SearchProvider.c"
	}
	_state_0:
#line 85 "../src/font-manager/SearchProvider.vala"
	_data_->_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 85 "../src/font-manager/SearchProvider.vala"
	_data_->result_set = _data_->_tmp0_;
#line 85 "../src/font-manager/SearchProvider.vala"
	_data_->result_set_length1 = 0;
#line 85 "../src/font-manager/SearchProvider.vala"
	_data_->_result_set_size_ = _data_->result_set_length1;
#line 86 "../src/font-manager/SearchProvider.vala"
	_data_->_tmp1_ = _data_->result_set;
#line 86 "../src/font-manager/SearchProvider.vala"
	_data_->_tmp1__length1 = _data_->result_set_length1;
#line 86 "../src/font-manager/SearchProvider.vala"
	_data_->result_length1 = _data_->_tmp1__length1;
#line 86 "../src/font-manager/SearchProvider.vala"
	_data_->result = _data_->_tmp1_;
#line 86 "../src/font-manager/SearchProvider.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 86 "../src/font-manager/SearchProvider.vala"
	if (_data_->_state_ != 0) {
#line 86 "../src/font-manager/SearchProvider.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 86 "../src/font-manager/SearchProvider.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1061 "SearchProvider.c"
		}
	}
#line 86 "../src/font-manager/SearchProvider.vala"
	g_object_unref (_data_->_async_result);
#line 86 "../src/font-manager/SearchProvider.vala"
	return FALSE;
#line 1068 "SearchProvider.c"
}

static void
font_manager_search_provider_get_subsearch_result_set_data_free (gpointer _data)
{
	FontManagerSearchProviderGetSubsearchResultSetData* _data_;
	_data_ = _data;
#line 24 "../src/font-manager/SearchProvider.vala"
	_data_->result = (_vala_array_free (_data_->result, _data_->result_length1, (GDestroyNotify) g_free), NULL);
#line 24 "../src/font-manager/SearchProvider.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/font-manager/SearchProvider.vala"
	g_slice_free (FontManagerSearchProviderGetSubsearchResultSetData, _data_);
#line 1082 "SearchProvider.c"
}

void
font_manager_search_provider_get_subsearch_result_set (FontManagerSearchProvider* self,
                                                       gchar** previous_results,
                                                       gint previous_results_length1,
                                                       gchar** terms,
                                                       gint terms_length1,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_)
{
	FontManagerSearchProviderGetSubsearchResultSetData* _data_;
	FontManagerSearchProvider* _tmp0_;
#line 24 "../src/font-manager/SearchProvider.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/font-manager/SearchProvider.vala"
	_data_ = g_slice_new0 (FontManagerSearchProviderGetSubsearchResultSetData);
#line 24 "../src/font-manager/SearchProvider.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 24 "../src/font-manager/SearchProvider.vala"
	g_task_set_task_data (_data_->_async_result, _data_, font_manager_search_provider_get_subsearch_result_set_data_free);
#line 24 "../src/font-manager/SearchProvider.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/font-manager/SearchProvider.vala"
	_data_->self = _tmp0_;
#line 24 "../src/font-manager/SearchProvider.vala"
	_data_->previous_results = previous_results;
#line 24 "../src/font-manager/SearchProvider.vala"
	_data_->previous_results_length1 = previous_results_length1;
#line 24 "../src/font-manager/SearchProvider.vala"
	_data_->terms = terms;
#line 24 "../src/font-manager/SearchProvider.vala"
	_data_->terms_length1 = terms_length1;
#line 24 "../src/font-manager/SearchProvider.vala"
	font_manager_search_provider_get_subsearch_result_set_co (_data_);
#line 1118 "SearchProvider.c"
}

gchar**
font_manager_search_provider_get_subsearch_result_set_finish (FontManagerSearchProvider* self,
                                                              GAsyncResult* _res_,
                                                              gint* result_length1,
                                                              GError** error)
{
	gchar** result;
	FontManagerSearchProviderGetSubsearchResultSetData* _data_;
#line 24 "../src/font-manager/SearchProvider.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/font-manager/SearchProvider.vala"
	if (NULL == _data_) {
#line 24 "../src/font-manager/SearchProvider.vala"
		return NULL;
#line 1135 "SearchProvider.c"
	}
#line 24 "../src/font-manager/SearchProvider.vala"
	result = _data_->result;
#line 24 "../src/font-manager/SearchProvider.vala"
	*result_length1 = _data_->result_length1;
#line 24 "../src/font-manager/SearchProvider.vala"
	_data_->result = NULL;
#line 24 "../src/font-manager/SearchProvider.vala"
	return result;
#line 1145 "SearchProvider.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1167 "SearchProvider.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1171 "SearchProvider.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1177 "SearchProvider.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1181 "SearchProvider.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1185 "SearchProvider.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 1193 "SearchProvider.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1221 "SearchProvider.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 1230 "SearchProvider.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1244 "SearchProvider.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 1253 "SearchProvider.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 1267 "SearchProvider.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1276 "SearchProvider.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 1285 "SearchProvider.c"
}

static gboolean
font_manager_search_provider_get_subsearch_result_set_co (FontManagerSearchProviderGetSubsearchResultSetData* _data_)
{
#line 91 "../src/font-manager/SearchProvider.vala"
	switch (_data_->_state_) {
#line 91 "../src/font-manager/SearchProvider.vala"
		case 0:
#line 1295 "SearchProvider.c"
		goto _state_0;
		default:
#line 91 "../src/font-manager/SearchProvider.vala"
		g_assert_not_reached ();
#line 1300 "SearchProvider.c"
	}
	_state_0:
#line 93 "../src/font-manager/SearchProvider.vala"
	_data_->_tmp0_ = _data_->terms[0];
#line 93 "../src/font-manager/SearchProvider.vala"
	if (g_str_has_prefix (_data_->_tmp0_, G_SEARCHPATH_SEPARATOR_S)) {
#line 94 "../src/font-manager/SearchProvider.vala"
		_data_->_tmp1_ = _data_->terms[0];
#line 94 "../src/font-manager/SearchProvider.vala"
		_data_->_tmp2_ = string_replace (_data_->_tmp1_, G_SEARCHPATH_SEPARATOR_S, "");
#line 94 "../src/font-manager/SearchProvider.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 94 "../src/font-manager/SearchProvider.vala"
		_data_->_tmp4_ = 0;
#line 94 "../src/font-manager/SearchProvider.vala"
		_data_->_tmp5_ = font_manager_search_provider_character_search (_data_->self, _data_->_tmp3_, &_data_->_tmp4_);
#line 94 "../src/font-manager/SearchProvider.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 94 "../src/font-manager/SearchProvider.vala"
		_data_->_tmp6__length1 = _data_->_tmp4_;
#line 94 "../src/font-manager/SearchProvider.vala"
		_g_free0 (_data_->_tmp3_);
#line 94 "../src/font-manager/SearchProvider.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 94 "../src/font-manager/SearchProvider.vala"
		_data_->_tmp7__length1 = _data_->_tmp6__length1;
#line 94 "../src/font-manager/SearchProvider.vala"
		_data_->result_length1 = _data_->_tmp7__length1;
#line 94 "../src/font-manager/SearchProvider.vala"
		_data_->result = _data_->_tmp7_;
#line 94 "../src/font-manager/SearchProvider.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 94 "../src/font-manager/SearchProvider.vala"
		if (_data_->_state_ != 0) {
#line 94 "../src/font-manager/SearchProvider.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 94 "../src/font-manager/SearchProvider.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1339 "SearchProvider.c"
			}
		}
#line 94 "../src/font-manager/SearchProvider.vala"
		g_object_unref (_data_->_async_result);
#line 94 "../src/font-manager/SearchProvider.vala"
		return FALSE;
#line 1346 "SearchProvider.c"
	} else {
#line 96 "../src/font-manager/SearchProvider.vala"
		_data_->_tmp8_ = 0;
#line 96 "../src/font-manager/SearchProvider.vala"
		_data_->_tmp9_ = font_manager_search_provider_database_search (_data_->self, _data_->terms, (gint) _data_->terms_length1, &_data_->_tmp8_);
#line 96 "../src/font-manager/SearchProvider.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 96 "../src/font-manager/SearchProvider.vala"
		_data_->_tmp10__length1 = _data_->_tmp8_;
#line 96 "../src/font-manager/SearchProvider.vala"
		_data_->result_length1 = _data_->_tmp10__length1;
#line 96 "../src/font-manager/SearchProvider.vala"
		_data_->result = _data_->_tmp10_;
#line 96 "../src/font-manager/SearchProvider.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 96 "../src/font-manager/SearchProvider.vala"
		if (_data_->_state_ != 0) {
#line 96 "../src/font-manager/SearchProvider.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 96 "../src/font-manager/SearchProvider.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1368 "SearchProvider.c"
			}
		}
#line 96 "../src/font-manager/SearchProvider.vala"
		g_object_unref (_data_->_async_result);
#line 96 "../src/font-manager/SearchProvider.vala"
		return FALSE;
#line 1375 "SearchProvider.c"
	}
}

static void
_g_hash_table_unref0_ (gpointer var)
{
#line 101 "../src/font-manager/SearchProvider.vala"
	(var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL));
#line 1384 "SearchProvider.c"
}

static void
_g_free0_ (gpointer var)
{
#line 104 "../src/font-manager/SearchProvider.vala"
	var = (g_free (var), NULL);
#line 1392 "SearchProvider.c"
}

static void
_g_variant_unref0_ (gpointer var)
{
#line 104 "../src/font-manager/SearchProvider.vala"
	(var == NULL) ? NULL : (var = (g_variant_unref (var), NULL));
#line 1400 "SearchProvider.c"
}

static GVariant*
_variant_new1 (gchar* value)
{
#line 105 "../src/font-manager/SearchProvider.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 1408 "SearchProvider.c"
}

static GVariant*
_variant_new2 (const gchar* value)
{
#line 106 "../src/font-manager/SearchProvider.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 1416 "SearchProvider.c"
}

static GVariant*
_variant_new3 (const gchar* value)
{
#line 107 "../src/font-manager/SearchProvider.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 1424 "SearchProvider.c"
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
#line 108 "../src/font-manager/SearchProvider.vala"
	return self ? g_hash_table_ref (self) : NULL;
#line 1432 "SearchProvider.c"
}

static GHashTable**
_vala_array_dup2 (GHashTable** self,
                  gssize length)
{
#line 110 "../src/font-manager/SearchProvider.vala"
	if (length >= 0) {
#line 1441 "SearchProvider.c"
		GHashTable** result;
		gssize i;
#line 110 "../src/font-manager/SearchProvider.vala"
		result = g_new0 (GHashTable*, length + 1);
#line 110 "../src/font-manager/SearchProvider.vala"
		for (i = 0; i < length; i++) {
#line 1448 "SearchProvider.c"
			GHashTable* _tmp0_;
#line 110 "../src/font-manager/SearchProvider.vala"
			_tmp0_ = _g_hash_table_ref0 (self[i]);
#line 110 "../src/font-manager/SearchProvider.vala"
			result[i] = _tmp0_;
#line 1454 "SearchProvider.c"
		}
#line 110 "../src/font-manager/SearchProvider.vala"
		return result;
#line 1458 "SearchProvider.c"
	}
#line 110 "../src/font-manager/SearchProvider.vala"
	return NULL;
#line 1462 "SearchProvider.c"
}

GHashTable**
font_manager_search_provider_get_result_metas (FontManagerSearchProvider* self,
                                               gchar** results,
                                               gint results_length1,
                                               gint* result_length1,
                                               GError** error)
{
	GPtrArray* metas = NULL;
	GPtrArray* _tmp0_;
	GPtrArray* _tmp30_;
	gpointer* _tmp31_;
	gint _tmp31__length1;
	GHashTable** _tmp32_;
	gint _tmp32__length1;
	GHashTable** _tmp33_;
	gint _tmp33__length1;
	GHashTable** result;
#line 99 "../src/font-manager/SearchProvider.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 101 "../src/font-manager/SearchProvider.vala"
	_tmp0_ = g_ptr_array_new_full ((guint) 0, _g_hash_table_unref0_);
#line 101 "../src/font-manager/SearchProvider.vala"
	metas = _tmp0_;
#line 1488 "SearchProvider.c"
	{
		gchar** entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
#line 102 "../src/font-manager/SearchProvider.vala"
		entry_collection = results;
#line 102 "../src/font-manager/SearchProvider.vala"
		entry_collection_length1 = results_length1;
#line 102 "../src/font-manager/SearchProvider.vala"
		for (entry_it = 0; entry_it < entry_collection_length1; entry_it = entry_it + 1) {
#line 1500 "SearchProvider.c"
			gchar* _tmp1_;
			gchar* entry = NULL;
#line 102 "../src/font-manager/SearchProvider.vala"
			_tmp1_ = g_strdup (entry_collection[entry_it]);
#line 102 "../src/font-manager/SearchProvider.vala"
			entry = _tmp1_;
#line 1507 "SearchProvider.c"
			{
				gchar** data = NULL;
				const gchar* _tmp2_;
				gchar** _tmp3_;
				gchar** _tmp4_;
				gint data_length1;
				gint _data_size_;
				GHashTable* meta = NULL;
				GHashFunc _tmp5_;
				GEqualFunc _tmp6_;
				GHashTable* _tmp7_;
				GHashTable* _tmp8_;
				gchar* _tmp9_;
				gchar** _tmp10_;
				gint _tmp10__length1;
				const gchar* _tmp11_;
				gchar** _tmp12_;
				gint _tmp12__length1;
				const gchar* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
				GVariant* _tmp16_;
				GHashTable* _tmp17_;
				gchar* _tmp18_;
				gchar** _tmp19_;
				gint _tmp19__length1;
				const gchar* _tmp20_;
				GVariant* _tmp21_;
				GHashTable* _tmp22_;
				gchar* _tmp23_;
				gchar** _tmp24_;
				gint _tmp24__length1;
				const gchar* _tmp25_;
				GVariant* _tmp26_;
				GPtrArray* _tmp27_;
				GHashTable* _tmp28_;
				GHashTable* _tmp29_;
#line 103 "../src/font-manager/SearchProvider.vala"
				_tmp2_ = entry;
#line 103 "../src/font-manager/SearchProvider.vala"
				_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, "::", 0);
#line 103 "../src/font-manager/SearchProvider.vala"
				data = _tmp4_;
#line 103 "../src/font-manager/SearchProvider.vala"
				data_length1 = _vala_array_length (_tmp3_);
#line 103 "../src/font-manager/SearchProvider.vala"
				_data_size_ = data_length1;
#line 104 "../src/font-manager/SearchProvider.vala"
				_tmp5_ = g_str_hash;
#line 104 "../src/font-manager/SearchProvider.vala"
				_tmp6_ = g_str_equal;
#line 104 "../src/font-manager/SearchProvider.vala"
				_tmp7_ = g_hash_table_new_full (_tmp5_, _tmp6_, _g_free0_, _g_variant_unref0_);
#line 104 "../src/font-manager/SearchProvider.vala"
				meta = _tmp7_;
#line 105 "../src/font-manager/SearchProvider.vala"
				_tmp8_ = meta;
#line 105 "../src/font-manager/SearchProvider.vala"
				_tmp9_ = g_strdup ("id");
#line 105 "../src/font-manager/SearchProvider.vala"
				_tmp10_ = data;
#line 105 "../src/font-manager/SearchProvider.vala"
				_tmp10__length1 = data_length1;
#line 105 "../src/font-manager/SearchProvider.vala"
				_tmp11_ = _tmp10_[FONT_MANAGER_SEARCH_PROVIDER_ID_FILEPATH];
#line 105 "../src/font-manager/SearchProvider.vala"
				_tmp12_ = data;
#line 105 "../src/font-manager/SearchProvider.vala"
				_tmp12__length1 = data_length1;
#line 105 "../src/font-manager/SearchProvider.vala"
				_tmp13_ = _tmp12_[FONT_MANAGER_SEARCH_PROVIDER_ID_INDEX];
#line 105 "../src/font-manager/SearchProvider.vala"
				_tmp14_ = g_strdup_printf ("%s::%s", _tmp11_, _tmp13_);
#line 105 "../src/font-manager/SearchProvider.vala"
				_tmp15_ = _tmp14_;
#line 105 "../src/font-manager/SearchProvider.vala"
				_tmp16_ = _variant_new1 (_tmp15_);
#line 105 "../src/font-manager/SearchProvider.vala"
				g_hash_table_insert (_tmp8_, _tmp9_, _tmp16_);
#line 105 "../src/font-manager/SearchProvider.vala"
				_g_free0 (_tmp15_);
#line 106 "../src/font-manager/SearchProvider.vala"
				_tmp17_ = meta;
#line 106 "../src/font-manager/SearchProvider.vala"
				_tmp18_ = g_strdup ("name");
#line 106 "../src/font-manager/SearchProvider.vala"
				_tmp19_ = data;
#line 106 "../src/font-manager/SearchProvider.vala"
				_tmp19__length1 = data_length1;
#line 106 "../src/font-manager/SearchProvider.vala"
				_tmp20_ = _tmp19_[FONT_MANAGER_SEARCH_PROVIDER_ID_FAMILY];
#line 106 "../src/font-manager/SearchProvider.vala"
				_tmp21_ = _variant_new2 (_tmp20_);
#line 106 "../src/font-manager/SearchProvider.vala"
				g_hash_table_insert (_tmp17_, _tmp18_, _tmp21_);
#line 107 "../src/font-manager/SearchProvider.vala"
				_tmp22_ = meta;
#line 107 "../src/font-manager/SearchProvider.vala"
				_tmp23_ = g_strdup ("description");
#line 107 "../src/font-manager/SearchProvider.vala"
				_tmp24_ = data;
#line 107 "../src/font-manager/SearchProvider.vala"
				_tmp24__length1 = data_length1;
#line 107 "../src/font-manager/SearchProvider.vala"
				_tmp25_ = _tmp24_[FONT_MANAGER_SEARCH_PROVIDER_ID_STYLE];
#line 107 "../src/font-manager/SearchProvider.vala"
				_tmp26_ = _variant_new3 (_tmp25_);
#line 107 "../src/font-manager/SearchProvider.vala"
				g_hash_table_insert (_tmp22_, _tmp23_, _tmp26_);
#line 108 "../src/font-manager/SearchProvider.vala"
				_tmp27_ = metas;
#line 108 "../src/font-manager/SearchProvider.vala"
				_tmp28_ = meta;
#line 108 "../src/font-manager/SearchProvider.vala"
				_tmp29_ = _g_hash_table_ref0 (_tmp28_);
#line 108 "../src/font-manager/SearchProvider.vala"
				g_ptr_array_add (_tmp27_, _tmp29_);
#line 102 "../src/font-manager/SearchProvider.vala"
				_g_hash_table_unref0 (meta);
#line 102 "../src/font-manager/SearchProvider.vala"
				data = (_vala_array_free (data, data_length1, (GDestroyNotify) g_free), NULL);
#line 102 "../src/font-manager/SearchProvider.vala"
				_g_free0 (entry);
#line 1631 "SearchProvider.c"
			}
		}
	}
#line 110 "../src/font-manager/SearchProvider.vala"
	_tmp30_ = metas;
#line 110 "../src/font-manager/SearchProvider.vala"
	_tmp31_ = _tmp30_->pdata;
#line 110 "../src/font-manager/SearchProvider.vala"
	_tmp31__length1 = _tmp30_->len;
#line 110 "../src/font-manager/SearchProvider.vala"
	_tmp32_ = (_tmp31_ != NULL) ? _vala_array_dup2 (_tmp31_, _tmp31__length1) : _tmp31_;
#line 110 "../src/font-manager/SearchProvider.vala"
	_tmp32__length1 = _tmp31__length1;
#line 110 "../src/font-manager/SearchProvider.vala"
	_tmp33_ = _tmp32_;
#line 110 "../src/font-manager/SearchProvider.vala"
	_tmp33__length1 = _tmp32__length1;
#line 110 "../src/font-manager/SearchProvider.vala"
	if (result_length1) {
#line 110 "../src/font-manager/SearchProvider.vala"
		*result_length1 = _tmp33__length1;
#line 1653 "SearchProvider.c"
	}
#line 110 "../src/font-manager/SearchProvider.vala"
	result = _tmp33_;
#line 110 "../src/font-manager/SearchProvider.vala"
	_g_ptr_array_unref0 (metas);
#line 110 "../src/font-manager/SearchProvider.vala"
	return result;
#line 1661 "SearchProvider.c"
}

void
font_manager_search_provider_activate_result (FontManagerSearchProvider* self,
                                              const gchar* _result_,
                                              gchar** terms,
                                              gint terms_length1,
                                              guint32 timestamp,
                                              GError** error)
{
	gchar** data = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint data_length1;
	gint _data_size_;
	GFile* file = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	gint findex = 0;
	const gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 114 "../src/font-manager/SearchProvider.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/font-manager/SearchProvider.vala"
	g_return_if_fail (_result_ != NULL);
#line 116 "../src/font-manager/SearchProvider.vala"
	_tmp1_ = _tmp0_ = g_strsplit (_result_, "::", 0);
#line 116 "../src/font-manager/SearchProvider.vala"
	data = _tmp1_;
#line 116 "../src/font-manager/SearchProvider.vala"
	data_length1 = _vala_array_length (_tmp0_);
#line 116 "../src/font-manager/SearchProvider.vala"
	_data_size_ = data_length1;
#line 117 "../src/font-manager/SearchProvider.vala"
	_tmp2_ = data[FONT_MANAGER_SEARCH_PROVIDER_ID_FILEPATH];
#line 117 "../src/font-manager/SearchProvider.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 117 "../src/font-manager/SearchProvider.vala"
	file = _tmp3_;
#line 118 "../src/font-manager/SearchProvider.vala"
	_tmp4_ = data[FONT_MANAGER_SEARCH_PROVIDER_ID_INDEX];
#line 118 "../src/font-manager/SearchProvider.vala"
	findex = atoi (_tmp4_);
#line 1705 "SearchProvider.c"
	{
		GDBusConnection* conn = NULL;
		GDBusConnection* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		GVariant* _tmp8_;
		GVariant* _tmp9_;
#line 120 "../src/font-manager/SearchProvider.vala"
		_tmp5_ = g_bus_get_sync (G_BUS_TYPE_SESSION, NULL, &_inner_error0_);
#line 120 "../src/font-manager/SearchProvider.vala"
		conn = _tmp5_;
#line 120 "../src/font-manager/SearchProvider.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1719 "SearchProvider.c"
			goto __catch0_g_error;
		}
#line 121 "../src/font-manager/SearchProvider.vala"
		_tmp6_ = g_file_get_uri (file);
#line 121 "../src/font-manager/SearchProvider.vala"
		_tmp7_ = _tmp6_;
#line 121 "../src/font-manager/SearchProvider.vala"
		_tmp8_ = g_variant_new ("(si)", _tmp7_, findex, NULL);
#line 121 "../src/font-manager/SearchProvider.vala"
		g_variant_ref_sink (_tmp8_);
#line 121 "../src/font-manager/SearchProvider.vala"
		_tmp9_ = _tmp8_;
#line 121 "../src/font-manager/SearchProvider.vala"
		g_dbus_connection_call (conn, FONT_MANAGER_FONT_VIEWER_BUS_ID, FONT_MANAGER_FONT_VIEWER_BUS_PATH, FONT_MANAGER_FONT_VIEWER_BUS_ID, "ShowUri", _tmp9_, NULL, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL, NULL);
#line 121 "../src/font-manager/SearchProvider.vala"
		_g_variant_unref0 (_tmp9_);
#line 121 "../src/font-manager/SearchProvider.vala"
		_g_free0 (_tmp7_);
#line 119 "../src/font-manager/SearchProvider.vala"
		_g_object_unref0 (conn);
#line 1740 "SearchProvider.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 119 "../src/font-manager/SearchProvider.vala"
		e = _inner_error0_;
#line 119 "../src/font-manager/SearchProvider.vala"
		_inner_error0_ = NULL;
#line 132 "../src/font-manager/SearchProvider.vala"
		_tmp10_ = e;
#line 132 "../src/font-manager/SearchProvider.vala"
		_tmp11_ = _tmp10_->message;
#line 132 "../src/font-manager/SearchProvider.vala"
		g_critical ("SearchProvider.vala:132: Method call to %s failed : %s", FONT_MANAGER_FONT_VIEWER_BUS_ID, _tmp11_);
#line 119 "../src/font-manager/SearchProvider.vala"
		_g_error_free0 (e);
#line 1760 "SearchProvider.c"
	}
	__finally0:
#line 119 "../src/font-manager/SearchProvider.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 119 "../src/font-manager/SearchProvider.vala"
		if ((_inner_error0_->domain == G_DBUS_ERROR) || (_inner_error0_->domain == G_IO_ERROR)) {
#line 119 "../src/font-manager/SearchProvider.vala"
			g_propagate_error (error, _inner_error0_);
#line 119 "../src/font-manager/SearchProvider.vala"
			_g_object_unref0 (file);
#line 119 "../src/font-manager/SearchProvider.vala"
			data = (_vala_array_free (data, data_length1, (GDestroyNotify) g_free), NULL);
#line 119 "../src/font-manager/SearchProvider.vala"
			return;
#line 1775 "SearchProvider.c"
		} else {
#line 119 "../src/font-manager/SearchProvider.vala"
			_g_object_unref0 (file);
#line 119 "../src/font-manager/SearchProvider.vala"
			data = (_vala_array_free (data, data_length1, (GDestroyNotify) g_free), NULL);
#line 119 "../src/font-manager/SearchProvider.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 119 "../src/font-manager/SearchProvider.vala"
			g_clear_error (&_inner_error0_);
#line 119 "../src/font-manager/SearchProvider.vala"
			return;
#line 1787 "SearchProvider.c"
		}
	}
#line 134 "../src/font-manager/SearchProvider.vala"
	_g_object_unref0 (file);
#line 134 "../src/font-manager/SearchProvider.vala"
	data = (_vala_array_free (data, data_length1, (GDestroyNotify) g_free), NULL);
#line 134 "../src/font-manager/SearchProvider.vala"
	return;
#line 1796 "SearchProvider.c"
}

void
font_manager_search_provider_launch_search (FontManagerSearchProvider* self,
                                            gchar** terms,
                                            gint terms_length1,
                                            guint32 timestamp,
                                            GError** error)
{
	gchar* search_term = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 137 "../src/font-manager/SearchProvider.vala"
	g_return_if_fail (self != NULL);
#line 139 "../src/font-manager/SearchProvider.vala"
	_tmp0_ = font_manager_search_provider_get_search_term (self, terms, (gint) terms_length1);
#line 139 "../src/font-manager/SearchProvider.vala"
	search_term = _tmp0_;
#line 1815 "SearchProvider.c"
	{
		GDBusConnection* conn = NULL;
		GDBusConnection* _tmp1_;
		GVariant* _tmp2_;
		GVariant* _tmp3_;
#line 141 "../src/font-manager/SearchProvider.vala"
		_tmp1_ = g_bus_get_sync (G_BUS_TYPE_SESSION, NULL, &_inner_error0_);
#line 141 "../src/font-manager/SearchProvider.vala"
		conn = _tmp1_;
#line 141 "../src/font-manager/SearchProvider.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1827 "SearchProvider.c"
			goto __catch0_g_error;
		}
#line 142 "../src/font-manager/SearchProvider.vala"
		_tmp2_ = g_variant_new ("(s)", search_term, NULL);
#line 142 "../src/font-manager/SearchProvider.vala"
		g_variant_ref_sink (_tmp2_);
#line 142 "../src/font-manager/SearchProvider.vala"
		_tmp3_ = _tmp2_;
#line 142 "../src/font-manager/SearchProvider.vala"
		g_dbus_connection_call (conn, FONT_MANAGER_BUS_ID, FONT_MANAGER_BUS_PATH, FONT_MANAGER_BUS_ID, "Search", _tmp3_, NULL, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL, NULL);
#line 142 "../src/font-manager/SearchProvider.vala"
		_g_variant_unref0 (_tmp3_);
#line 140 "../src/font-manager/SearchProvider.vala"
		_g_object_unref0 (conn);
#line 1842 "SearchProvider.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 140 "../src/font-manager/SearchProvider.vala"
		e = _inner_error0_;
#line 140 "../src/font-manager/SearchProvider.vala"
		_inner_error0_ = NULL;
#line 153 "../src/font-manager/SearchProvider.vala"
		_tmp4_ = e;
#line 153 "../src/font-manager/SearchProvider.vala"
		_tmp5_ = _tmp4_->message;
#line 153 "../src/font-manager/SearchProvider.vala"
		g_critical ("SearchProvider.vala:153: Method call to %s failed : %s", FONT_MANAGER_BUS_ID, _tmp5_);
#line 140 "../src/font-manager/SearchProvider.vala"
		_g_error_free0 (e);
#line 1862 "SearchProvider.c"
	}
	__finally0:
#line 140 "../src/font-manager/SearchProvider.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 140 "../src/font-manager/SearchProvider.vala"
		if ((_inner_error0_->domain == G_DBUS_ERROR) || (_inner_error0_->domain == G_IO_ERROR)) {
#line 140 "../src/font-manager/SearchProvider.vala"
			g_propagate_error (error, _inner_error0_);
#line 140 "../src/font-manager/SearchProvider.vala"
			_g_free0 (search_term);
#line 140 "../src/font-manager/SearchProvider.vala"
			return;
#line 1875 "SearchProvider.c"
		} else {
#line 140 "../src/font-manager/SearchProvider.vala"
			_g_free0 (search_term);
#line 140 "../src/font-manager/SearchProvider.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 140 "../src/font-manager/SearchProvider.vala"
			g_clear_error (&_inner_error0_);
#line 140 "../src/font-manager/SearchProvider.vala"
			return;
#line 1885 "SearchProvider.c"
		}
	}
#line 155 "../src/font-manager/SearchProvider.vala"
	_g_free0 (search_term);
#line 155 "../src/font-manager/SearchProvider.vala"
	return;
#line 1892 "SearchProvider.c"
}

void
font_manager_search_provider_dbus_register (FontManagerSearchProvider* self,
                                            GDBusConnection* conn)
{
	GError* _inner_error0_ = NULL;
#line 159 "../src/font-manager/SearchProvider.vala"
	g_return_if_fail (self != NULL);
#line 159 "../src/font-manager/SearchProvider.vala"
	g_return_if_fail (conn != NULL);
#line 1904 "SearchProvider.c"
	{
		guint _tmp0_ = 0U;
		guint _tmp1_;
#line 161 "../src/font-manager/SearchProvider.vala"
		_tmp1_ = font_manager_search_provider_register_object (self, conn, FONT_MANAGER_SEARCH_PROVIDER_SEARCH_PROVIDER_BUS_PATH, &_inner_error0_);
#line 161 "../src/font-manager/SearchProvider.vala"
		_tmp0_ = _tmp1_;
#line 161 "../src/font-manager/SearchProvider.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1914 "SearchProvider.c"
			goto __catch0_g_error;
		}
#line 161 "../src/font-manager/SearchProvider.vala"
		self->priv->dbus_id = _tmp0_;
#line 1919 "SearchProvider.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 160 "../src/font-manager/SearchProvider.vala"
		e = _inner_error0_;
#line 160 "../src/font-manager/SearchProvider.vala"
		_inner_error0_ = NULL;
#line 163 "../src/font-manager/SearchProvider.vala"
		_tmp2_ = e;
#line 163 "../src/font-manager/SearchProvider.vala"
		_tmp3_ = _tmp2_->message;
#line 163 "../src/font-manager/SearchProvider.vala"
		g_warning ("SearchProvider.vala:163: Failed to register gnome shell search provide" \
"r : %s", _tmp3_);
#line 160 "../src/font-manager/SearchProvider.vala"
		_g_error_free0 (e);
#line 1939 "SearchProvider.c"
	}
	__finally0:
#line 160 "../src/font-manager/SearchProvider.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 160 "../src/font-manager/SearchProvider.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 160 "../src/font-manager/SearchProvider.vala"
		g_clear_error (&_inner_error0_);
#line 160 "../src/font-manager/SearchProvider.vala"
		return;
#line 1950 "SearchProvider.c"
	}
#line 165 "../src/font-manager/SearchProvider.vala"
	return;
#line 1954 "SearchProvider.c"
}

void
font_manager_search_provider_dbus_unregister (FontManagerSearchProvider* self,
                                              GDBusConnection* conn)
{
#line 169 "../src/font-manager/SearchProvider.vala"
	g_return_if_fail (self != NULL);
#line 169 "../src/font-manager/SearchProvider.vala"
	g_return_if_fail (conn != NULL);
#line 170 "../src/font-manager/SearchProvider.vala"
	if (self->priv->dbus_id != ((guint) 0)) {
#line 171 "../src/font-manager/SearchProvider.vala"
		g_dbus_connection_unregister_object (conn, self->priv->dbus_id);
#line 1969 "SearchProvider.c"
	}
#line 172 "../src/font-manager/SearchProvider.vala"
	return;
#line 1973 "SearchProvider.c"
}

FontManagerSearchProvider*
font_manager_search_provider_construct (GType object_type)
{
	FontManagerSearchProvider * self = NULL;
#line 24 "../src/font-manager/SearchProvider.vala"
	self = (FontManagerSearchProvider*) g_object_new (object_type, NULL);
#line 24 "../src/font-manager/SearchProvider.vala"
	return self;
#line 1984 "SearchProvider.c"
}

FontManagerSearchProvider*
font_manager_search_provider_new (void)
{
#line 24 "../src/font-manager/SearchProvider.vala"
	return font_manager_search_provider_construct (FONT_MANAGER_TYPE_SEARCH_PROVIDER);
#line 1992 "SearchProvider.c"
}

static void
font_manager_search_provider_class_init (FontManagerSearchProviderClass * klass,
                                         gpointer klass_data)
{
#line 24 "../src/font-manager/SearchProvider.vala"
	font_manager_search_provider_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/font-manager/SearchProvider.vala"
	g_type_class_adjust_private_offset (klass, &FontManagerSearchProvider_private_offset);
#line 24 "../src/font-manager/SearchProvider.vala"
	G_OBJECT_CLASS (klass)->finalize = font_manager_search_provider_finalize;
#line 2005 "SearchProvider.c"
}

static void
font_manager_search_provider_instance_init (FontManagerSearchProvider * self,
                                            gpointer klass)
{
#line 24 "../src/font-manager/SearchProvider.vala"
	self->priv = font_manager_search_provider_get_instance_private (self);
#line 26 "../src/font-manager/SearchProvider.vala"
	self->priv->dbus_id = (guint) 0;
#line 2016 "SearchProvider.c"
}

static void
font_manager_search_provider_finalize (GObject * obj)
{
	FontManagerSearchProvider * self;
#line 24 "../src/font-manager/SearchProvider.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_SEARCH_PROVIDER, FontManagerSearchProvider);
#line 24 "../src/font-manager/SearchProvider.vala"
	G_OBJECT_CLASS (font_manager_search_provider_parent_class)->finalize (obj);
#line 2027 "SearchProvider.c"
}

 G_GNUC_NO_INLINE static GType
font_manager_search_provider_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerSearchProviderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_search_provider_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerSearchProvider), 0, (GInstanceInitFunc) font_manager_search_provider_instance_init, NULL };
	GType font_manager_search_provider_type_id;
	font_manager_search_provider_type_id = g_type_register_static (G_TYPE_OBJECT, "FontManagerSearchProvider", &g_define_type_info, 0);
	g_type_set_qdata (font_manager_search_provider_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) font_manager_search_provider_register_object);
	FontManagerSearchProvider_private_offset = g_type_add_instance_private (font_manager_search_provider_type_id, sizeof (FontManagerSearchProviderPrivate));
	return font_manager_search_provider_type_id;
}

GType
font_manager_search_provider_get_type (void)
{
	static volatile gsize font_manager_search_provider_type_id__once = 0;
	if (g_once_init_enter (&font_manager_search_provider_type_id__once)) {
		GType font_manager_search_provider_type_id;
		font_manager_search_provider_type_id = font_manager_search_provider_get_type_once ();
		g_once_init_leave (&font_manager_search_provider_type_id__once, font_manager_search_provider_type_id);
	}
	return font_manager_search_provider_type_id__once;
}

static void
_dbus_font_manager_search_provider_get_initial_result_set (FontManagerSearchProvider* self,
                                                           GVariant* _parameters_,
                                                           GDBusMethodInvocation* invocation)
{
	GVariantIter _arguments_iter;
	FontManagerSearchProviderGetInitialResultSetReadyData* _ready_data;
	GVariant* _tmp54_;
	gchar** _tmp55_;
	gint _tmp55__length;
	gint _tmp55__size;
	gint _tmp55__length1;
	GVariantIter _tmp56_;
	GVariant* _tmp57_;
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_iter_init (&_arguments_iter, _parameters_);
#line 69 "../src/font-manager/FontModel.vala"
	_ready_data = g_slice_new0 (FontManagerSearchProviderGetInitialResultSetReadyData);
#line 69 "../src/font-manager/FontModel.vala"
	_ready_data->_invocation_ = invocation;
#line 69 "../src/font-manager/FontModel.vala"
	_tmp54_ = g_variant_iter_next_value (&_arguments_iter);
#line 2075 "SearchProvider.c"
	_tmp55_ = g_new (gchar*, 5);
	_tmp55__length = 0;
	_tmp55__size = 4;
	_tmp55__length1 = 0;
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_iter_init (&_tmp56_, _tmp54_);
#line 69 "../src/font-manager/FontModel.vala"
	for (; (_tmp57_ = g_variant_iter_next_value (&_tmp56_)) != NULL; _tmp55__length1++) {
#line 69 "../src/font-manager/FontModel.vala"
		if (_tmp55__size == _tmp55__length) {
#line 69 "../src/font-manager/FontModel.vala"
			_tmp55__size = 2 * _tmp55__size;
#line 69 "../src/font-manager/FontModel.vala"
			_tmp55_ = g_renew (gchar*, _tmp55_, _tmp55__size + 1);
#line 2090 "SearchProvider.c"
		}
#line 69 "../src/font-manager/FontModel.vala"
		_tmp55_[_tmp55__length++] = g_variant_dup_string (_tmp57_, NULL);
#line 69 "../src/font-manager/FontModel.vala"
		g_variant_unref (_tmp57_);
#line 2096 "SearchProvider.c"
	}
#line 69 "../src/font-manager/FontModel.vala"
	_ready_data->terms_length1 = _tmp55__length1;
#line 69 "../src/font-manager/FontModel.vala"
	_tmp55_[_tmp55__length] = NULL;
#line 69 "../src/font-manager/FontModel.vala"
	_ready_data->terms = _tmp55_;
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_unref (_tmp54_);
#line 69 "../src/font-manager/FontModel.vala"
	font_manager_search_provider_get_initial_result_set (self, _ready_data->terms, _ready_data->terms_length1, (GAsyncReadyCallback) _dbus_font_manager_search_provider_get_initial_result_set_ready, _ready_data);
#line 2108 "SearchProvider.c"
	_error:
	;
}

static void
_dbus_font_manager_search_provider_get_initial_result_set_ready (GObject * source_object,
                                                                 GAsyncResult * _res_,
                                                                 gpointer _user_data_)
{
	FontManagerSearchProviderGetInitialResultSetReadyData* _ready_data;
	GDBusMethodInvocation* invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar** result;
	gint result_length1 = 0;
	gchar** _tmp58_;
	GVariantBuilder _tmp59_;
	gint _tmp60_;
	_ready_data = _user_data_;
	invocation = _ready_data->_invocation_;
#line 69 "../src/font-manager/FontModel.vala"
	result = font_manager_search_provider_get_initial_result_set_finish ((FontManagerSearchProvider*) source_object, _res_, &result_length1, &error);
#line 69 "../src/font-manager/FontModel.vala"
	if (error) {
#line 69 "../src/font-manager/FontModel.vala"
		g_dbus_method_invocation_take_error (invocation, error);
#line 2137 "SearchProvider.c"
		goto _error;
	}
#line 69 "../src/font-manager/FontModel.vala"
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
#line 69 "../src/font-manager/FontModel.vala"
	_tmp58_ = result;
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_builder_init (&_tmp59_, G_VARIANT_TYPE ("as"));
#line 69 "../src/font-manager/FontModel.vala"
	for (_tmp60_ = 0; _tmp60_ < result_length1; _tmp60_++) {
#line 69 "../src/font-manager/FontModel.vala"
		g_variant_builder_add_value (&_tmp59_, g_variant_new_string (*_tmp58_));
#line 69 "../src/font-manager/FontModel.vala"
		_tmp58_++;
#line 2154 "SearchProvider.c"
	}
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp59_));
#line 69 "../src/font-manager/FontModel.vala"
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
#line 69 "../src/font-manager/FontModel.vala"
	_reply = g_variant_builder_end (&_reply_builder);
#line 69 "../src/font-manager/FontModel.vala"
	g_dbus_message_set_body (_reply_message, _reply);
#line 69 "../src/font-manager/FontModel.vala"
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
#line 69 "../src/font-manager/FontModel.vala"
	g_object_unref (invocation);
#line 69 "../src/font-manager/FontModel.vala"
	g_object_unref (_reply_message);
#line 2170 "SearchProvider.c"
	_error:
#line 69 "../src/font-manager/FontModel.vala"
	_ready_data->terms = (_vala_array_free (_ready_data->terms, _ready_data->terms_length1, (GDestroyNotify) g_free), NULL);
#line 69 "../src/font-manager/FontModel.vala"
	g_slice_free (FontManagerSearchProviderGetInitialResultSetReadyData, _ready_data);
#line 2176 "SearchProvider.c"
}

static void
_dbus_font_manager_search_provider_get_subsearch_result_set (FontManagerSearchProvider* self,
                                                             GVariant* _parameters_,
                                                             GDBusMethodInvocation* invocation)
{
	GVariantIter _arguments_iter;
	FontManagerSearchProviderGetSubsearchResultSetReadyData* _ready_data;
	GVariant* _tmp61_;
	gchar** _tmp62_;
	gint _tmp62__length;
	gint _tmp62__size;
	gint _tmp62__length1;
	GVariantIter _tmp63_;
	GVariant* _tmp64_;
	GVariant* _tmp65_;
	gchar** _tmp66_;
	gint _tmp66__length;
	gint _tmp66__size;
	gint _tmp66__length1;
	GVariantIter _tmp67_;
	GVariant* _tmp68_;
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_iter_init (&_arguments_iter, _parameters_);
#line 69 "../src/font-manager/FontModel.vala"
	_ready_data = g_slice_new0 (FontManagerSearchProviderGetSubsearchResultSetReadyData);
#line 69 "../src/font-manager/FontModel.vala"
	_ready_data->_invocation_ = invocation;
#line 69 "../src/font-manager/FontModel.vala"
	_tmp61_ = g_variant_iter_next_value (&_arguments_iter);
#line 2208 "SearchProvider.c"
	_tmp62_ = g_new (gchar*, 5);
	_tmp62__length = 0;
	_tmp62__size = 4;
	_tmp62__length1 = 0;
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_iter_init (&_tmp63_, _tmp61_);
#line 69 "../src/font-manager/FontModel.vala"
	for (; (_tmp64_ = g_variant_iter_next_value (&_tmp63_)) != NULL; _tmp62__length1++) {
#line 69 "../src/font-manager/FontModel.vala"
		if (_tmp62__size == _tmp62__length) {
#line 69 "../src/font-manager/FontModel.vala"
			_tmp62__size = 2 * _tmp62__size;
#line 69 "../src/font-manager/FontModel.vala"
			_tmp62_ = g_renew (gchar*, _tmp62_, _tmp62__size + 1);
#line 2223 "SearchProvider.c"
		}
#line 69 "../src/font-manager/FontModel.vala"
		_tmp62_[_tmp62__length++] = g_variant_dup_string (_tmp64_, NULL);
#line 69 "../src/font-manager/FontModel.vala"
		g_variant_unref (_tmp64_);
#line 2229 "SearchProvider.c"
	}
#line 69 "../src/font-manager/FontModel.vala"
	_ready_data->previous_results_length1 = _tmp62__length1;
#line 69 "../src/font-manager/FontModel.vala"
	_tmp62_[_tmp62__length] = NULL;
#line 69 "../src/font-manager/FontModel.vala"
	_ready_data->previous_results = _tmp62_;
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_unref (_tmp61_);
#line 69 "../src/font-manager/FontModel.vala"
	_tmp65_ = g_variant_iter_next_value (&_arguments_iter);
#line 2241 "SearchProvider.c"
	_tmp66_ = g_new (gchar*, 5);
	_tmp66__length = 0;
	_tmp66__size = 4;
	_tmp66__length1 = 0;
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_iter_init (&_tmp67_, _tmp65_);
#line 69 "../src/font-manager/FontModel.vala"
	for (; (_tmp68_ = g_variant_iter_next_value (&_tmp67_)) != NULL; _tmp66__length1++) {
#line 69 "../src/font-manager/FontModel.vala"
		if (_tmp66__size == _tmp66__length) {
#line 69 "../src/font-manager/FontModel.vala"
			_tmp66__size = 2 * _tmp66__size;
#line 69 "../src/font-manager/FontModel.vala"
			_tmp66_ = g_renew (gchar*, _tmp66_, _tmp66__size + 1);
#line 2256 "SearchProvider.c"
		}
#line 69 "../src/font-manager/FontModel.vala"
		_tmp66_[_tmp66__length++] = g_variant_dup_string (_tmp68_, NULL);
#line 69 "../src/font-manager/FontModel.vala"
		g_variant_unref (_tmp68_);
#line 2262 "SearchProvider.c"
	}
#line 69 "../src/font-manager/FontModel.vala"
	_ready_data->terms_length1 = _tmp66__length1;
#line 69 "../src/font-manager/FontModel.vala"
	_tmp66_[_tmp66__length] = NULL;
#line 69 "../src/font-manager/FontModel.vala"
	_ready_data->terms = _tmp66_;
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_unref (_tmp65_);
#line 69 "../src/font-manager/FontModel.vala"
	font_manager_search_provider_get_subsearch_result_set (self, _ready_data->previous_results, _ready_data->previous_results_length1, _ready_data->terms, _ready_data->terms_length1, (GAsyncReadyCallback) _dbus_font_manager_search_provider_get_subsearch_result_set_ready, _ready_data);
#line 2274 "SearchProvider.c"
	_error:
	;
}

static void
_dbus_font_manager_search_provider_get_subsearch_result_set_ready (GObject * source_object,
                                                                   GAsyncResult * _res_,
                                                                   gpointer _user_data_)
{
	FontManagerSearchProviderGetSubsearchResultSetReadyData* _ready_data;
	GDBusMethodInvocation* invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar** result;
	gint result_length1 = 0;
	gchar** _tmp69_;
	GVariantBuilder _tmp70_;
	gint _tmp71_;
	_ready_data = _user_data_;
	invocation = _ready_data->_invocation_;
#line 69 "../src/font-manager/FontModel.vala"
	result = font_manager_search_provider_get_subsearch_result_set_finish ((FontManagerSearchProvider*) source_object, _res_, &result_length1, &error);
#line 69 "../src/font-manager/FontModel.vala"
	if (error) {
#line 69 "../src/font-manager/FontModel.vala"
		g_dbus_method_invocation_take_error (invocation, error);
#line 2303 "SearchProvider.c"
		goto _error;
	}
#line 69 "../src/font-manager/FontModel.vala"
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
#line 69 "../src/font-manager/FontModel.vala"
	_tmp69_ = result;
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_builder_init (&_tmp70_, G_VARIANT_TYPE ("as"));
#line 69 "../src/font-manager/FontModel.vala"
	for (_tmp71_ = 0; _tmp71_ < result_length1; _tmp71_++) {
#line 69 "../src/font-manager/FontModel.vala"
		g_variant_builder_add_value (&_tmp70_, g_variant_new_string (*_tmp69_));
#line 69 "../src/font-manager/FontModel.vala"
		_tmp69_++;
#line 2320 "SearchProvider.c"
	}
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp70_));
#line 69 "../src/font-manager/FontModel.vala"
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
#line 69 "../src/font-manager/FontModel.vala"
	_reply = g_variant_builder_end (&_reply_builder);
#line 69 "../src/font-manager/FontModel.vala"
	g_dbus_message_set_body (_reply_message, _reply);
#line 69 "../src/font-manager/FontModel.vala"
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
#line 69 "../src/font-manager/FontModel.vala"
	g_object_unref (invocation);
#line 69 "../src/font-manager/FontModel.vala"
	g_object_unref (_reply_message);
#line 2336 "SearchProvider.c"
	_error:
#line 69 "../src/font-manager/FontModel.vala"
	_ready_data->previous_results = (_vala_array_free (_ready_data->previous_results, _ready_data->previous_results_length1, (GDestroyNotify) g_free), NULL);
#line 69 "../src/font-manager/FontModel.vala"
	_ready_data->terms = (_vala_array_free (_ready_data->terms, _ready_data->terms_length1, (GDestroyNotify) g_free), NULL);
#line 69 "../src/font-manager/FontModel.vala"
	g_slice_free (FontManagerSearchProviderGetSubsearchResultSetReadyData, _ready_data);
#line 2344 "SearchProvider.c"
}

static void
_dbus_font_manager_search_provider_get_result_metas (FontManagerSearchProvider* self,
                                                     GVariant* _parameters_,
                                                     GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar** results = NULL;
	gint results_length1 = 0;
	GVariant* _tmp72_;
	gchar** _tmp73_;
	gint _tmp73__length;
	gint _tmp73__size;
	gint _tmp73__length1;
	GVariantIter _tmp74_;
	GVariant* _tmp75_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	GHashTable** result;
	gint result_length1 = 0;
	GHashTable** _tmp76_;
	GVariantBuilder _tmp77_;
	gint _tmp78_;
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_iter_init (&_arguments_iter, _parameters_);
#line 69 "../src/font-manager/FontModel.vala"
	_tmp72_ = g_variant_iter_next_value (&_arguments_iter);
#line 2375 "SearchProvider.c"
	_tmp73_ = g_new (gchar*, 5);
	_tmp73__length = 0;
	_tmp73__size = 4;
	_tmp73__length1 = 0;
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_iter_init (&_tmp74_, _tmp72_);
#line 69 "../src/font-manager/FontModel.vala"
	for (; (_tmp75_ = g_variant_iter_next_value (&_tmp74_)) != NULL; _tmp73__length1++) {
#line 69 "../src/font-manager/FontModel.vala"
		if (_tmp73__size == _tmp73__length) {
#line 69 "../src/font-manager/FontModel.vala"
			_tmp73__size = 2 * _tmp73__size;
#line 69 "../src/font-manager/FontModel.vala"
			_tmp73_ = g_renew (gchar*, _tmp73_, _tmp73__size + 1);
#line 2390 "SearchProvider.c"
		}
#line 69 "../src/font-manager/FontModel.vala"
		_tmp73_[_tmp73__length++] = g_variant_dup_string (_tmp75_, NULL);
#line 69 "../src/font-manager/FontModel.vala"
		g_variant_unref (_tmp75_);
#line 2396 "SearchProvider.c"
	}
#line 69 "../src/font-manager/FontModel.vala"
	results_length1 = _tmp73__length1;
#line 69 "../src/font-manager/FontModel.vala"
	_tmp73_[_tmp73__length] = NULL;
#line 69 "../src/font-manager/FontModel.vala"
	results = _tmp73_;
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_unref (_tmp72_);
#line 69 "../src/font-manager/FontModel.vala"
	result = font_manager_search_provider_get_result_metas (self, results, results_length1, &result_length1, &error);
#line 69 "../src/font-manager/FontModel.vala"
	if (error) {
#line 69 "../src/font-manager/FontModel.vala"
		g_dbus_method_invocation_take_error (invocation, error);
#line 2412 "SearchProvider.c"
		goto _error;
	}
#line 69 "../src/font-manager/FontModel.vala"
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
#line 69 "../src/font-manager/FontModel.vala"
	_tmp76_ = result;
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_builder_init (&_tmp77_, G_VARIANT_TYPE ("aa{sv}"));
#line 69 "../src/font-manager/FontModel.vala"
	for (_tmp78_ = 0; _tmp78_ < result_length1; _tmp78_++) {
#line 2425 "SearchProvider.c"
		GVariantBuilder _tmp79_;
		GHashTableIter _tmp80_;
		gpointer _tmp81_;
		gpointer _tmp82_;
#line 69 "../src/font-manager/FontModel.vala"
		g_hash_table_iter_init (&_tmp80_, *_tmp76_);
#line 69 "../src/font-manager/FontModel.vala"
		g_variant_builder_init (&_tmp79_, G_VARIANT_TYPE ("a{sv}"));
#line 69 "../src/font-manager/FontModel.vala"
		while (g_hash_table_iter_next (&_tmp80_, &_tmp81_, &_tmp82_)) {
#line 2436 "SearchProvider.c"
			gchar* _key;
			GVariant* _value;
#line 69 "../src/font-manager/FontModel.vala"
			_key = (gchar*) _tmp81_;
#line 69 "../src/font-manager/FontModel.vala"
			_value = (GVariant*) _tmp82_;
#line 69 "../src/font-manager/FontModel.vala"
			g_variant_builder_add (&_tmp79_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
#line 2445 "SearchProvider.c"
		}
#line 69 "../src/font-manager/FontModel.vala"
		g_variant_builder_add_value (&_tmp77_, g_variant_builder_end (&_tmp79_));
#line 69 "../src/font-manager/FontModel.vala"
		_tmp76_++;
#line 2451 "SearchProvider.c"
	}
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp77_));
#line 69 "../src/font-manager/FontModel.vala"
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_hash_table_unref), NULL);
#line 69 "../src/font-manager/FontModel.vala"
	_reply = g_variant_builder_end (&_reply_builder);
#line 69 "../src/font-manager/FontModel.vala"
	g_dbus_message_set_body (_reply_message, _reply);
#line 69 "../src/font-manager/FontModel.vala"
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
#line 69 "../src/font-manager/FontModel.vala"
	g_object_unref (invocation);
#line 69 "../src/font-manager/FontModel.vala"
	g_object_unref (_reply_message);
#line 2467 "SearchProvider.c"
	_error:
#line 69 "../src/font-manager/FontModel.vala"
	results = (_vala_array_free (results, results_length1, (GDestroyNotify) g_free), NULL);
#line 2471 "SearchProvider.c"
	;
}

static void
_dbus_font_manager_search_provider_activate_result (FontManagerSearchProvider* self,
                                                    GVariant* _parameters_,
                                                    GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* _result_ = NULL;
	GVariant* _tmp83_;
	gchar** terms = NULL;
	gint terms_length1 = 0;
	GVariant* _tmp84_;
	gchar** _tmp85_;
	gint _tmp85__length;
	gint _tmp85__size;
	gint _tmp85__length1;
	GVariantIter _tmp86_;
	GVariant* _tmp87_;
	guint32 timestamp = 0U;
	GVariant* _tmp88_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_iter_init (&_arguments_iter, _parameters_);
#line 69 "../src/font-manager/FontModel.vala"
	_tmp83_ = g_variant_iter_next_value (&_arguments_iter);
#line 69 "../src/font-manager/FontModel.vala"
	_result_ = g_variant_dup_string (_tmp83_, NULL);
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_unref (_tmp83_);
#line 69 "../src/font-manager/FontModel.vala"
	_tmp84_ = g_variant_iter_next_value (&_arguments_iter);
#line 2508 "SearchProvider.c"
	_tmp85_ = g_new (gchar*, 5);
	_tmp85__length = 0;
	_tmp85__size = 4;
	_tmp85__length1 = 0;
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_iter_init (&_tmp86_, _tmp84_);
#line 69 "../src/font-manager/FontModel.vala"
	for (; (_tmp87_ = g_variant_iter_next_value (&_tmp86_)) != NULL; _tmp85__length1++) {
#line 69 "../src/font-manager/FontModel.vala"
		if (_tmp85__size == _tmp85__length) {
#line 69 "../src/font-manager/FontModel.vala"
			_tmp85__size = 2 * _tmp85__size;
#line 69 "../src/font-manager/FontModel.vala"
			_tmp85_ = g_renew (gchar*, _tmp85_, _tmp85__size + 1);
#line 2523 "SearchProvider.c"
		}
#line 69 "../src/font-manager/FontModel.vala"
		_tmp85_[_tmp85__length++] = g_variant_dup_string (_tmp87_, NULL);
#line 69 "../src/font-manager/FontModel.vala"
		g_variant_unref (_tmp87_);
#line 2529 "SearchProvider.c"
	}
#line 69 "../src/font-manager/FontModel.vala"
	terms_length1 = _tmp85__length1;
#line 69 "../src/font-manager/FontModel.vala"
	_tmp85_[_tmp85__length] = NULL;
#line 69 "../src/font-manager/FontModel.vala"
	terms = _tmp85_;
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_unref (_tmp84_);
#line 69 "../src/font-manager/FontModel.vala"
	_tmp88_ = g_variant_iter_next_value (&_arguments_iter);
#line 69 "../src/font-manager/FontModel.vala"
	timestamp = g_variant_get_uint32 (_tmp88_);
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_unref (_tmp88_);
#line 69 "../src/font-manager/FontModel.vala"
	font_manager_search_provider_activate_result (self, _result_, terms, terms_length1, timestamp, &error);
#line 69 "../src/font-manager/FontModel.vala"
	if (error) {
#line 69 "../src/font-manager/FontModel.vala"
		g_dbus_method_invocation_take_error (invocation, error);
#line 2551 "SearchProvider.c"
		goto _error;
	}
#line 69 "../src/font-manager/FontModel.vala"
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
#line 69 "../src/font-manager/FontModel.vala"
	_reply = g_variant_builder_end (&_reply_builder);
#line 69 "../src/font-manager/FontModel.vala"
	g_dbus_message_set_body (_reply_message, _reply);
#line 69 "../src/font-manager/FontModel.vala"
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
#line 69 "../src/font-manager/FontModel.vala"
	g_object_unref (invocation);
#line 69 "../src/font-manager/FontModel.vala"
	g_object_unref (_reply_message);
#line 2568 "SearchProvider.c"
	_error:
#line 69 "../src/font-manager/FontModel.vala"
	_g_free0 (_result_);
#line 69 "../src/font-manager/FontModel.vala"
	terms = (_vala_array_free (terms, terms_length1, (GDestroyNotify) g_free), NULL);
#line 2574 "SearchProvider.c"
	;
}

static void
_dbus_font_manager_search_provider_launch_search (FontManagerSearchProvider* self,
                                                  GVariant* _parameters_,
                                                  GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar** terms = NULL;
	gint terms_length1 = 0;
	GVariant* _tmp89_;
	gchar** _tmp90_;
	gint _tmp90__length;
	gint _tmp90__size;
	gint _tmp90__length1;
	GVariantIter _tmp91_;
	GVariant* _tmp92_;
	guint32 timestamp = 0U;
	GVariant* _tmp93_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_iter_init (&_arguments_iter, _parameters_);
#line 69 "../src/font-manager/FontModel.vala"
	_tmp89_ = g_variant_iter_next_value (&_arguments_iter);
#line 2603 "SearchProvider.c"
	_tmp90_ = g_new (gchar*, 5);
	_tmp90__length = 0;
	_tmp90__size = 4;
	_tmp90__length1 = 0;
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_iter_init (&_tmp91_, _tmp89_);
#line 69 "../src/font-manager/FontModel.vala"
	for (; (_tmp92_ = g_variant_iter_next_value (&_tmp91_)) != NULL; _tmp90__length1++) {
#line 69 "../src/font-manager/FontModel.vala"
		if (_tmp90__size == _tmp90__length) {
#line 69 "../src/font-manager/FontModel.vala"
			_tmp90__size = 2 * _tmp90__size;
#line 69 "../src/font-manager/FontModel.vala"
			_tmp90_ = g_renew (gchar*, _tmp90_, _tmp90__size + 1);
#line 2618 "SearchProvider.c"
		}
#line 69 "../src/font-manager/FontModel.vala"
		_tmp90_[_tmp90__length++] = g_variant_dup_string (_tmp92_, NULL);
#line 69 "../src/font-manager/FontModel.vala"
		g_variant_unref (_tmp92_);
#line 2624 "SearchProvider.c"
	}
#line 69 "../src/font-manager/FontModel.vala"
	terms_length1 = _tmp90__length1;
#line 69 "../src/font-manager/FontModel.vala"
	_tmp90_[_tmp90__length] = NULL;
#line 69 "../src/font-manager/FontModel.vala"
	terms = _tmp90_;
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_unref (_tmp89_);
#line 69 "../src/font-manager/FontModel.vala"
	_tmp93_ = g_variant_iter_next_value (&_arguments_iter);
#line 69 "../src/font-manager/FontModel.vala"
	timestamp = g_variant_get_uint32 (_tmp93_);
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_unref (_tmp93_);
#line 69 "../src/font-manager/FontModel.vala"
	font_manager_search_provider_launch_search (self, terms, terms_length1, timestamp, &error);
#line 69 "../src/font-manager/FontModel.vala"
	if (error) {
#line 69 "../src/font-manager/FontModel.vala"
		g_dbus_method_invocation_take_error (invocation, error);
#line 2646 "SearchProvider.c"
		goto _error;
	}
#line 69 "../src/font-manager/FontModel.vala"
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
#line 69 "../src/font-manager/FontModel.vala"
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
#line 69 "../src/font-manager/FontModel.vala"
	_reply = g_variant_builder_end (&_reply_builder);
#line 69 "../src/font-manager/FontModel.vala"
	g_dbus_message_set_body (_reply_message, _reply);
#line 69 "../src/font-manager/FontModel.vala"
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
#line 69 "../src/font-manager/FontModel.vala"
	g_object_unref (invocation);
#line 69 "../src/font-manager/FontModel.vala"
	g_object_unref (_reply_message);
#line 2663 "SearchProvider.c"
	_error:
#line 69 "../src/font-manager/FontModel.vala"
	terms = (_vala_array_free (terms, terms_length1, (GDestroyNotify) g_free), NULL);
#line 2667 "SearchProvider.c"
	;
}

static void
font_manager_search_provider_dbus_interface_method_call (GDBusConnection* connection,
                                                         const gchar* sender,
                                                         const gchar* object_path,
                                                         const gchar* interface_name,
                                                         const gchar* method_name,
                                                         GVariant* parameters,
                                                         GDBusMethodInvocation* invocation,
                                                         gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
#line 69 "../src/font-manager/FontModel.vala"
	if (strcmp (method_name, "GetInitialResultSet") == 0) {
#line 69 "../src/font-manager/FontModel.vala"
		_dbus_font_manager_search_provider_get_initial_result_set (object, parameters, invocation);
#line 2689 "SearchProvider.c"
	} else if (strcmp (method_name, "GetSubsearchResultSet") == 0) {
#line 69 "../src/font-manager/FontModel.vala"
		_dbus_font_manager_search_provider_get_subsearch_result_set (object, parameters, invocation);
#line 2693 "SearchProvider.c"
	} else if (strcmp (method_name, "GetResultMetas") == 0) {
#line 69 "../src/font-manager/FontModel.vala"
		_dbus_font_manager_search_provider_get_result_metas (object, parameters, invocation);
#line 2697 "SearchProvider.c"
	} else if (strcmp (method_name, "ActivateResult") == 0) {
#line 69 "../src/font-manager/FontModel.vala"
		_dbus_font_manager_search_provider_activate_result (object, parameters, invocation);
#line 2701 "SearchProvider.c"
	} else if (strcmp (method_name, "LaunchSearch") == 0) {
#line 69 "../src/font-manager/FontModel.vala"
		_dbus_font_manager_search_provider_launch_search (object, parameters, invocation);
#line 2705 "SearchProvider.c"
	} else {
#line 69 "../src/font-manager/FontModel.vala"
		g_object_unref (invocation);
#line 2709 "SearchProvider.c"
	}
}

static GVariant*
font_manager_search_provider_dbus_interface_get_property (GDBusConnection* connection,
                                                          const gchar* sender,
                                                          const gchar* object_path,
                                                          const gchar* interface_name,
                                                          const gchar* property_name,
                                                          GError** error,
                                                          gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
#line 69 "../src/font-manager/FontModel.vala"
	return NULL;
#line 2728 "SearchProvider.c"
}

static gboolean
font_manager_search_provider_dbus_interface_set_property (GDBusConnection* connection,
                                                          const gchar* sender,
                                                          const gchar* object_path,
                                                          const gchar* interface_name,
                                                          const gchar* property_name,
                                                          GVariant* value,
                                                          GError** error,
                                                          gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
#line 69 "../src/font-manager/FontModel.vala"
	return FALSE;
#line 2747 "SearchProvider.c"
}

guint
font_manager_search_provider_register_object (gpointer object,
                                              GDBusConnection* connection,
                                              const gchar* path,
                                              GError** error)
{
	guint result;
	gpointer *data;
#line 69 "../src/font-manager/FontModel.vala"
	data = g_new (gpointer, 3);
#line 69 "../src/font-manager/FontModel.vala"
	data[0] = g_object_ref (object);
#line 69 "../src/font-manager/FontModel.vala"
	data[1] = g_object_ref (connection);
#line 69 "../src/font-manager/FontModel.vala"
	data[2] = g_strdup (path);
#line 69 "../src/font-manager/FontModel.vala"
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_font_manager_search_provider_dbus_interface_info), &_font_manager_search_provider_dbus_interface_vtable, data, _font_manager_search_provider_unregister_object, error);
#line 69 "../src/font-manager/FontModel.vala"
	if (!result) {
#line 69 "../src/font-manager/FontModel.vala"
		return 0;
#line 2772 "SearchProvider.c"
	}
#line 69 "../src/font-manager/FontModel.vala"
	return result;
#line 2776 "SearchProvider.c"
}

static void
_font_manager_search_provider_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
#line 69 "../src/font-manager/FontModel.vala"
	g_object_unref (data[0]);
#line 69 "../src/font-manager/FontModel.vala"
	g_object_unref (data[1]);
#line 69 "../src/font-manager/FontModel.vala"
	g_free (data[2]);
#line 69 "../src/font-manager/FontModel.vala"
	g_free (data);
#line 2792 "SearchProvider.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 69 "../src/font-manager/FontModel.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 2802 "SearchProvider.c"
		gssize i;
#line 69 "../src/font-manager/FontModel.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 69 "../src/font-manager/FontModel.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 69 "../src/font-manager/FontModel.vala"
				destroy_func (((gpointer*) array)[i]);
#line 2810 "SearchProvider.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 69 "../src/font-manager/FontModel.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 69 "../src/font-manager/FontModel.vala"
	g_free (array);
#line 2825 "SearchProvider.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 69 "../src/font-manager/FontModel.vala"
	if (array) {
#line 69 "../src/font-manager/FontModel.vala"
		while (((gpointer*) array)[length]) {
#line 69 "../src/font-manager/FontModel.vala"
			length++;
#line 2839 "SearchProvider.c"
		}
	}
#line 69 "../src/font-manager/FontModel.vala"
	return length;
#line 2844 "SearchProvider.c"
}

