/* PreviewPage.c generated by valac 0.56.17, the Vala compiler
 * generated from PreviewPage.vala, do not modify */

/* PreviewPage.vala
 *
 * Copyright (C) 2020-2024 Jerry Casiano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 *
 * If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <webkit/webkit.h>
#include "config.h"
#include "font-manager.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <locale.h>

#define HEADER "\n" \
"<html dir=\"%s\">\n" \
"  <head>\n" \
"    <style>\n" \
"      body, textarea {\n" \
"        color: %s;\n" \
"        background-color: %s;\n" \
"      }\n" \
"      textarea {\n" \
"        width: 95%;\n" \
"        height: 95%;\n" \
"        resize: none;\n" \
"        wrap: soft;\n" \
"        -webkit-box-sizing: border-box;\n" \
"      }\n" \
"      .aligned {\n" \
"        text-align: %s;\n" \
"      }\n" \
"      .padded {\n" \
"        padding: 64px;\n" \
"      }\n" \
"      .bodyText {\n" \
"        margin: 12px 8px 12px 8px;\n" \
"        text-align: justify;\n" \
"      }\n" \
"      .previewText {\n" \
"        font-size: %.0lfpx;\n" \
"        font-family: %s, adobe-notdef;\n" \
"        font-style: %s;\n" \
"        font-weight: %i;\n" \
"      }\n" \
"      .noWrap {\n" \
"        overflow: visible;\n" \
"        white-space: nowrap;\n" \
"        display:block;\n" \
"        width:100%;\n" \
"      }\n" \
"      %s\n" \
"      @font-face {\n" \
"            font-family: 'adobe-notdef';\n" \
"            src:\n" \
"                url('https://github.com/adobe-fonts/adobe-notdef/blob/" \
"master/AND-Regular.ttf?raw=true')\n" \
"                format('truetype');\n" \
"      }\n" \
"    </style>\n" \
"  </head>\n" \
"  <script>\n" \
"    function onInput() {\n" \
"      document.title = document.getElementById(\"textArea\").value;\n" \
"    }\n" \
"  </script>\n" \
"  <body oncontextmenu=\"return false;\">\n" \
"    <div>\n"
#define WATERFALL_ROW "\n" \
"      <p id=\"%.0lf\" class=\"noWrap\">\n" \
"        <span style=\"font-family: monospace;font-size: 10px;\">%s</sp" \
"an>\n" \
"        <span class=\"previewText\" style=\"font-size:%.0lfpx;\">%s</s" \
"pan>\n" \
"      </p>\n"
#define BODY_TEXT "\n" \
"      <p class=\"bodyText\">\n" \
"        <span class=\"previewText\">%s</span>\n" \
"      </p>\n"
#define ACTIVE_PREVIEW "\n" \
"      <div class=\"aligned\">\n" \
"        <div class=\"padded\">\n" \
"          <p class=\"previewText\">%s</p>\n" \
"        </div>\n" \
"      </div>\n"
#define EDITABLE_PREVIEW "\n" \
"      <div class=\"aligned\">\n" \
"      <textarea class=\"previewText\" id=\"textArea\" oninput=\"onInpu" \
"t()\">%s</textarea>\n" \
"      </div>\n"
#define DEFAULT_ACTIVE_TEXT "\n" \
"            The quick brown fox jumps over the lazy dog.<br/>\n" \
"            ABCDEFGHIJKLMNOPQRSTUVWXYZ<br/>\n" \
"            abcdefghijklmnopqrstuvwxyz<br/>\n" \
"            1234567890.:,;(*!?')\n" \
"        "
#define FOOTER "\n    </div>\n  </body>\n</html>\n"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PAGE (font_manager_google_fonts_preview_page_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PAGE, FontManagerGoogleFontsPreviewPage))
#define FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PAGE, FontManagerGoogleFontsPreviewPageClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_PREVIEW_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PAGE))
#define FONT_MANAGER_GOOGLE_FONTS_IS_PREVIEW_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PAGE))
#define FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PAGE, FontManagerGoogleFontsPreviewPageClass))

typedef struct _FontManagerGoogleFontsPreviewPage FontManagerGoogleFontsPreviewPage;
typedef struct _FontManagerGoogleFontsPreviewPageClass FontManagerGoogleFontsPreviewPageClass;
typedef struct _FontManagerGoogleFontsPreviewPagePrivate FontManagerGoogleFontsPreviewPagePrivate;

#define FONT_MANAGER_TYPE_WATERFALL_SETTINGS (font_manager_waterfall_settings_get_type ())
#define FONT_MANAGER_WATERFALL_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_WATERFALL_SETTINGS, FontManagerWaterfallSettings))
#define FONT_MANAGER_WATERFALL_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_WATERFALL_SETTINGS, FontManagerWaterfallSettingsClass))
#define FONT_MANAGER_IS_WATERFALL_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_WATERFALL_SETTINGS))
#define FONT_MANAGER_IS_WATERFALL_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_WATERFALL_SETTINGS))
#define FONT_MANAGER_WATERFALL_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_WATERFALL_SETTINGS, FontManagerWaterfallSettingsClass))

typedef struct _FontManagerWaterfallSettings FontManagerWaterfallSettings;
typedef struct _FontManagerWaterfallSettingsClass FontManagerWaterfallSettingsClass;

#define FONT_MANAGER_TYPE_PREVIEW_COLORS (font_manager_preview_colors_get_type ())
#define FONT_MANAGER_PREVIEW_COLORS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_PREVIEW_COLORS, FontManagerPreviewColors))
#define FONT_MANAGER_PREVIEW_COLORS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_PREVIEW_COLORS, FontManagerPreviewColorsClass))
#define FONT_MANAGER_IS_PREVIEW_COLORS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_PREVIEW_COLORS))
#define FONT_MANAGER_IS_PREVIEW_COLORS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_PREVIEW_COLORS))
#define FONT_MANAGER_PREVIEW_COLORS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_PREVIEW_COLORS, FontManagerPreviewColorsClass))

typedef struct _FontManagerPreviewColors FontManagerPreviewColors;
typedef struct _FontManagerPreviewColorsClass FontManagerPreviewColorsClass;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT (font_manager_google_fonts_font_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_FONT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFont))
#define FONT_MANAGER_GOOGLE_FONTS_FONT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFontClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FONT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FONT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT))
#define FONT_MANAGER_GOOGLE_FONTS_FONT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFontClass))

typedef struct _FontManagerGoogleFontsFont FontManagerGoogleFontsFont;
typedef struct _FontManagerGoogleFontsFontClass FontManagerGoogleFontsFontClass;

#define FONT_MANAGER_TYPE_PREVIEW_ENTRY (font_manager_preview_entry_get_type ())
#define FONT_MANAGER_PREVIEW_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_PREVIEW_ENTRY, FontManagerPreviewEntry))
#define FONT_MANAGER_PREVIEW_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_PREVIEW_ENTRY, FontManagerPreviewEntryClass))
#define FONT_MANAGER_IS_PREVIEW_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_PREVIEW_ENTRY))
#define FONT_MANAGER_IS_PREVIEW_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_PREVIEW_ENTRY))
#define FONT_MANAGER_PREVIEW_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_PREVIEW_ENTRY, FontManagerPreviewEntryClass))

typedef struct _FontManagerPreviewEntry FontManagerPreviewEntry;
typedef struct _FontManagerPreviewEntryClass FontManagerPreviewEntryClass;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST (font_manager_google_fonts_sample_list_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST, FontManagerGoogleFontsSampleList))
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST, FontManagerGoogleFontsSampleListClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_SAMPLE_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST))
#define FONT_MANAGER_GOOGLE_FONTS_IS_SAMPLE_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST))
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST, FontManagerGoogleFontsSampleListClass))

typedef struct _FontManagerGoogleFontsSampleList FontManagerGoogleFontsSampleList;
typedef struct _FontManagerGoogleFontsSampleListClass FontManagerGoogleFontsSampleListClass;
enum  {
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_0_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREDEFINED_SIZE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SHOW_LINE_SIZE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_SIZE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MIN_WATERFALL_SIZE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MAX_WATERFALL_SIZE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SIZE_RATIO_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SELECTED_ITEM_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_JUSTIFICATION_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_MODE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SETTINGS_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_TEXT_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_NUM_PROPERTIES
};
static GParamSpec* font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY (font_manager_google_fonts_family_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_FAMILY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamily))
#define FONT_MANAGER_GOOGLE_FONTS_FAMILY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamilyClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FAMILY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FAMILY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY))
#define FONT_MANAGER_GOOGLE_FONTS_FAMILY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamilyClass))

typedef struct _FontManagerGoogleFontsFamily FontManagerGoogleFontsFamily;
typedef struct _FontManagerGoogleFontsFamilyClass FontManagerGoogleFontsFamilyClass;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL (font_manager_google_fonts_sample_model_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL, FontManagerGoogleFontsSampleModel))
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL, FontManagerGoogleFontsSampleModelClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_SAMPLE_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL))
#define FONT_MANAGER_GOOGLE_FONTS_IS_SAMPLE_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL))
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL, FontManagerGoogleFontsSampleModelClass))

typedef struct _FontManagerGoogleFontsSampleModel FontManagerGoogleFontsSampleModel;
typedef struct _FontManagerGoogleFontsSampleModelClass FontManagerGoogleFontsSampleModelClass;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FontManagerGoogleFontsPreviewPage {
	GtkBox parent_instance;
	FontManagerGoogleFontsPreviewPagePrivate * priv;
};

struct _FontManagerGoogleFontsPreviewPageClass {
	GtkBoxClass parent_class;
};

struct _FontManagerGoogleFontsPreviewPagePrivate {
	gint _predefined_size;
	gboolean _show_line_size;
	gdouble _preview_size;
	gdouble _min_waterfall_size;
	gdouble _max_waterfall_size;
	gdouble _waterfall_size_ratio;
	GObject* _selected_item;
	GtkJustification _justification;
	FontManagerPreviewPageMode _preview_mode;
	FontManagerWaterfallSettings* _waterfall_settings;
	gchar* _preview_text;
	gchar* waterfall_body;
	gchar* active_preview_text;
	gchar* default_pangram;
	GtkCenterBox* controls;
	GtkMenuButton* menu_button;
	GtkMenuButton* sample_button;
	FontManagerPreviewColors* preview_colors;
	FontManagerGoogleFontsFont* font;
	FontManagerFontScale* fontscale;
	FontManagerPreviewEntry* entry;
	FontManagerPreviewControls* preview_controls;
	FontManagerGoogleFontsSampleList* samples;
	GdkRectangle clicked_area;
	WebKitWebView* webview;
	GtkRevealer* controls_revealer;
	GtkRevealer* fontscale_revealer;
	gchar** requires_reload;
	gint requires_reload_length1;
	gint _requires_reload_size_;
	gchar** affects_waterfall;
	gint affects_waterfall_length1;
	gint _affects_waterfall_size_;
};

static gint FontManagerGoogleFontsPreviewPage_private_offset;
static gpointer font_manager_google_fonts_preview_page_parent_class = NULL;

VALA_EXTERN WebKitWebView* font_manager_google_fonts_create_webview (void);
VALA_EXTERN GType font_manager_google_fonts_preview_page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsPreviewPage, g_object_unref)
VALA_EXTERN GType font_manager_waterfall_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerWaterfallSettings, g_object_unref)
VALA_EXTERN GType font_manager_preview_colors_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerPreviewColors, g_object_unref)
VALA_EXTERN GType font_manager_google_fonts_font_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsFont, g_object_unref)
VALA_EXTERN GType font_manager_preview_entry_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerPreviewEntry, g_object_unref)
VALA_EXTERN GType font_manager_google_fonts_sample_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsSampleList, g_object_unref)
VALA_EXTERN FontManagerGoogleFontsPreviewPage* font_manager_google_fonts_preview_page_new (void);
VALA_EXTERN FontManagerGoogleFontsPreviewPage* font_manager_google_fonts_preview_page_construct (GType object_type);
VALA_EXTERN FontManagerPreviewEntry* font_manager_preview_entry_new (void);
VALA_EXTERN FontManagerPreviewEntry* font_manager_preview_entry_construct (GType object_type);
VALA_EXTERN FontManagerGoogleFontsSampleList* font_manager_google_fonts_sample_list_new (void);
VALA_EXTERN FontManagerGoogleFontsSampleList* font_manager_google_fonts_sample_list_construct (GType object_type);
static void font_manager_google_fonts_preview_page_on_mode_action_activated (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      FontManagerGoogleFontsPreviewPage* self);
static void __lambda166_ (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN void font_manager_google_fonts_preview_page_reload_preview (FontManagerGoogleFontsPreviewPage* self);
static void ___lambda166__font_manager_preview_colors_color_set (FontManagerPreviewColors* _sender,
                                                          gpointer self);
static void font_manager_google_fonts_preview_page_on_item_selected (FontManagerGoogleFontsPreviewPage* self);
static void _font_manager_google_fonts_preview_page_on_item_selected_g_object_notify (GObject* _sender,
                                                                               GParamSpec* pspec,
                                                                               gpointer self);
static void font_manager_google_fonts_preview_page_on_sample_selected (FontManagerGoogleFontsPreviewPage* self,
                                                                const gchar* sample);
static void _font_manager_google_fonts_preview_page_on_sample_selected_font_manager_google_fonts_sample_list_row_selected (FontManagerGoogleFontsSampleList* _sender,
                                                                                                                    const gchar* sample,
                                                                                                                    gpointer self);
static void font_manager_google_fonts_preview_page_on_undo_clicked (FontManagerGoogleFontsPreviewPage* self);
static void _font_manager_google_fonts_preview_page_on_undo_clicked_font_manager_preview_controls_undo_clicked (FontManagerPreviewControls* _sender,
                                                                                                         gpointer self);
static void font_manager_google_fonts_preview_page_on_entry_changed (FontManagerGoogleFontsPreviewPage* self);
static void _font_manager_google_fonts_preview_page_on_entry_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                                    gpointer self);
static void font_manager_google_fonts_preview_page_update_waterfall_body (FontManagerGoogleFontsPreviewPage* self);
static void _font_manager_google_fonts_preview_page_update_waterfall_body_g_object_notify (GObject* _sender,
                                                                                    GParamSpec* pspec,
                                                                                    gpointer self);
static void _font_manager_google_fonts_preview_page_reload_preview_g_object_notify (GObject* _sender,
                                                                             GParamSpec* pspec,
                                                                             gpointer self);
static void font_manager_google_fonts_preview_page_on_edit_toggled (FontManagerGoogleFontsPreviewPage* self,
                                                             gboolean active);
static void _font_manager_google_fonts_preview_page_on_edit_toggled_font_manager_preview_controls_edit_toggled (FontManagerPreviewControls* _sender,
                                                                                                         gboolean object,
                                                                                                         gpointer self);
static void __lambda174_ (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN FontManagerWaterfallSettings* font_manager_google_fonts_preview_page_get_waterfall_settings (FontManagerGoogleFontsPreviewPage* self);
static void ___lambda174__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void __lambda175_ (FontManagerGoogleFontsPreviewPage* self);
static gboolean __lambda176_ (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN void font_manager_waterfall_settings_on_selection_changed (FontManagerWaterfallSettings* self);
VALA_EXTERN gdouble font_manager_waterfall_settings_get_minimum (FontManagerWaterfallSettings* self);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_min_waterfall_size (FontManagerGoogleFontsPreviewPage* self,
                                                                    gdouble value);
VALA_EXTERN gdouble font_manager_waterfall_settings_get_maximum (FontManagerWaterfallSettings* self);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_max_waterfall_size (FontManagerGoogleFontsPreviewPage* self,
                                                                    gdouble value);
VALA_EXTERN gdouble font_manager_waterfall_settings_get_ratio (FontManagerWaterfallSettings* self);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_waterfall_size_ratio (FontManagerGoogleFontsPreviewPage* self,
                                                                      gdouble value);
static gboolean ___lambda176__gsource_func (gpointer self);
static void ___lambda175__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void __lambda177_ (FontManagerGoogleFontsPreviewPage* self);
static void ___lambda177__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void font_manager_google_fonts_preview_page_on_show_context_menu (FontManagerGoogleFontsPreviewPage* self,
                                                                  gint n_press,
                                                                  gdouble x,
                                                                  gdouble y);
static void _font_manager_google_fonts_preview_page_on_show_context_menu_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                                             gint n_press,
                                                                                             gdouble x,
                                                                                             gdouble y,
                                                                                             gpointer self);
VALA_EXTERN void font_manager_google_fonts_preview_page_restore_state (FontManagerGoogleFontsPreviewPage* self,
                                                           GSettings* settings);
VALA_EXTERN FontManagerPreviewPageMode font_manager_google_fonts_preview_page_get_preview_mode (FontManagerGoogleFontsPreviewPage* self);
static gchar* _variant_get3 (GVariant* value);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_preview_mode (FontManagerGoogleFontsPreviewPage* self,
                                                              FontManagerPreviewPageMode value);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_preview_text (FontManagerGoogleFontsPreviewPage* self,
                                                              const gchar* value);
static gchar* font_manager_google_fonts_preview_page_generate_waterfall (FontManagerGoogleFontsPreviewPage* self);
static gchar* font_manager_google_fonts_preview_page_generate_lorem_ipsum (FontManagerGoogleFontsPreviewPage* self);
static gchar* font_manager_google_fonts_preview_page_generate_active_preview (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN FontManagerStringSet* font_manager_google_fonts_font_get_subsets (FontManagerGoogleFontsFont* self);
VALA_EXTERN void font_manager_google_fonts_sample_list_set_items (FontManagerGoogleFontsSampleList* self,
                                                      FontManagerStringSet* value);
VALA_EXTERN const gchar* font_manager_google_fonts_font_get_family (FontManagerGoogleFontsFont* self);
VALA_EXTERN gchar* font_manager_google_fonts_font_to_display_name (FontManagerGoogleFontsFont* self);
VALA_EXTERN GObject* font_manager_google_fonts_preview_page_get_selected_item (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN GType font_manager_google_fonts_family_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsFamily, g_object_unref)
VALA_EXTERN FontManagerGoogleFontsFont* font_manager_google_fonts_family_get_default_variant (FontManagerGoogleFontsFamily* self);
VALA_EXTERN GType font_manager_google_fonts_sample_model_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsSampleModel, g_object_unref)
VALA_EXTERN FontManagerGoogleFontsSampleModel* font_manager_google_fonts_sample_list_get_model (FontManagerGoogleFontsSampleList* self);
static gdouble font_manager_google_fonts_preview_page_get_next_line_size (FontManagerGoogleFontsPreviewPage* self,
                                                                   gdouble current);
VALA_EXTERN gdouble font_manager_google_fonts_preview_page_get_waterfall_size_ratio (FontManagerGoogleFontsPreviewPage* self);
static gchar* font_manager_google_fonts_preview_page_get_current_header (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN GtkJustification font_manager_google_fonts_preview_page_get_justification (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN void font_manager_preview_colors_get_foreground_color (FontManagerPreviewColors* self,
                                                       GdkRGBA * result);
VALA_EXTERN void font_manager_preview_colors_get_background_color (FontManagerPreviewColors* self,
                                                       GdkRGBA * result);
VALA_EXTERN gdouble font_manager_google_fonts_preview_page_get_preview_size (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN const gchar* font_manager_google_fonts_font_get_style (FontManagerGoogleFontsFont* self);
VALA_EXTERN gint font_manager_google_fonts_font_get_weight (FontManagerGoogleFontsFont* self);
VALA_EXTERN gchar* font_manager_google_fonts_font_to_font_face_rule (FontManagerGoogleFontsFont* self);
VALA_EXTERN gdouble font_manager_google_fonts_preview_page_get_min_waterfall_size (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN gdouble font_manager_google_fonts_preview_page_get_max_waterfall_size (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN gboolean font_manager_google_fonts_preview_page_get_show_line_size (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN const gchar* font_manager_google_fonts_preview_page_get_preview_text (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN GtkPopoverMenu* font_manager_waterfall_settings_get_context_menu (FontManagerWaterfallSettings* self);
VALA_EXTERN gint font_manager_google_fonts_preview_page_get_predefined_size (FontManagerGoogleFontsPreviewPage* self);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_predefined_size (FontManagerGoogleFontsPreviewPage* self,
                                                                 gint value);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_show_line_size (FontManagerGoogleFontsPreviewPage* self,
                                                                gboolean value);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_preview_size (FontManagerGoogleFontsPreviewPage* self,
                                                              gdouble value);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_selected_item (FontManagerGoogleFontsPreviewPage* self,
                                                               GObject* value);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_justification (FontManagerGoogleFontsPreviewPage* self,
                                                               GtkJustification value);
VALA_EXTERN void font_manager_google_fonts_preview_page_set_waterfall_settings (FontManagerGoogleFontsPreviewPage* self,
                                                                    FontManagerWaterfallSettings* value);
static void font_manager_google_fonts_preview_page_finalize (GObject * obj);
static GType font_manager_google_fonts_preview_page_get_type_once (void);
static void _vala_font_manager_google_fonts_preview_page_get_property (GObject * object,
                                                                guint property_id,
                                                                GValue * value,
                                                                GParamSpec * pspec);
static void _vala_font_manager_google_fonts_preview_page_set_property (GObject * object,
                                                                guint property_id,
                                                                const GValue * value,
                                                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

WebKitWebView*
font_manager_google_fonts_create_webview (void)
{
	WebKitWebView* webview = NULL;
	WebKitWebView* _tmp0_;
	WebKitSettings* settings = NULL;
	WebKitSettings* _tmp1_ = NULL;
	WebKitWebContext* _tmp2_;
	WebKitWebContext* _tmp3_;
	WebKitWebContext* _tmp4_;
	WebKitNetworkSession* _tmp5_;
	WebKitNetworkSession* _tmp6_;
	WebKitWebView* result;
#line 121 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = (WebKitWebView*) webkit_web_view_new ();
#line 121 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_ref_sink (_tmp0_);
#line 121 "../src/font-manager/web/google/PreviewPage.vala"
	webview = _tmp0_;
#line 122 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = webkit_settings_new ();
#line 122 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_settings_set_allow_modal_dialogs (_tmp1_, FALSE);
#line 122 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_settings_set_auto_load_images (_tmp1_, FALSE);
#line 122 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_settings_set_enable_back_forward_navigation_gestures (_tmp1_, FALSE);
#line 122 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_settings_set_enable_developer_extras (_tmp1_, FALSE);
#line 122 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_settings_set_enable_fullscreen (_tmp1_, FALSE);
#line 122 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_settings_set_enable_media (_tmp1_, FALSE);
#line 122 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_settings_set_enable_media_stream (_tmp1_, FALSE);
#line 122 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_settings_set_enable_site_specific_quirks (_tmp1_, FALSE);
#line 122 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_settings_set_enable_smooth_scrolling (_tmp1_, TRUE);
#line 122 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_settings_set_enable_webaudio (_tmp1_, FALSE);
#line 122 "../src/font-manager/web/google/PreviewPage.vala"
	settings = _tmp1_;
#line 134 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_settings_set_user_agent_with_application_details (settings, PACKAGE_NAME, PACKAGE_VERSION);
#line 136 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_web_view_set_settings (webview, settings);
#line 137 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_get (webview, "web-context", &_tmp2_, NULL);
#line 137 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = _tmp2_;
#line 137 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp4_ = _tmp3_;
#line 137 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_web_context_set_cache_model (_tmp4_, WEBKIT_CACHE_MODEL_DOCUMENT_BROWSER);
#line 137 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (_tmp4_);
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_ = webkit_web_view_get_network_session (webview);
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp6_ = _tmp5_;
#line 138 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_network_session_prefetch_dns (_tmp6_, "http://fonts.gstatic.com/");
#line 139 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_widget_set_expand ((GtkWidget*) webview, TRUE);
#line 140 "../src/font-manager/web/google/PreviewPage.vala"
	result = webview;
#line 140 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (settings);
#line 140 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 448 "PreviewPage.c"
}

static inline gpointer
font_manager_google_fonts_preview_page_get_instance_private (FontManagerGoogleFontsPreviewPage* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerGoogleFontsPreviewPage_private_offset);
}

static void
__lambda166_ (FontManagerGoogleFontsPreviewPage* self)
{
#line 218 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_reload_preview (self);
#line 462 "PreviewPage.c"
}

static void
___lambda166__font_manager_preview_colors_color_set (FontManagerPreviewColors* _sender,
                                                     gpointer self)
{
#line 218 "../src/font-manager/web/google/PreviewPage.vala"
	__lambda166_ ((FontManagerGoogleFontsPreviewPage*) self);
#line 471 "PreviewPage.c"
}

static void
_font_manager_google_fonts_preview_page_on_item_selected_g_object_notify (GObject* _sender,
                                                                          GParamSpec* pspec,
                                                                          gpointer self)
{
#line 223 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_on_item_selected ((FontManagerGoogleFontsPreviewPage*) self);
#line 481 "PreviewPage.c"
}

static void
_font_manager_google_fonts_preview_page_on_sample_selected_font_manager_google_fonts_sample_list_row_selected (FontManagerGoogleFontsSampleList* _sender,
                                                                                                               const gchar* sample,
                                                                                                               gpointer self)
{
#line 224 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_on_sample_selected ((FontManagerGoogleFontsPreviewPage*) self, sample);
#line 491 "PreviewPage.c"
}

static void
_font_manager_google_fonts_preview_page_on_undo_clicked_font_manager_preview_controls_undo_clicked (FontManagerPreviewControls* _sender,
                                                                                                    gpointer self)
{
#line 225 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_on_undo_clicked ((FontManagerGoogleFontsPreviewPage*) self);
#line 500 "PreviewPage.c"
}

static void
_font_manager_google_fonts_preview_page_on_entry_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                               gpointer self)
{
#line 226 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_on_entry_changed ((FontManagerGoogleFontsPreviewPage*) self);
#line 509 "PreviewPage.c"
}

static void
_font_manager_google_fonts_preview_page_update_waterfall_body_g_object_notify (GObject* _sender,
                                                                               GParamSpec* pspec,
                                                                               gpointer self)
{
#line 228 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_update_waterfall_body ((FontManagerGoogleFontsPreviewPage*) self);
#line 519 "PreviewPage.c"
}

static void
_font_manager_google_fonts_preview_page_reload_preview_g_object_notify (GObject* _sender,
                                                                        GParamSpec* pspec,
                                                                        gpointer self)
{
#line 230 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_reload_preview ((FontManagerGoogleFontsPreviewPage*) self);
#line 529 "PreviewPage.c"
}

static void
_font_manager_google_fonts_preview_page_on_edit_toggled_font_manager_preview_controls_edit_toggled (FontManagerPreviewControls* _sender,
                                                                                                    gboolean object,
                                                                                                    gpointer self)
{
#line 231 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_on_edit_toggled ((FontManagerGoogleFontsPreviewPage*) self, object);
#line 539 "PreviewPage.c"
}

static void
__lambda174_ (FontManagerGoogleFontsPreviewPage* self)
{
	GBindingFlags _flags = 0U;
	FontManagerWaterfallSettings* _tmp0_;
	FontManagerWaterfallSettings* _tmp1_;
#line 235 "../src/font-manager/web/google/PreviewPage.vala"
	_flags = G_BINDING_BIDIRECTIONAL | G_BINDING_SYNC_CREATE;
#line 236 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->_waterfall_settings;
#line 236 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp0_, "predefined-size", (GObject*) self, "predefined-size", _flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 237 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = self->priv->_waterfall_settings;
#line 237 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp1_, "show-line-size", (GObject*) self, "show-line-size", _flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 558 "PreviewPage.c"
}

static void
___lambda174__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 234 "../src/font-manager/web/google/PreviewPage.vala"
	__lambda174_ ((FontManagerGoogleFontsPreviewPage*) self);
#line 568 "PreviewPage.c"
}

static gboolean
__lambda176_ (FontManagerGoogleFontsPreviewPage* self)
{
	FontManagerWaterfallSettings* _tmp0_;
	FontManagerWaterfallSettings* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	FontManagerWaterfallSettings* _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	FontManagerWaterfallSettings* _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gboolean result;
#line 242 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->_waterfall_settings;
#line 242 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_waterfall_settings_on_selection_changed (_tmp0_);
#line 243 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = self->priv->_waterfall_settings;
#line 243 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp2_ = font_manager_waterfall_settings_get_minimum (_tmp1_);
#line 243 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = _tmp2_;
#line 243 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_set_min_waterfall_size (self, _tmp3_);
#line 244 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp4_ = self->priv->_waterfall_settings;
#line 244 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_ = font_manager_waterfall_settings_get_maximum (_tmp4_);
#line 244 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp6_ = _tmp5_;
#line 244 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_set_max_waterfall_size (self, _tmp6_);
#line 245 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp7_ = self->priv->_waterfall_settings;
#line 245 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp8_ = font_manager_waterfall_settings_get_ratio (_tmp7_);
#line 245 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp9_ = _tmp8_;
#line 245 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_set_waterfall_size_ratio (self, _tmp9_);
#line 246 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_update_waterfall_body (self);
#line 247 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_reload_preview (self);
#line 248 "../src/font-manager/web/google/PreviewPage.vala"
	result = G_SOURCE_REMOVE;
#line 248 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 621 "PreviewPage.c"
}

static gboolean
___lambda176__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda176_ ((FontManagerGoogleFontsPreviewPage*) self);
#line 240 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 631 "PreviewPage.c"
}

static void
__lambda175_ (FontManagerGoogleFontsPreviewPage* self)
{
#line 240 "../src/font-manager/web/google/PreviewPage.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda176__gsource_func, g_object_ref (self), g_object_unref);
#line 639 "PreviewPage.c"
}

static void
___lambda175__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 239 "../src/font-manager/web/google/PreviewPage.vala"
	__lambda175_ ((FontManagerGoogleFontsPreviewPage*) self);
#line 649 "PreviewPage.c"
}

static void
__lambda177_ (FontManagerGoogleFontsPreviewPage* self)
{
#line 252 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_update_waterfall_body (self);
#line 253 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_reload_preview (self);
#line 659 "PreviewPage.c"
}

static void
___lambda177__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 251 "../src/font-manager/web/google/PreviewPage.vala"
	__lambda177_ ((FontManagerGoogleFontsPreviewPage*) self);
#line 669 "PreviewPage.c"
}

static void
_font_manager_google_fonts_preview_page_on_show_context_menu_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                                        gint n_press,
                                                                                        gdouble x,
                                                                                        gdouble y,
                                                                                        gpointer self)
{
#line 259 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_on_show_context_menu ((FontManagerGoogleFontsPreviewPage*) self, n_press, x, y);
#line 681 "PreviewPage.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 260 "../src/font-manager/web/google/PreviewPage.vala"
	return self ? g_object_ref (self) : NULL;
#line 689 "PreviewPage.c"
}

FontManagerGoogleFontsPreviewPage*
font_manager_google_fonts_preview_page_construct (GType object_type)
{
	FontManagerGoogleFontsPreviewPage * self = NULL;
	WebKitWebView* _tmp0_;
	FontManagerPreviewControls* _tmp1_;
	GtkRevealer* _tmp2_;
	GtkRevealer* _tmp3_;
	FontManagerPreviewControls* _tmp4_;
	GtkRevealer* _tmp5_;
	WebKitWebView* _tmp6_;
	FontManagerPreviewEntry* _tmp7_;
	GtkCenterBox* _tmp8_;
	FontManagerPreviewEntry* _tmp9_;
	FontManagerFontScale* _tmp10_;
	GtkRevealer* _tmp11_;
	GtkRevealer* _tmp12_;
	FontManagerFontScale* _tmp13_;
	GtkRevealer* _tmp14_;
	FontManagerGoogleFontsSampleList* _tmp15_;
	GtkMenuButton* _tmp16_;
	FontManagerGoogleFontsSampleList* _tmp17_;
	GtkMenuButton* _tmp18_;
	FontManagerPreviewColors* _tmp19_;
	GBindingFlags flags = 0U;
	FontManagerFontScale* _tmp20_;
	FontManagerPreviewEntry* _tmp21_;
	FontManagerPreviewControls* _tmp22_;
	FontManagerGoogleFontsSampleList* _tmp23_;
	FontManagerPreviewControls* _tmp24_;
	FontManagerPreviewEntry* _tmp25_;
	gchar** _tmp26_;
	gint _tmp26__length1;
	gchar** _tmp30_;
	gint _tmp30__length1;
	FontManagerPreviewControls* _tmp34_;
	GtkGesture* right_click = NULL;
	GtkGestureClick* _tmp35_ = NULL;
	WebKitWebView* _tmp36_;
	GtkEventController* _tmp37_;
#line 202 "../src/font-manager/web/google/PreviewPage.vala"
	self = (FontManagerGoogleFontsPreviewPage*) g_object_new (object_type, NULL);
#line 203 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = font_manager_google_fonts_create_webview ();
#line 203 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->webview);
#line 203 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->webview = _tmp0_;
#line 204 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = (FontManagerPreviewControls*) font_manager_preview_controls_new ();
#line 204 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_ref_sink (_tmp1_);
#line 204 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->preview_controls);
#line 204 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->preview_controls = _tmp1_;
#line 205 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp2_ = (GtkRevealer*) gtk_revealer_new ();
#line 205 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_ref_sink (_tmp2_);
#line 205 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->controls_revealer);
#line 205 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->controls_revealer = _tmp2_;
#line 206 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = self->priv->controls_revealer;
#line 206 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp4_ = self->priv->preview_controls;
#line 206 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_revealer_set_child (_tmp3_, (GtkWidget*) _tmp4_);
#line 207 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_ = self->priv->controls_revealer;
#line 207 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp5_);
#line 208 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp6_ = self->priv->webview;
#line 208 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp6_);
#line 209 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp7_ = font_manager_preview_entry_new ();
#line 209 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_ref_sink (_tmp7_);
#line 209 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->entry);
#line 209 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->entry = _tmp7_;
#line 210 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp8_ = self->priv->controls;
#line 210 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp9_ = self->priv->entry;
#line 210 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_center_box_set_center_widget (_tmp8_, (GtkWidget*) _tmp9_);
#line 211 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp10_ = (FontManagerFontScale*) font_manager_font_scale_new ();
#line 211 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_ref_sink (_tmp10_);
#line 211 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->fontscale);
#line 211 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->fontscale = _tmp10_;
#line 212 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp11_ = (GtkRevealer*) gtk_revealer_new ();
#line 212 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_ref_sink (_tmp11_);
#line 212 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->fontscale_revealer);
#line 212 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->fontscale_revealer = _tmp11_;
#line 213 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp12_ = self->priv->fontscale_revealer;
#line 213 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp13_ = self->priv->fontscale;
#line 213 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_revealer_set_child (_tmp12_, (GtkWidget*) _tmp13_);
#line 214 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp14_ = self->priv->fontscale_revealer;
#line 214 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp14_);
#line 215 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp15_ = font_manager_google_fonts_sample_list_new ();
#line 215 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_ref_sink (_tmp15_);
#line 215 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->samples);
#line 215 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->samples = _tmp15_;
#line 216 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp16_ = self->priv->sample_button;
#line 216 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp17_ = self->priv->samples;
#line 216 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_menu_button_set_popover (_tmp16_, (GtkWidget*) _tmp17_);
#line 217 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp18_ = self->priv->menu_button;
#line 217 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_set_preview_page_mode_menu_and_actions ((GtkWidget*) self, (GtkWidget*) _tmp18_, (GCallback) font_manager_google_fonts_preview_page_on_mode_action_activated);
#line 218 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp19_ = self->priv->preview_colors;
#line 218 "../src/font-manager/web/google/PreviewPage.vala"
	g_signal_connect_object (_tmp19_, "color-set", (GCallback) ___lambda166__font_manager_preview_colors_color_set, self, 0);
#line 219 "../src/font-manager/web/google/PreviewPage.vala"
	flags = G_BINDING_BIDIRECTIONAL | G_BINDING_SYNC_CREATE;
#line 220 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp20_ = self->priv->fontscale;
#line 220 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_bind_property_with_closures ((GObject*) self, "preview-size", (GObject*) _tmp20_, "value", flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 221 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp21_ = self->priv->entry;
#line 221 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_bind_property_with_closures ((GObject*) self, "preview-text", (GObject*) _tmp21_, "placeholder-text", flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 222 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp22_ = self->priv->preview_controls;
#line 222 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_bind_property_with_closures ((GObject*) self, "justification", (GObject*) _tmp22_, "justification", flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 223 "../src/font-manager/web/google/PreviewPage.vala"
	g_signal_connect_object ((GObject*) self, "notify::selected-item", (GCallback) _font_manager_google_fonts_preview_page_on_item_selected_g_object_notify, self, G_CONNECT_AFTER);
#line 224 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp23_ = self->priv->samples;
#line 224 "../src/font-manager/web/google/PreviewPage.vala"
	g_signal_connect_object (_tmp23_, "row-selected", (GCallback) _font_manager_google_fonts_preview_page_on_sample_selected_font_manager_google_fonts_sample_list_row_selected, self, 0);
#line 225 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp24_ = self->priv->preview_controls;
#line 225 "../src/font-manager/web/google/PreviewPage.vala"
	g_signal_connect_object (_tmp24_, "undo-clicked", (GCallback) _font_manager_google_fonts_preview_page_on_undo_clicked_font_manager_preview_controls_undo_clicked, self, 0);
#line 226 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp25_ = self->priv->entry;
#line 226 "../src/font-manager/web/google/PreviewPage.vala"
	g_signal_connect_object ((GtkEditable*) _tmp25_, "changed", (GCallback) _font_manager_google_fonts_preview_page_on_entry_changed_gtk_editable_changed, self, 0);
#line 227 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp26_ = self->priv->affects_waterfall;
#line 227 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp26__length1 = self->priv->affects_waterfall_length1;
#line 864 "PreviewPage.c"
	{
		gchar** property_collection = NULL;
		gint property_collection_length1 = 0;
		gint _property_collection_size_ = 0;
		gint property_it = 0;
#line 227 "../src/font-manager/web/google/PreviewPage.vala"
		property_collection = _tmp26_;
#line 227 "../src/font-manager/web/google/PreviewPage.vala"
		property_collection_length1 = _tmp26__length1;
#line 227 "../src/font-manager/web/google/PreviewPage.vala"
		for (property_it = 0; property_it < property_collection_length1; property_it = property_it + 1) {
#line 876 "PreviewPage.c"
			gchar* _tmp27_;
			gchar* property = NULL;
#line 227 "../src/font-manager/web/google/PreviewPage.vala"
			_tmp27_ = g_strdup (property_collection[property_it]);
#line 227 "../src/font-manager/web/google/PreviewPage.vala"
			property = _tmp27_;
#line 883 "PreviewPage.c"
			{
				const gchar* _tmp28_;
				gchar* _tmp29_;
#line 228 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp28_ = property;
#line 228 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp29_ = g_strconcat ("notify::", _tmp28_, NULL);
#line 228 "../src/font-manager/web/google/PreviewPage.vala"
				g_signal_connect_object ((GObject*) self, _tmp29_, (GCallback) _font_manager_google_fonts_preview_page_update_waterfall_body_g_object_notify, self, G_CONNECT_AFTER);
#line 228 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (_tmp29_);
#line 227 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (property);
#line 897 "PreviewPage.c"
			}
		}
	}
#line 229 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp30_ = self->priv->requires_reload;
#line 229 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp30__length1 = self->priv->requires_reload_length1;
#line 905 "PreviewPage.c"
	{
		gchar** property_collection = NULL;
		gint property_collection_length1 = 0;
		gint _property_collection_size_ = 0;
		gint property_it = 0;
#line 229 "../src/font-manager/web/google/PreviewPage.vala"
		property_collection = _tmp30_;
#line 229 "../src/font-manager/web/google/PreviewPage.vala"
		property_collection_length1 = _tmp30__length1;
#line 229 "../src/font-manager/web/google/PreviewPage.vala"
		for (property_it = 0; property_it < property_collection_length1; property_it = property_it + 1) {
#line 917 "PreviewPage.c"
			gchar* _tmp31_;
			gchar* property = NULL;
#line 229 "../src/font-manager/web/google/PreviewPage.vala"
			_tmp31_ = g_strdup (property_collection[property_it]);
#line 229 "../src/font-manager/web/google/PreviewPage.vala"
			property = _tmp31_;
#line 924 "PreviewPage.c"
			{
				const gchar* _tmp32_;
				gchar* _tmp33_;
#line 230 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp32_ = property;
#line 230 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp33_ = g_strconcat ("notify::", _tmp32_, NULL);
#line 230 "../src/font-manager/web/google/PreviewPage.vala"
				g_signal_connect_object ((GObject*) self, _tmp33_, (GCallback) _font_manager_google_fonts_preview_page_reload_preview_g_object_notify, self, G_CONNECT_AFTER);
#line 230 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (_tmp33_);
#line 229 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (property);
#line 938 "PreviewPage.c"
			}
		}
	}
#line 231 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp34_ = self->priv->preview_controls;
#line 231 "../src/font-manager/web/google/PreviewPage.vala"
	g_signal_connect_object (_tmp34_, "edit-toggled", (GCallback) _font_manager_google_fonts_preview_page_on_edit_toggled_font_manager_preview_controls_edit_toggled, self, 0);
#line 232 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_update_waterfall_body (self);
#line 233 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_reload_preview (self);
#line 234 "../src/font-manager/web/google/PreviewPage.vala"
	g_signal_connect_object ((GObject*) self, "notify::waterfall-settings", (GCallback) ___lambda174__g_object_notify, self, 0);
#line 239 "../src/font-manager/web/google/PreviewPage.vala"
	g_signal_connect_object ((GObject*) self, "notify::predefined-size", (GCallback) ___lambda175__g_object_notify, self, G_CONNECT_AFTER);
#line 251 "../src/font-manager/web/google/PreviewPage.vala"
	g_signal_connect_object ((GObject*) self, "notify::show-line-size", (GCallback) ___lambda177__g_object_notify, self, G_CONNECT_AFTER);
#line 255 "../src/font-manager/web/google/PreviewPage.vala"
	memset (&self->priv->clicked_area, 0, sizeof (GdkRectangle));
#line 256 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp35_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 256 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp35_, (guint) GDK_BUTTON_SECONDARY);
#line 256 "../src/font-manager/web/google/PreviewPage.vala"
	right_click = (GtkGesture*) _tmp35_;
#line 259 "../src/font-manager/web/google/PreviewPage.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (right_click, gtk_gesture_click_get_type (), GtkGestureClick), "pressed", (GCallback) _font_manager_google_fonts_preview_page_on_show_context_menu_gtk_gesture_click_pressed, self, 0);
#line 260 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp36_ = self->priv->webview;
#line 260 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp37_ = _g_object_ref0 ((GtkEventController*) right_click);
#line 260 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_add_controller ((GtkWidget*) _tmp36_, _tmp37_);
#line 202 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (right_click);
#line 202 "../src/font-manager/web/google/PreviewPage.vala"
	return self;
#line 976 "PreviewPage.c"
}

FontManagerGoogleFontsPreviewPage*
font_manager_google_fonts_preview_page_new (void)
{
#line 202 "../src/font-manager/web/google/PreviewPage.vala"
	return font_manager_google_fonts_preview_page_construct (FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PAGE);
#line 984 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_restore_state (FontManagerGoogleFontsPreviewPage* self,
                                                      GSettings* settings)
{
	GSettingsBindFlags flags = 0U;
#line 263 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 264 "../src/font-manager/web/google/PreviewPage.vala"
	if (settings == NULL) {
#line 265 "../src/font-manager/web/google/PreviewPage.vala"
		return;
#line 998 "PreviewPage.c"
	}
#line 266 "../src/font-manager/web/google/PreviewPage.vala"
	flags = G_SETTINGS_BIND_DEFAULT;
#line 267 "../src/font-manager/web/google/PreviewPage.vala"
	g_settings_bind (settings, "preview-font-size", (GObject*) self, "preview-size", flags);
#line 268 "../src/font-manager/web/google/PreviewPage.vala"
	g_settings_bind (settings, "preview-mode", (GObject*) self, "preview-mode", flags);
#line 269 "../src/font-manager/web/google/PreviewPage.vala"
	g_settings_bind (settings, "google-fonts-preview-text", (GObject*) self, "preview-text", flags);
#line 270 "../src/font-manager/web/google/PreviewPage.vala"
	return;
#line 1010 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_on_sample_selected (FontManagerGoogleFontsPreviewPage* self,
                                                           const gchar* sample)
{
	FontManagerPreviewEntry* _tmp0_;
	FontManagerPreviewPageMode _tmp1_;
#line 273 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 273 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (sample != NULL);
#line 274 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->entry;
#line 274 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_editable_set_text ((GtkEditable*) _tmp0_, sample);
#line 275 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = self->priv->_preview_mode;
#line 275 "../src/font-manager/web/google/PreviewPage.vala"
	if (_tmp1_ == FONT_MANAGER_PREVIEW_PAGE_MODE_PREVIEW) {
#line 1031 "PreviewPage.c"
		gchar* _tmp2_;
#line 276 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp2_ = g_strdup (sample);
#line 276 "../src/font-manager/web/google/PreviewPage.vala"
		_g_free0 (self->priv->active_preview_text);
#line 276 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->active_preview_text = _tmp2_;
#line 277 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_reload_preview (self);
#line 1041 "PreviewPage.c"
	}
#line 279 "../src/font-manager/web/google/PreviewPage.vala"
	return;
#line 1045 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_on_undo_clicked (FontManagerGoogleFontsPreviewPage* self)
{
#line 282 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 283 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (self->priv->active_preview_text);
#line 283 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->active_preview_text = NULL;
#line 284 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_reload_preview (self);
#line 285 "../src/font-manager/web/google/PreviewPage.vala"
	return;
#line 1061 "PreviewPage.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 1082 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_on_edit_toggled (FontManagerGoogleFontsPreviewPage* self,
                                                        gboolean active)
{
	WebKitWebView* _tmp0_;
#line 288 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 289 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->webview;
#line 289 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_web_view_set_editable (_tmp0_, active);
#line 290 "../src/font-manager/web/google/PreviewPage.vala"
	if (!active) {
#line 1098 "PreviewPage.c"
		gboolean _tmp1_ = FALSE;
		WebKitWebView* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 291 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp2_ = self->priv->webview;
#line 291 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp3_ = webkit_web_view_get_title (_tmp2_);
#line 291 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp4_ = _tmp3_;
#line 291 "../src/font-manager/web/google/PreviewPage.vala"
		if (_tmp4_ != NULL) {
#line 1111 "PreviewPage.c"
			WebKitWebView* _tmp5_;
			const gchar* _tmp6_;
			const gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
#line 291 "../src/font-manager/web/google/PreviewPage.vala"
			_tmp5_ = self->priv->webview;
#line 291 "../src/font-manager/web/google/PreviewPage.vala"
			_tmp6_ = webkit_web_view_get_title (_tmp5_);
#line 291 "../src/font-manager/web/google/PreviewPage.vala"
			_tmp7_ = _tmp6_;
#line 291 "../src/font-manager/web/google/PreviewPage.vala"
			_tmp8_ = string_strip (_tmp7_);
#line 291 "../src/font-manager/web/google/PreviewPage.vala"
			_tmp9_ = _tmp8_;
#line 291 "../src/font-manager/web/google/PreviewPage.vala"
			_tmp10_ = strlen (_tmp9_);
#line 291 "../src/font-manager/web/google/PreviewPage.vala"
			_tmp11_ = _tmp10_;
#line 291 "../src/font-manager/web/google/PreviewPage.vala"
			_tmp1_ = _tmp11_ > 0;
#line 291 "../src/font-manager/web/google/PreviewPage.vala"
			_g_free0 (_tmp9_);
#line 1137 "PreviewPage.c"
		} else {
#line 291 "../src/font-manager/web/google/PreviewPage.vala"
			_tmp1_ = FALSE;
#line 1141 "PreviewPage.c"
		}
#line 291 "../src/font-manager/web/google/PreviewPage.vala"
		if (_tmp1_) {
#line 1145 "PreviewPage.c"
			WebKitWebView* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
#line 292 "../src/font-manager/web/google/PreviewPage.vala"
			_tmp12_ = self->priv->webview;
#line 292 "../src/font-manager/web/google/PreviewPage.vala"
			_tmp13_ = webkit_web_view_get_title (_tmp12_);
#line 292 "../src/font-manager/web/google/PreviewPage.vala"
			_tmp14_ = _tmp13_;
#line 292 "../src/font-manager/web/google/PreviewPage.vala"
			_tmp15_ = g_strdup (_tmp14_);
#line 292 "../src/font-manager/web/google/PreviewPage.vala"
			_g_free0 (self->priv->active_preview_text);
#line 292 "../src/font-manager/web/google/PreviewPage.vala"
			self->priv->active_preview_text = _tmp15_;
#line 1162 "PreviewPage.c"
		}
	}
#line 293 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_reload_preview (self);
#line 294 "../src/font-manager/web/google/PreviewPage.vala"
	return;
#line 1169 "PreviewPage.c"
}

static gchar*
_variant_get3 (GVariant* value)
{
#line 300 "../src/font-manager/web/google/PreviewPage.vala"
	return g_variant_dup_string (value, NULL);
#line 1177 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_on_mode_action_activated (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 FontManagerGoogleFontsPreviewPage* self)
{
	FontManagerPreviewPageMode mode = 0;
	gchar* param = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 298 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 298 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (action != NULL);
#line 298 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (parameter != NULL);
#line 299 "../src/font-manager/web/google/PreviewPage.vala"
	mode = FONT_MANAGER_PREVIEW_PAGE_MODE_LOREM_IPSUM;
#line 300 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = _variant_get3 (parameter);
#line 300 "../src/font-manager/web/google/PreviewPage.vala"
	param = _tmp0_;
#line 301 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = param;
#line 301 "../src/font-manager/web/google/PreviewPage.vala"
	if (g_strcmp0 (_tmp1_, "Waterfall") == 0) {
#line 302 "../src/font-manager/web/google/PreviewPage.vala"
		mode = FONT_MANAGER_PREVIEW_PAGE_MODE_WATERFALL;
#line 1208 "PreviewPage.c"
	}
#line 303 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp2_ = param;
#line 303 "../src/font-manager/web/google/PreviewPage.vala"
	if (g_strcmp0 (_tmp2_, "Preview") == 0) {
#line 304 "../src/font-manager/web/google/PreviewPage.vala"
		mode = FONT_MANAGER_PREVIEW_PAGE_MODE_PREVIEW;
#line 1216 "PreviewPage.c"
	}
#line 305 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_set_preview_mode (self, mode);
#line 306 "../src/font-manager/web/google/PreviewPage.vala"
	g_simple_action_set_state (action, parameter);
#line 307 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (param);
#line 307 "../src/font-manager/web/google/PreviewPage.vala"
	return;
#line 1226 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_on_entry_changed (FontManagerGoogleFontsPreviewPage* self)
{
	const gchar* _tmp0_ = NULL;
	FontManagerPreviewEntry* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
#line 310 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 311 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = self->priv->entry;
#line 311 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp2_ = gtk_entry_get_text_length ((GtkEntry*) _tmp1_);
#line 311 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = _tmp2_;
#line 311 "../src/font-manager/web/google/PreviewPage.vala"
	if (_tmp3_ > ((guint) 0)) {
#line 1246 "PreviewPage.c"
		FontManagerPreviewEntry* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 311 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp4_ = self->priv->entry;
#line 311 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp5_ = gtk_editable_get_text ((GtkEditable*) _tmp4_);
#line 311 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp6_ = _tmp5_;
#line 311 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp0_ = _tmp6_;
#line 1258 "PreviewPage.c"
	} else {
#line 311 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp0_ = NULL;
#line 1262 "PreviewPage.c"
	}
#line 311 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_set_preview_text (self, _tmp0_);
#line 312 "../src/font-manager/web/google/PreviewPage.vala"
	return;
#line 1268 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_reload_preview (FontManagerGoogleFontsPreviewPage* self)
{
	gchar* html = NULL;
	gchar* _tmp0_;
	FontManagerGoogleFontsFont* _tmp1_;
	GtkMenuButton* _tmp20_;
	FontManagerPreviewPageMode _tmp21_;
	GtkRevealer* _tmp22_;
	FontManagerPreviewPageMode _tmp23_;
	FontManagerPreviewControls* _tmp24_;
	const gchar* _tmp25_;
	GtkRevealer* _tmp26_;
	FontManagerPreviewPageMode _tmp27_;
	FontManagerPreviewEntry* _tmp28_;
	FontManagerPreviewPageMode _tmp29_;
	WebKitWebView* _tmp30_;
	const gchar* _tmp31_;
#line 315 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 316 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = g_strdup ("<html><body><p> </p></body></html>");
#line 316 "../src/font-manager/web/google/PreviewPage.vala"
	html = _tmp0_;
#line 317 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = self->priv->font;
#line 317 "../src/font-manager/web/google/PreviewPage.vala"
	if (_tmp1_ != NULL) {
#line 1299 "PreviewPage.c"
		FontManagerPreviewPageMode _tmp2_;
		FontManagerGoogleFontsSampleList* _tmp6_;
		FontManagerGoogleFontsFont* _tmp7_;
		FontManagerStringSet* _tmp8_;
		FontManagerStringSet* _tmp9_;
		gchar* description = NULL;
		FontManagerGoogleFontsFont* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		FontManagerGoogleFontsFont* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		FontManagerPreviewControls* _tmp18_;
		const gchar* _tmp19_;
#line 318 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp2_ = self->priv->_preview_mode;
#line 318 "../src/font-manager/web/google/PreviewPage.vala"
		switch (_tmp2_) {
#line 318 "../src/font-manager/web/google/PreviewPage.vala"
			case FONT_MANAGER_PREVIEW_PAGE_MODE_WATERFALL:
#line 1322 "PreviewPage.c"
			{
				gchar* _tmp3_;
#line 320 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp3_ = font_manager_google_fonts_preview_page_generate_waterfall (self);
#line 320 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (html);
#line 320 "../src/font-manager/web/google/PreviewPage.vala"
				html = _tmp3_;
#line 321 "../src/font-manager/web/google/PreviewPage.vala"
				break;
#line 1333 "PreviewPage.c"
			}
#line 318 "../src/font-manager/web/google/PreviewPage.vala"
			case FONT_MANAGER_PREVIEW_PAGE_MODE_LOREM_IPSUM:
#line 1337 "PreviewPage.c"
			{
				gchar* _tmp4_;
#line 323 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp4_ = font_manager_google_fonts_preview_page_generate_lorem_ipsum (self);
#line 323 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (html);
#line 323 "../src/font-manager/web/google/PreviewPage.vala"
				html = _tmp4_;
#line 324 "../src/font-manager/web/google/PreviewPage.vala"
				break;
#line 1348 "PreviewPage.c"
			}
#line 318 "../src/font-manager/web/google/PreviewPage.vala"
			case FONT_MANAGER_PREVIEW_PAGE_MODE_PREVIEW:
#line 1352 "PreviewPage.c"
			{
				gchar* _tmp5_;
#line 326 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp5_ = font_manager_google_fonts_preview_page_generate_active_preview (self);
#line 326 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (html);
#line 326 "../src/font-manager/web/google/PreviewPage.vala"
				html = _tmp5_;
#line 327 "../src/font-manager/web/google/PreviewPage.vala"
				break;
#line 1363 "PreviewPage.c"
			}
			default:
			{
#line 329 "../src/font-manager/web/google/PreviewPage.vala"
				g_assert_not_reached ();
#line 1369 "PreviewPage.c"
			}
		}
#line 331 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp6_ = self->priv->samples;
#line 331 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp7_ = self->priv->font;
#line 331 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp8_ = font_manager_google_fonts_font_get_subsets (_tmp7_);
#line 331 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp9_ = _tmp8_;
#line 331 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_sample_list_set_items (_tmp6_, _tmp9_);
#line 332 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp10_ = self->priv->font;
#line 332 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp11_ = font_manager_google_fonts_font_get_family (_tmp10_);
#line 332 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp12_ = _tmp11_;
#line 332 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp13_ = self->priv->font;
#line 332 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp14_ = font_manager_google_fonts_font_to_display_name (_tmp13_);
#line 332 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp15_ = _tmp14_;
#line 332 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp16_ = g_strdup_printf ("%s %s", _tmp12_, _tmp15_);
#line 332 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp17_ = _tmp16_;
#line 332 "../src/font-manager/web/google/PreviewPage.vala"
		_g_free0 (_tmp15_);
#line 332 "../src/font-manager/web/google/PreviewPage.vala"
		description = _tmp17_;
#line 333 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp18_ = self->priv->preview_controls;
#line 333 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp19_ = description;
#line 333 "../src/font-manager/web/google/PreviewPage.vala"
		g_object_set (_tmp18_, "description", _tmp19_, NULL);
#line 317 "../src/font-manager/web/google/PreviewPage.vala"
		_g_free0 (description);
#line 1410 "PreviewPage.c"
	}
#line 335 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp20_ = self->priv->sample_button;
#line 335 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp21_ = self->priv->_preview_mode;
#line 335 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp20_, _tmp21_ != FONT_MANAGER_PREVIEW_PAGE_MODE_LOREM_IPSUM);
#line 336 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp22_ = self->priv->controls_revealer;
#line 336 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp23_ = self->priv->_preview_mode;
#line 336 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_revealer_set_reveal_child (_tmp22_, _tmp23_ == FONT_MANAGER_PREVIEW_PAGE_MODE_PREVIEW);
#line 337 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp24_ = self->priv->preview_controls;
#line 337 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp25_ = self->priv->active_preview_text;
#line 337 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_set (_tmp24_, "undo-available", g_strcmp0 (_tmp25_, DEFAULT_ACTIVE_TEXT) != 0, NULL);
#line 338 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp26_ = self->priv->fontscale_revealer;
#line 338 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp27_ = self->priv->_preview_mode;
#line 338 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_revealer_set_reveal_child (_tmp26_, _tmp27_ != FONT_MANAGER_PREVIEW_PAGE_MODE_WATERFALL);
#line 339 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp28_ = self->priv->entry;
#line 339 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp29_ = self->priv->_preview_mode;
#line 339 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp28_, _tmp29_ == FONT_MANAGER_PREVIEW_PAGE_MODE_WATERFALL);
#line 340 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp30_ = self->priv->webview;
#line 340 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp31_ = html;
#line 340 "../src/font-manager/web/google/PreviewPage.vala"
	webkit_web_view_load_html (_tmp30_, _tmp31_, NULL);
#line 341 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (html);
#line 341 "../src/font-manager/web/google/PreviewPage.vala"
	return;
#line 1452 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_on_item_selected (FontManagerGoogleFontsPreviewPage* self)
{
	GObject* _tmp0_;
	guint langs = 0U;
	FontManagerGoogleFontsSampleList* _tmp5_;
	FontManagerGoogleFontsSampleModel* _tmp6_;
	FontManagerGoogleFontsSampleModel* _tmp7_;
	GtkMenuButton* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
#line 344 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 345 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->_selected_item;
#line 345 "../src/font-manager/web/google/PreviewPage.vala"
	if (FONT_MANAGER_GOOGLE_FONTS_IS_FAMILY (_tmp0_)) {
#line 1472 "PreviewPage.c"
		GObject* _tmp1_;
		FontManagerGoogleFontsFont* _tmp2_;
#line 346 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp1_ = self->priv->_selected_item;
#line 346 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp2_ = font_manager_google_fonts_family_get_default_variant (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamily));
#line 346 "../src/font-manager/web/google/PreviewPage.vala"
		_g_object_unref0 (self->priv->font);
#line 346 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->font = _tmp2_;
#line 1483 "PreviewPage.c"
	} else {
		GObject* _tmp3_;
		FontManagerGoogleFontsFont* _tmp4_;
#line 348 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp3_ = self->priv->_selected_item;
#line 348 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFont));
#line 348 "../src/font-manager/web/google/PreviewPage.vala"
		_g_object_unref0 (self->priv->font);
#line 348 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->font = _tmp4_;
#line 1495 "PreviewPage.c"
	}
#line 349 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_reload_preview (self);
#line 350 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_ = self->priv->samples;
#line 350 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp6_ = font_manager_google_fonts_sample_list_get_model (_tmp5_);
#line 350 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp7_ = _tmp6_;
#line 350 "../src/font-manager/web/google/PreviewPage.vala"
	langs = g_list_model_get_n_items ((GListModel*) _tmp7_);
#line 351 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp8_ = self->priv->sample_button;
#line 351 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp9_ = g_strdup_printf (ngettext ("%i Language Sample Available ", "%i Language Samples Available", (gulong) langs), (gint) langs);
#line 351 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp10_ = _tmp9_;
#line 351 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp8_, _tmp10_);
#line 351 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (_tmp10_);
#line 356 "../src/font-manager/web/google/PreviewPage.vala"
	return;
#line 1519 "PreviewPage.c"
}

static gdouble
font_manager_google_fonts_preview_page_get_next_line_size (FontManagerGoogleFontsPreviewPage* self,
                                                           gdouble current)
{
	gdouble _tmp0_;
	gdouble next = 0.0;
	gdouble _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_;
	gdouble result;
#line 359 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 360 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->_waterfall_size_ratio;
#line 360 "../src/font-manager/web/google/PreviewPage.vala"
	if (_tmp0_ <= 1.0) {
#line 361 "../src/font-manager/web/google/PreviewPage.vala"
		result = current + 1.0;
#line 361 "../src/font-manager/web/google/PreviewPage.vala"
		return result;
#line 1542 "PreviewPage.c"
	}
#line 362 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = self->priv->_waterfall_size_ratio;
#line 362 "../src/font-manager/web/google/PreviewPage.vala"
	next = current * _tmp1_;
#line 363 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = self->priv->_waterfall_size_ratio;
#line 363 "../src/font-manager/web/google/PreviewPage.vala"
	if (_tmp3_ > 1.1) {
#line 363 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp2_ = floor (next);
#line 1554 "PreviewPage.c"
	} else {
#line 363 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp2_ = ceil (next);
#line 1558 "PreviewPage.c"
	}
#line 363 "../src/font-manager/web/google/PreviewPage.vala"
	result = _tmp2_;
#line 363 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 1564 "PreviewPage.c"
}

static gchar*
font_manager_google_fonts_preview_page_get_current_header (FontManagerGoogleFontsPreviewPage* self)
{
	FontManagerGoogleFontsFont* _tmp0_;
	gchar* justify = NULL;
	gchar* _tmp1_;
	PangoContext* ctx = NULL;
	FontManagerPreviewEntry* _tmp2_;
	PangoContext* _tmp3_;
	PangoContext* _tmp4_;
	PangoDirection dir = 0;
	PangoContext* _tmp5_;
	FontManagerPreviewPageMode _tmp6_;
	const gchar* _tmp11_ = NULL;
	FontManagerPreviewColors* _tmp12_;
	GdkRGBA _tmp13_ = {0};
	GdkRGBA _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	FontManagerPreviewColors* _tmp17_;
	GdkRGBA _tmp18_ = {0};
	GdkRGBA _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	const gchar* _tmp22_;
	gdouble _tmp23_;
	FontManagerGoogleFontsFont* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	FontManagerGoogleFontsFont* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	FontManagerGoogleFontsFont* _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	FontManagerGoogleFontsFont* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* result;
#line 366 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 366 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->font;
#line 366 "../src/font-manager/web/google/PreviewPage.vala"
	_vala_return_val_if_fail (_tmp0_ != NULL, "font != null", NULL);
#line 368 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = g_strdup ("justify");
#line 368 "../src/font-manager/web/google/PreviewPage.vala"
	justify = _tmp1_;
#line 369 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp2_ = self->priv->entry;
#line 369 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = gtk_widget_get_pango_context ((GtkWidget*) _tmp2_);
#line 369 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 369 "../src/font-manager/web/google/PreviewPage.vala"
	ctx = _tmp4_;
#line 370 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_ = ctx;
#line 370 "../src/font-manager/web/google/PreviewPage.vala"
	dir = pango_context_get_base_dir (_tmp5_);
#line 371 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp6_ = self->priv->_preview_mode;
#line 371 "../src/font-manager/web/google/PreviewPage.vala"
	if (_tmp6_ == FONT_MANAGER_PREVIEW_PAGE_MODE_PREVIEW) {
#line 1634 "PreviewPage.c"
		GtkJustification _tmp7_;
#line 372 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp7_ = self->priv->_justification;
#line 372 "../src/font-manager/web/google/PreviewPage.vala"
		switch (_tmp7_) {
#line 372 "../src/font-manager/web/google/PreviewPage.vala"
			case GTK_JUSTIFY_LEFT:
#line 1642 "PreviewPage.c"
			{
				gchar* _tmp8_;
#line 374 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp8_ = g_strdup ("left");
#line 374 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (justify);
#line 374 "../src/font-manager/web/google/PreviewPage.vala"
				justify = _tmp8_;
#line 375 "../src/font-manager/web/google/PreviewPage.vala"
				break;
#line 1653 "PreviewPage.c"
			}
#line 372 "../src/font-manager/web/google/PreviewPage.vala"
			case GTK_JUSTIFY_CENTER:
#line 1657 "PreviewPage.c"
			{
				gchar* _tmp9_;
#line 377 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp9_ = g_strdup ("center");
#line 377 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (justify);
#line 377 "../src/font-manager/web/google/PreviewPage.vala"
				justify = _tmp9_;
#line 378 "../src/font-manager/web/google/PreviewPage.vala"
				break;
#line 1668 "PreviewPage.c"
			}
#line 372 "../src/font-manager/web/google/PreviewPage.vala"
			case GTK_JUSTIFY_RIGHT:
#line 1672 "PreviewPage.c"
			{
				gchar* _tmp10_;
#line 380 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp10_ = g_strdup ("right");
#line 380 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (justify);
#line 380 "../src/font-manager/web/google/PreviewPage.vala"
				justify = _tmp10_;
#line 381 "../src/font-manager/web/google/PreviewPage.vala"
				break;
#line 1683 "PreviewPage.c"
			}
			default:
			{
#line 383 "../src/font-manager/web/google/PreviewPage.vala"
				break;
#line 1689 "PreviewPage.c"
			}
		}
	}
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	if (dir == PANGO_DIRECTION_RTL) {
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp11_ = "rtl";
#line 1697 "PreviewPage.c"
	} else {
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp11_ = "ltr";
#line 1701 "PreviewPage.c"
	}
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp12_ = self->priv->preview_colors;
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_preview_colors_get_foreground_color (_tmp12_, &_tmp13_);
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp14_ = _tmp13_;
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp15_ = gdk_rgba_to_string (&_tmp14_);
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp16_ = _tmp15_;
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp17_ = self->priv->preview_colors;
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_preview_colors_get_background_color (_tmp17_, &_tmp18_);
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp19_ = _tmp18_;
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp20_ = gdk_rgba_to_string (&_tmp19_);
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp21_ = _tmp20_;
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp22_ = justify;
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp23_ = self->priv->_preview_size;
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp24_ = self->priv->font;
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp25_ = font_manager_google_fonts_font_get_family (_tmp24_);
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp26_ = _tmp25_;
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp27_ = self->priv->font;
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp28_ = font_manager_google_fonts_font_get_style (_tmp27_);
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp29_ = _tmp28_;
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp30_ = self->priv->font;
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp31_ = font_manager_google_fonts_font_get_weight (_tmp30_);
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp32_ = _tmp31_;
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp33_ = self->priv->font;
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp34_ = font_manager_google_fonts_font_to_font_face_rule (_tmp33_);
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp35_ = _tmp34_;
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp36_ = g_strdup_printf (HEADER, _tmp11_, _tmp16_, _tmp21_, _tmp22_, _tmp23_, _tmp26_, _tmp29_, _tmp32_, _tmp35_);
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp37_ = _tmp36_;
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (_tmp35_);
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (_tmp21_);
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (_tmp16_);
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	result = _tmp37_;
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (ctx);
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (justify);
#line 386 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 1769 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_update_waterfall_body (FontManagerGoogleFontsPreviewPage* self)
{
	GString* builder = NULL;
	GString* _tmp0_;
	GString* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
#line 396 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 397 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = g_string_new ("");
#line 397 "../src/font-manager/web/google/PreviewPage.vala"
	builder = _tmp0_;
#line 1786 "PreviewPage.c"
	{
		gdouble i = 0.0;
		gdouble _tmp1_;
#line 398 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp1_ = self->priv->_min_waterfall_size;
#line 398 "../src/font-manager/web/google/PreviewPage.vala"
		i = _tmp1_;
#line 1794 "PreviewPage.c"
		{
			gboolean _tmp2_ = FALSE;
#line 398 "../src/font-manager/web/google/PreviewPage.vala"
			_tmp2_ = TRUE;
#line 398 "../src/font-manager/web/google/PreviewPage.vala"
			while (TRUE) {
#line 1801 "PreviewPage.c"
				gdouble _tmp3_;
				gchar* pixels = NULL;
				gchar* _tmp4_;
				gboolean _tmp5_;
				GString* _tmp10_;
				const gchar* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
#line 398 "../src/font-manager/web/google/PreviewPage.vala"
				if (!_tmp2_) {
#line 400 "../src/font-manager/web/google/PreviewPage.vala"
					i = font_manager_google_fonts_preview_page_get_next_line_size (self, i);
#line 1816 "PreviewPage.c"
				}
#line 398 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp2_ = FALSE;
#line 399 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp3_ = self->priv->_max_waterfall_size;
#line 399 "../src/font-manager/web/google/PreviewPage.vala"
				if (!(i <= _tmp3_)) {
#line 399 "../src/font-manager/web/google/PreviewPage.vala"
					break;
#line 1826 "PreviewPage.c"
				}
#line 401 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp4_ = g_strdup ("&nbsp;");
#line 401 "../src/font-manager/web/google/PreviewPage.vala"
				pixels = _tmp4_;
#line 402 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp5_ = self->priv->_show_line_size;
#line 402 "../src/font-manager/web/google/PreviewPage.vala"
				if (_tmp5_) {
#line 1836 "PreviewPage.c"
					gchar* _tmp6_ = NULL;
					gchar* _tmp9_;
#line 403 "../src/font-manager/web/google/PreviewPage.vala"
					if (i < ((gdouble) 10)) {
#line 1841 "PreviewPage.c"
						gchar* _tmp7_;
#line 404 "../src/font-manager/web/google/PreviewPage.vala"
						_tmp7_ = g_strdup_printf ("&nbsp;&nbsp;%.0lfpx&nbsp", i);
#line 404 "../src/font-manager/web/google/PreviewPage.vala"
						_g_free0 (_tmp6_);
#line 404 "../src/font-manager/web/google/PreviewPage.vala"
						_tmp6_ = _tmp7_;
#line 1849 "PreviewPage.c"
					} else {
						gchar* _tmp8_;
#line 405 "../src/font-manager/web/google/PreviewPage.vala"
						_tmp8_ = g_strdup_printf ("&nbsp;%.0lfpx&nbsp;", i);
#line 405 "../src/font-manager/web/google/PreviewPage.vala"
						_g_free0 (_tmp6_);
#line 405 "../src/font-manager/web/google/PreviewPage.vala"
						_tmp6_ = _tmp8_;
#line 1858 "PreviewPage.c"
					}
#line 403 "../src/font-manager/web/google/PreviewPage.vala"
					_tmp9_ = g_strdup (_tmp6_);
#line 403 "../src/font-manager/web/google/PreviewPage.vala"
					_g_free0 (pixels);
#line 403 "../src/font-manager/web/google/PreviewPage.vala"
					pixels = _tmp9_;
#line 402 "../src/font-manager/web/google/PreviewPage.vala"
					_g_free0 (_tmp6_);
#line 1868 "PreviewPage.c"
				}
#line 406 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp10_ = builder;
#line 406 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp11_ = pixels;
#line 406 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp12_ = font_manager_google_fonts_preview_page_get_preview_text (self);
#line 406 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp13_ = _tmp12_;
#line 406 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp14_ = g_strdup_printf (WATERFALL_ROW, i, _tmp11_, i, _tmp13_);
#line 406 "../src/font-manager/web/google/PreviewPage.vala"
				_tmp15_ = _tmp14_;
#line 406 "../src/font-manager/web/google/PreviewPage.vala"
				g_string_append (_tmp10_, _tmp15_);
#line 406 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (_tmp15_);
#line 398 "../src/font-manager/web/google/PreviewPage.vala"
				_g_free0 (pixels);
#line 1888 "PreviewPage.c"
			}
		}
	}
#line 408 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp16_ = builder;
#line 408 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp17_ = _tmp16_->str;
#line 408 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp18_ = g_strdup (_tmp17_);
#line 408 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (self->priv->waterfall_body);
#line 408 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->waterfall_body = _tmp18_;
#line 409 "../src/font-manager/web/google/PreviewPage.vala"
	_g_string_free0 (builder);
#line 409 "../src/font-manager/web/google/PreviewPage.vala"
	return;
#line 1906 "PreviewPage.c"
}

static gchar*
font_manager_google_fonts_preview_page_generate_active_preview (FontManagerGoogleFontsPreviewPage* self)
{
	FontManagerGoogleFontsFont* _tmp0_;
	GString* builder = NULL;
	GString* _tmp1_;
	GString* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_ = NULL;
	WebKitWebView* _tmp6_;
	gchar* html = NULL;
	gchar* _tmp7_;
	const gchar* _tmp8_ = NULL;
	const gchar* _tmp9_;
	gchar* text = NULL;
	gchar* _tmp13_;
	GString* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GString* _tmp18_;
	GString* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* result;
#line 412 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 412 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->font;
#line 412 "../src/font-manager/web/google/PreviewPage.vala"
	_vala_return_val_if_fail (_tmp0_ != NULL, "font != null", NULL);
#line 414 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = g_string_new ("");
#line 414 "../src/font-manager/web/google/PreviewPage.vala"
	builder = _tmp1_;
#line 415 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp2_ = builder;
#line 415 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = font_manager_google_fonts_preview_page_get_current_header (self);
#line 415 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp4_ = _tmp3_;
#line 415 "../src/font-manager/web/google/PreviewPage.vala"
	g_string_append (_tmp2_, _tmp4_);
#line 415 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (_tmp4_);
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp6_ = self->priv->webview;
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	if (webkit_web_view_is_editable (_tmp6_)) {
#line 417 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp5_ = EDITABLE_PREVIEW;
#line 1961 "PreviewPage.c"
	} else {
#line 418 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp5_ = ACTIVE_PREVIEW;
#line 1965 "PreviewPage.c"
	}
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp7_ = g_strdup (_tmp5_);
#line 416 "../src/font-manager/web/google/PreviewPage.vala"
	html = _tmp7_;
#line 419 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp9_ = self->priv->active_preview_text;
#line 419 "../src/font-manager/web/google/PreviewPage.vala"
	if (_tmp9_ != NULL) {
#line 1975 "PreviewPage.c"
		const gchar* _tmp10_;
#line 420 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp10_ = self->priv->active_preview_text;
#line 420 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp8_ = _tmp10_;
#line 1981 "PreviewPage.c"
	} else {
		const gchar* _tmp11_ = NULL;
		WebKitWebView* _tmp12_;
#line 421 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp12_ = self->priv->webview;
#line 421 "../src/font-manager/web/google/PreviewPage.vala"
		if (webkit_web_view_is_editable (_tmp12_)) {
#line 422 "../src/font-manager/web/google/PreviewPage.vala"
			_tmp11_ = "";
#line 1991 "PreviewPage.c"
		} else {
#line 423 "../src/font-manager/web/google/PreviewPage.vala"
			_tmp11_ = DEFAULT_ACTIVE_TEXT;
#line 1995 "PreviewPage.c"
		}
#line 421 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp8_ = _tmp11_;
#line 1999 "PreviewPage.c"
	}
#line 419 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp13_ = g_strdup (_tmp8_);
#line 419 "../src/font-manager/web/google/PreviewPage.vala"
	text = _tmp13_;
#line 424 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp14_ = builder;
#line 424 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp15_ = html;
#line 424 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp16_ = g_strdup_printf (_tmp15_, text);
#line 424 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp17_ = _tmp16_;
#line 424 "../src/font-manager/web/google/PreviewPage.vala"
	g_string_append (_tmp14_, _tmp17_);
#line 424 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (_tmp17_);
#line 425 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp18_ = builder;
#line 425 "../src/font-manager/web/google/PreviewPage.vala"
	g_string_append (_tmp18_, FOOTER);
#line 426 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp19_ = builder;
#line 426 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp20_ = _tmp19_->str;
#line 426 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp21_ = g_strdup (_tmp20_);
#line 426 "../src/font-manager/web/google/PreviewPage.vala"
	result = _tmp21_;
#line 426 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (text);
#line 426 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (html);
#line 426 "../src/font-manager/web/google/PreviewPage.vala"
	_g_string_free0 (builder);
#line 426 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2037 "PreviewPage.c"
}

static gchar*
font_manager_google_fonts_preview_page_generate_waterfall (FontManagerGoogleFontsPreviewPage* self)
{
	FontManagerGoogleFontsFont* _tmp0_;
	GString* builder = NULL;
	GString* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* result;
#line 429 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 429 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->font;
#line 429 "../src/font-manager/web/google/PreviewPage.vala"
	_vala_return_val_if_fail (_tmp0_ != NULL, "font != null", NULL);
#line 431 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = g_string_new ("");
#line 431 "../src/font-manager/web/google/PreviewPage.vala"
	builder = _tmp1_;
#line 432 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp2_ = font_manager_google_fonts_preview_page_get_current_header (self);
#line 432 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = _tmp2_;
#line 432 "../src/font-manager/web/google/PreviewPage.vala"
	g_string_append (builder, _tmp3_);
#line 432 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (_tmp3_);
#line 433 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp4_ = self->priv->waterfall_body;
#line 433 "../src/font-manager/web/google/PreviewPage.vala"
	g_string_append (builder, _tmp4_);
#line 434 "../src/font-manager/web/google/PreviewPage.vala"
	g_string_append (builder, FOOTER);
#line 435 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_ = builder->str;
#line 435 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 435 "../src/font-manager/web/google/PreviewPage.vala"
	result = _tmp6_;
#line 435 "../src/font-manager/web/google/PreviewPage.vala"
	_g_string_free0 (builder);
#line 435 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2086 "PreviewPage.c"
}

static gchar*
font_manager_google_fonts_preview_page_generate_lorem_ipsum (FontManagerGoogleFontsPreviewPage* self)
{
	FontManagerGoogleFontsFont* _tmp0_;
	GString* builder = NULL;
	GString* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* pref_loc = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* result;
#line 438 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 438 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->font;
#line 438 "../src/font-manager/web/google/PreviewPage.vala"
	_vala_return_val_if_fail (_tmp0_ != NULL, "font != null", NULL);
#line 440 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = g_string_new ("");
#line 440 "../src/font-manager/web/google/PreviewPage.vala"
	builder = _tmp1_;
#line 441 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp2_ = font_manager_google_fonts_preview_page_get_current_header (self);
#line 441 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = _tmp2_;
#line 441 "../src/font-manager/web/google/PreviewPage.vala"
	g_string_append (builder, _tmp3_);
#line 441 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (_tmp3_);
#line 442 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp4_ = setlocale (LC_ALL, "");
#line 442 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 442 "../src/font-manager/web/google/PreviewPage.vala"
	pref_loc = _tmp5_;
#line 443 "../src/font-manager/web/google/PreviewPage.vala"
	setlocale (LC_ALL, "C");
#line 444 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp6_ = g_strdup_printf (BODY_TEXT, FONT_MANAGER_LOREM_IPSUM);
#line 444 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp7_ = _tmp6_;
#line 444 "../src/font-manager/web/google/PreviewPage.vala"
	g_string_append (builder, _tmp7_);
#line 444 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (_tmp7_);
#line 445 "../src/font-manager/web/google/PreviewPage.vala"
	setlocale (LC_ALL, pref_loc);
#line 446 "../src/font-manager/web/google/PreviewPage.vala"
	g_string_append (builder, FOOTER);
#line 447 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp8_ = builder->str;
#line 447 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 447 "../src/font-manager/web/google/PreviewPage.vala"
	result = _tmp9_;
#line 447 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (pref_loc);
#line 447 "../src/font-manager/web/google/PreviewPage.vala"
	_g_string_free0 (builder);
#line 447 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2155 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_on_show_context_menu (FontManagerGoogleFontsPreviewPage* self,
                                                             gint n_press,
                                                             gdouble x,
                                                             gdouble y)
{
	gboolean _tmp0_ = FALSE;
	FontManagerWaterfallSettings* _tmp1_;
	FontManagerWaterfallSettings* _tmp3_;
	GtkPopoverMenu* _tmp4_;
	GtkPopoverMenu* _tmp5_;
	GtkWidget* _tmp6_;
	FontManagerWaterfallSettings* _tmp10_;
	GtkPopoverMenu* _tmp11_;
	GtkPopoverMenu* _tmp12_;
	WebKitWebView* _tmp13_;
	FontManagerWaterfallSettings* _tmp14_;
	GtkPopoverMenu* _tmp15_;
	GtkPopoverMenu* _tmp16_;
	GdkRectangle _tmp17_;
	FontManagerWaterfallSettings* _tmp18_;
	GtkPopoverMenu* _tmp19_;
	GtkPopoverMenu* _tmp20_;
#line 450 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 451 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = self->priv->_waterfall_settings;
#line 451 "../src/font-manager/web/google/PreviewPage.vala"
	if (_tmp1_ == NULL) {
#line 451 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp0_ = TRUE;
#line 2189 "PreviewPage.c"
	} else {
		FontManagerPreviewPageMode _tmp2_;
#line 451 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp2_ = self->priv->_preview_mode;
#line 451 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp0_ = _tmp2_ != FONT_MANAGER_PREVIEW_PAGE_MODE_WATERFALL;
#line 2196 "PreviewPage.c"
	}
#line 451 "../src/font-manager/web/google/PreviewPage.vala"
	if (_tmp0_) {
#line 452 "../src/font-manager/web/google/PreviewPage.vala"
		return;
#line 2202 "PreviewPage.c"
	}
#line 453 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->clicked_area.x = (gint) x;
#line 454 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->clicked_area.y = (gint) y;
#line 455 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->clicked_area.width = 2;
#line 456 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->clicked_area.height = 2;
#line 457 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = self->priv->_waterfall_settings;
#line 457 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp4_ = font_manager_waterfall_settings_get_context_menu (_tmp3_);
#line 457 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_ = _tmp4_;
#line 457 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp6_ = gtk_widget_get_parent ((GtkWidget*) _tmp5_);
#line 457 "../src/font-manager/web/google/PreviewPage.vala"
	if (_tmp6_ != NULL) {
#line 2222 "PreviewPage.c"
		FontManagerWaterfallSettings* _tmp7_;
		GtkPopoverMenu* _tmp8_;
		GtkPopoverMenu* _tmp9_;
#line 458 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp7_ = self->priv->_waterfall_settings;
#line 458 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp8_ = font_manager_waterfall_settings_get_context_menu (_tmp7_);
#line 458 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp9_ = _tmp8_;
#line 458 "../src/font-manager/web/google/PreviewPage.vala"
		gtk_widget_unparent ((GtkWidget*) _tmp9_);
#line 2234 "PreviewPage.c"
	}
#line 459 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp10_ = self->priv->_waterfall_settings;
#line 459 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp11_ = font_manager_waterfall_settings_get_context_menu (_tmp10_);
#line 459 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp12_ = _tmp11_;
#line 459 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp13_ = self->priv->webview;
#line 459 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp12_, (GtkWidget*) _tmp13_);
#line 460 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp14_ = self->priv->_waterfall_settings;
#line 460 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp15_ = font_manager_waterfall_settings_get_context_menu (_tmp14_);
#line 460 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp16_ = _tmp15_;
#line 460 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp17_ = self->priv->clicked_area;
#line 460 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_popover_set_pointing_to ((GtkPopover*) _tmp16_, &_tmp17_);
#line 461 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp18_ = self->priv->_waterfall_settings;
#line 461 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp19_ = font_manager_waterfall_settings_get_context_menu (_tmp18_);
#line 461 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp20_ = _tmp19_;
#line 461 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_popover_popup ((GtkPopover*) _tmp20_);
#line 462 "../src/font-manager/web/google/PreviewPage.vala"
	return;
#line 2266 "PreviewPage.c"
}

gint
font_manager_google_fonts_preview_page_get_predefined_size (FontManagerGoogleFontsPreviewPage* self)
{
	gint result;
#line 146 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 146 "../src/font-manager/web/google/PreviewPage.vala"
	result = self->priv->_predefined_size;
#line 146 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2279 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_predefined_size (FontManagerGoogleFontsPreviewPage* self,
                                                            gint value)
{
	gint old_value;
#line 146 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 146 "../src/font-manager/web/google/PreviewPage.vala"
	old_value = font_manager_google_fonts_preview_page_get_predefined_size (self);
#line 146 "../src/font-manager/web/google/PreviewPage.vala"
	if (old_value != value) {
#line 146 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->_predefined_size = value;
#line 146 "../src/font-manager/web/google/PreviewPage.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREDEFINED_SIZE_PROPERTY]);
#line 2297 "PreviewPage.c"
	}
}

gboolean
font_manager_google_fonts_preview_page_get_show_line_size (FontManagerGoogleFontsPreviewPage* self)
{
	gboolean result;
#line 147 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 147 "../src/font-manager/web/google/PreviewPage.vala"
	result = self->priv->_show_line_size;
#line 147 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2311 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_show_line_size (FontManagerGoogleFontsPreviewPage* self,
                                                           gboolean value)
{
	gboolean old_value;
#line 147 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 147 "../src/font-manager/web/google/PreviewPage.vala"
	old_value = font_manager_google_fonts_preview_page_get_show_line_size (self);
#line 147 "../src/font-manager/web/google/PreviewPage.vala"
	if (old_value != value) {
#line 147 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->_show_line_size = value;
#line 147 "../src/font-manager/web/google/PreviewPage.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SHOW_LINE_SIZE_PROPERTY]);
#line 2329 "PreviewPage.c"
	}
}

gdouble
font_manager_google_fonts_preview_page_get_preview_size (FontManagerGoogleFontsPreviewPage* self)
{
	gdouble result;
#line 148 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 148 "../src/font-manager/web/google/PreviewPage.vala"
	result = self->priv->_preview_size;
#line 148 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2343 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_preview_size (FontManagerGoogleFontsPreviewPage* self,
                                                         gdouble value)
{
	gdouble old_value;
#line 148 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/font-manager/web/google/PreviewPage.vala"
	old_value = font_manager_google_fonts_preview_page_get_preview_size (self);
#line 148 "../src/font-manager/web/google/PreviewPage.vala"
	if (old_value != value) {
#line 148 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->_preview_size = value;
#line 148 "../src/font-manager/web/google/PreviewPage.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_SIZE_PROPERTY]);
#line 2361 "PreviewPage.c"
	}
}

gdouble
font_manager_google_fonts_preview_page_get_min_waterfall_size (FontManagerGoogleFontsPreviewPage* self)
{
	gdouble result;
#line 149 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 149 "../src/font-manager/web/google/PreviewPage.vala"
	result = self->priv->_min_waterfall_size;
#line 149 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2375 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_min_waterfall_size (FontManagerGoogleFontsPreviewPage* self,
                                                               gdouble value)
{
	gdouble old_value;
#line 149 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 149 "../src/font-manager/web/google/PreviewPage.vala"
	old_value = font_manager_google_fonts_preview_page_get_min_waterfall_size (self);
#line 149 "../src/font-manager/web/google/PreviewPage.vala"
	if (old_value != value) {
#line 149 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->_min_waterfall_size = value;
#line 149 "../src/font-manager/web/google/PreviewPage.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MIN_WATERFALL_SIZE_PROPERTY]);
#line 2393 "PreviewPage.c"
	}
}

gdouble
font_manager_google_fonts_preview_page_get_max_waterfall_size (FontManagerGoogleFontsPreviewPage* self)
{
	gdouble result;
#line 150 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 150 "../src/font-manager/web/google/PreviewPage.vala"
	result = self->priv->_max_waterfall_size;
#line 150 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2407 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_max_waterfall_size (FontManagerGoogleFontsPreviewPage* self,
                                                               gdouble value)
{
	gdouble old_value;
#line 150 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 150 "../src/font-manager/web/google/PreviewPage.vala"
	old_value = font_manager_google_fonts_preview_page_get_max_waterfall_size (self);
#line 150 "../src/font-manager/web/google/PreviewPage.vala"
	if (old_value != value) {
#line 150 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->_max_waterfall_size = value;
#line 150 "../src/font-manager/web/google/PreviewPage.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MAX_WATERFALL_SIZE_PROPERTY]);
#line 2425 "PreviewPage.c"
	}
}

gdouble
font_manager_google_fonts_preview_page_get_waterfall_size_ratio (FontManagerGoogleFontsPreviewPage* self)
{
	gdouble result;
#line 151 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 151 "../src/font-manager/web/google/PreviewPage.vala"
	result = self->priv->_waterfall_size_ratio;
#line 151 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2439 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_waterfall_size_ratio (FontManagerGoogleFontsPreviewPage* self,
                                                                 gdouble value)
{
	gdouble old_value;
#line 151 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/font-manager/web/google/PreviewPage.vala"
	old_value = font_manager_google_fonts_preview_page_get_waterfall_size_ratio (self);
#line 151 "../src/font-manager/web/google/PreviewPage.vala"
	if (old_value != value) {
#line 151 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->_waterfall_size_ratio = value;
#line 151 "../src/font-manager/web/google/PreviewPage.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SIZE_RATIO_PROPERTY]);
#line 2457 "PreviewPage.c"
	}
}

GObject*
font_manager_google_fonts_preview_page_get_selected_item (FontManagerGoogleFontsPreviewPage* self)
{
	GObject* result;
	GObject* _tmp0_;
#line 152 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 152 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->_selected_item;
#line 152 "../src/font-manager/web/google/PreviewPage.vala"
	result = _tmp0_;
#line 152 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2474 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_selected_item (FontManagerGoogleFontsPreviewPage* self,
                                                          GObject* value)
{
	GObject* old_value;
#line 152 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 152 "../src/font-manager/web/google/PreviewPage.vala"
	old_value = font_manager_google_fonts_preview_page_get_selected_item (self);
#line 152 "../src/font-manager/web/google/PreviewPage.vala"
	if (old_value != value) {
#line 2488 "PreviewPage.c"
		GObject* _tmp0_;
#line 152 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 152 "../src/font-manager/web/google/PreviewPage.vala"
		_g_object_unref0 (self->priv->_selected_item);
#line 152 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->_selected_item = _tmp0_;
#line 152 "../src/font-manager/web/google/PreviewPage.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SELECTED_ITEM_PROPERTY]);
#line 2498 "PreviewPage.c"
	}
}

GtkJustification
font_manager_google_fonts_preview_page_get_justification (FontManagerGoogleFontsPreviewPage* self)
{
	GtkJustification result;
#line 153 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 153 "../src/font-manager/web/google/PreviewPage.vala"
	result = self->priv->_justification;
#line 153 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2512 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_justification (FontManagerGoogleFontsPreviewPage* self,
                                                          GtkJustification value)
{
	GtkJustification old_value;
#line 153 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 153 "../src/font-manager/web/google/PreviewPage.vala"
	old_value = font_manager_google_fonts_preview_page_get_justification (self);
#line 153 "../src/font-manager/web/google/PreviewPage.vala"
	if (old_value != value) {
#line 153 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->_justification = value;
#line 153 "../src/font-manager/web/google/PreviewPage.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_JUSTIFICATION_PROPERTY]);
#line 2530 "PreviewPage.c"
	}
}

FontManagerPreviewPageMode
font_manager_google_fonts_preview_page_get_preview_mode (FontManagerGoogleFontsPreviewPage* self)
{
	FontManagerPreviewPageMode result;
#line 155 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 155 "../src/font-manager/web/google/PreviewPage.vala"
	result = self->priv->_preview_mode;
#line 155 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2544 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_preview_mode (FontManagerGoogleFontsPreviewPage* self,
                                                         FontManagerPreviewPageMode value)
{
	FontManagerPreviewPageMode old_value;
#line 155 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 155 "../src/font-manager/web/google/PreviewPage.vala"
	old_value = font_manager_google_fonts_preview_page_get_preview_mode (self);
#line 155 "../src/font-manager/web/google/PreviewPage.vala"
	if (old_value != value) {
#line 155 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->_preview_mode = value;
#line 155 "../src/font-manager/web/google/PreviewPage.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_MODE_PROPERTY]);
#line 2562 "PreviewPage.c"
	}
}

FontManagerWaterfallSettings*
font_manager_google_fonts_preview_page_get_waterfall_settings (FontManagerGoogleFontsPreviewPage* self)
{
	FontManagerWaterfallSettings* result;
	FontManagerWaterfallSettings* _tmp0_;
#line 156 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 156 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = self->priv->_waterfall_settings;
#line 156 "../src/font-manager/web/google/PreviewPage.vala"
	result = _tmp0_;
#line 156 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2579 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_waterfall_settings (FontManagerGoogleFontsPreviewPage* self,
                                                               FontManagerWaterfallSettings* value)
{
	FontManagerWaterfallSettings* old_value;
#line 156 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 156 "../src/font-manager/web/google/PreviewPage.vala"
	old_value = font_manager_google_fonts_preview_page_get_waterfall_settings (self);
#line 156 "../src/font-manager/web/google/PreviewPage.vala"
	if (old_value != value) {
#line 2593 "PreviewPage.c"
		FontManagerWaterfallSettings* _tmp0_;
#line 156 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 156 "../src/font-manager/web/google/PreviewPage.vala"
		_g_object_unref0 (self->priv->_waterfall_settings);
#line 156 "../src/font-manager/web/google/PreviewPage.vala"
		self->priv->_waterfall_settings = _tmp0_;
#line 156 "../src/font-manager/web/google/PreviewPage.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SETTINGS_PROPERTY]);
#line 2603 "PreviewPage.c"
	}
}

const gchar*
font_manager_google_fonts_preview_page_get_preview_text (FontManagerGoogleFontsPreviewPage* self)
{
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
#line 159 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 160 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = self->priv->_preview_text;
#line 160 "../src/font-manager/web/google/PreviewPage.vala"
	if (_tmp1_ != NULL) {
#line 2619 "PreviewPage.c"
		const gchar* _tmp2_;
#line 160 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp2_ = self->priv->_preview_text;
#line 160 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp0_ = _tmp2_;
#line 2625 "PreviewPage.c"
	} else {
		const gchar* _tmp3_;
#line 160 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp3_ = self->priv->default_pangram;
#line 160 "../src/font-manager/web/google/PreviewPage.vala"
		_tmp0_ = _tmp3_;
#line 2632 "PreviewPage.c"
	}
#line 160 "../src/font-manager/web/google/PreviewPage.vala"
	result = _tmp0_;
#line 160 "../src/font-manager/web/google/PreviewPage.vala"
	return result;
#line 2638 "PreviewPage.c"
}

void
font_manager_google_fonts_preview_page_set_preview_text (FontManagerGoogleFontsPreviewPage* self,
                                                         const gchar* value)
{
	gchar* _tmp0_;
#line 162 "../src/font-manager/web/google/PreviewPage.vala"
	g_return_if_fail (self != NULL);
#line 163 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = g_strdup (value);
#line 163 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (self->priv->_preview_text);
#line 163 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_preview_text = _tmp0_;
#line 162 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_TEXT_PROPERTY]);
#line 2656 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_class_init (FontManagerGoogleFontsPreviewPageClass * klass,
                                                   gpointer klass_data)
{
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	font_manager_google_fonts_preview_page_parent_class = g_type_class_peek_parent (klass);
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	g_type_class_adjust_private_offset (klass, &FontManagerGoogleFontsPreviewPage_private_offset);
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_google_fonts_preview_page_get_property;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_google_fonts_preview_page_set_property;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	G_OBJECT_CLASS (klass)->finalize = font_manager_google_fonts_preview_page_finalize;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREDEFINED_SIZE_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREDEFINED_SIZE_PROPERTY] = g_param_spec_int ("predefined-size", "predefined-size", "predefined-size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SHOW_LINE_SIZE_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SHOW_LINE_SIZE_PROPERTY] = g_param_spec_boolean ("show-line-size", "show-line-size", "show-line-size", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_SIZE_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_SIZE_PROPERTY] = g_param_spec_double ("preview-size", "preview-size", "preview-size", -G_MAXDOUBLE, G_MAXDOUBLE, 12.5, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MIN_WATERFALL_SIZE_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MIN_WATERFALL_SIZE_PROPERTY] = g_param_spec_double ("min-waterfall-size", "min-waterfall-size", "min-waterfall-size", -G_MAXDOUBLE, G_MAXDOUBLE, FONT_MANAGER_MIN_FONT_SIZE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MAX_WATERFALL_SIZE_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MAX_WATERFALL_SIZE_PROPERTY] = g_param_spec_double ("max-waterfall-size", "max-waterfall-size", "max-waterfall-size", -G_MAXDOUBLE, G_MAXDOUBLE, FONT_MANAGER_MAX_FONT_SIZE * 2, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SIZE_RATIO_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SIZE_RATIO_PROPERTY] = g_param_spec_double ("waterfall-size-ratio", "waterfall-size-ratio", "waterfall-size-ratio", -G_MAXDOUBLE, G_MAXDOUBLE, 1.1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SELECTED_ITEM_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SELECTED_ITEM_PROPERTY] = g_param_spec_object ("selected-item", "selected-item", "selected-item", G_TYPE_OBJECT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_JUSTIFICATION_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_JUSTIFICATION_PROPERTY] = g_param_spec_enum ("justification", "justification", "justification", gtk_justification_get_type (), GTK_JUSTIFY_CENTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_MODE_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_MODE_PROPERTY] = g_param_spec_enum ("preview-mode", "preview-mode", "preview-mode", font_manager_preview_page_mode_get_type (), FONT_MANAGER_PREVIEW_PAGE_MODE_WATERFALL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SETTINGS_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SETTINGS_PROPERTY] = g_param_spec_object ("waterfall-settings", "waterfall-settings", "waterfall-settings", FONT_MANAGER_TYPE_WATERFALL_SETTINGS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_TEXT_PROPERTY, font_manager_google_fonts_preview_page_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_TEXT_PROPERTY] = g_param_spec_string ("preview-text", "preview-text", "preview-text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/github/FontManager/FontManager/web/google/ui/google-fonts-preview-page.ui");
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "controls", FALSE, FontManagerGoogleFontsPreviewPage_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPagePrivate, controls));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "menu_button", FALSE, FontManagerGoogleFontsPreviewPage_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPagePrivate, menu_button));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sample_button", FALSE, FontManagerGoogleFontsPreviewPage_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPagePrivate, sample_button));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "preview_colors", FALSE, FontManagerGoogleFontsPreviewPage_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPagePrivate, preview_colors));
#line 198 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_class_install_property_action (GTK_WIDGET_CLASS (klass), "predefined-size", "predefined-size");
#line 199 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_class_install_property_action (GTK_WIDGET_CLASS (klass), "show-line-size", "show-line-size");
#line 2709 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_instance_init (FontManagerGoogleFontsPreviewPage * self,
                                                      gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar** _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar** _tmp11_;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv = font_manager_google_fonts_preview_page_get_instance_private (self);
#line 147 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_show_line_size = TRUE;
#line 148 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_preview_size = 12.5;
#line 149 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_min_waterfall_size = FONT_MANAGER_MIN_FONT_SIZE;
#line 150 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_max_waterfall_size = FONT_MANAGER_MAX_FONT_SIZE * 2;
#line 151 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_waterfall_size_ratio = 1.1;
#line 152 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_selected_item = NULL;
#line 153 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_justification = GTK_JUSTIFY_CENTER;
#line 155 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_preview_mode = FONT_MANAGER_PREVIEW_PAGE_MODE_WATERFALL;
#line 167 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_preview_text = NULL;
#line 168 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->waterfall_body = NULL;
#line 169 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->active_preview_text = NULL;
#line 170 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp0_ = g_strdup ("The quick brown fox jumps over the lazy dog.");
#line 170 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->default_pangram = _tmp0_;
#line 187 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp1_ = g_strdup ("preview-text");
#line 187 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp2_ = g_strdup ("preview-size");
#line 187 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp3_ = g_strdup ("preview-mode");
#line 187 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp4_ = g_strdup ("justification");
#line 187 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_ = g_new0 (gchar*, 4 + 1);
#line 187 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_[0] = _tmp1_;
#line 187 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_[1] = _tmp2_;
#line 187 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_[2] = _tmp3_;
#line 187 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp5_[3] = _tmp4_;
#line 187 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->requires_reload = _tmp5_;
#line 187 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->requires_reload_length1 = 4;
#line 187 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_requires_reload_size_ = self->priv->requires_reload_length1;
#line 192 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp6_ = g_strdup ("min-waterfall-size");
#line 192 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp7_ = g_strdup ("max-waterfall-size");
#line 192 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp8_ = g_strdup ("waterfall-size-ratio");
#line 192 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp9_ = g_strdup ("preview-text");
#line 192 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp10_ = g_strdup ("show-line-size");
#line 192 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp11_ = g_new0 (gchar*, 5 + 1);
#line 192 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp11_[0] = _tmp6_;
#line 192 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp11_[1] = _tmp7_;
#line 192 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp11_[2] = _tmp8_;
#line 192 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp11_[3] = _tmp9_;
#line 192 "../src/font-manager/web/google/PreviewPage.vala"
	_tmp11_[4] = _tmp10_;
#line 192 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->affects_waterfall = _tmp11_;
#line 192 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->affects_waterfall_length1 = 5;
#line 192 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->_affects_waterfall_size_ = self->priv->affects_waterfall_length1;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	g_type_ensure (FONT_MANAGER_TYPE_PREVIEW_COLORS);
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2812 "PreviewPage.c"
}

static void
font_manager_google_fonts_preview_page_finalize (GObject * obj)
{
	FontManagerGoogleFontsPreviewPage * self;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PAGE, FontManagerGoogleFontsPreviewPage);
#line 152 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->_selected_item);
#line 156 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->_waterfall_settings);
#line 167 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (self->priv->_preview_text);
#line 168 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (self->priv->waterfall_body);
#line 169 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (self->priv->active_preview_text);
#line 170 "../src/font-manager/web/google/PreviewPage.vala"
	_g_free0 (self->priv->default_pangram);
#line 177 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->font);
#line 178 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->fontscale);
#line 179 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->entry);
#line 180 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->preview_controls);
#line 181 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->samples);
#line 183 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->webview);
#line 184 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->controls_revealer);
#line 185 "../src/font-manager/web/google/PreviewPage.vala"
	_g_object_unref0 (self->priv->fontscale_revealer);
#line 187 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->requires_reload = (_vala_array_free (self->priv->requires_reload, self->priv->requires_reload_length1, (GDestroyNotify) g_free), NULL);
#line 192 "../src/font-manager/web/google/PreviewPage.vala"
	self->priv->affects_waterfall = (_vala_array_free (self->priv->affects_waterfall, self->priv->affects_waterfall_length1, (GDestroyNotify) g_free), NULL);
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	G_OBJECT_CLASS (font_manager_google_fonts_preview_page_parent_class)->finalize (obj);
#line 2855 "PreviewPage.c"
}

 G_GNUC_NO_INLINE static GType
font_manager_google_fonts_preview_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerGoogleFontsPreviewPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_google_fonts_preview_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerGoogleFontsPreviewPage), 0, (GInstanceInitFunc) font_manager_google_fonts_preview_page_instance_init, NULL };
	GType font_manager_google_fonts_preview_page_type_id;
	font_manager_google_fonts_preview_page_type_id = g_type_register_static (gtk_box_get_type (), "FontManagerGoogleFontsPreviewPage", &g_define_type_info, 0);
	FontManagerGoogleFontsPreviewPage_private_offset = g_type_add_instance_private (font_manager_google_fonts_preview_page_type_id, sizeof (FontManagerGoogleFontsPreviewPagePrivate));
	return font_manager_google_fonts_preview_page_type_id;
}

GType
font_manager_google_fonts_preview_page_get_type (void)
{
	static volatile gsize font_manager_google_fonts_preview_page_type_id__once = 0;
	if (g_once_init_enter (&font_manager_google_fonts_preview_page_type_id__once)) {
		GType font_manager_google_fonts_preview_page_type_id;
		font_manager_google_fonts_preview_page_type_id = font_manager_google_fonts_preview_page_get_type_once ();
		g_once_init_leave (&font_manager_google_fonts_preview_page_type_id__once, font_manager_google_fonts_preview_page_type_id);
	}
	return font_manager_google_fonts_preview_page_type_id__once;
}

static void
_vala_font_manager_google_fonts_preview_page_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec)
{
	FontManagerGoogleFontsPreviewPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PAGE, FontManagerGoogleFontsPreviewPage);
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	switch (property_id) {
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREDEFINED_SIZE_PROPERTY:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_int (value, font_manager_google_fonts_preview_page_get_predefined_size (self));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SHOW_LINE_SIZE_PROPERTY:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_boolean (value, font_manager_google_fonts_preview_page_get_show_line_size (self));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_SIZE_PROPERTY:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_double (value, font_manager_google_fonts_preview_page_get_preview_size (self));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MIN_WATERFALL_SIZE_PROPERTY:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_double (value, font_manager_google_fonts_preview_page_get_min_waterfall_size (self));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MAX_WATERFALL_SIZE_PROPERTY:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_double (value, font_manager_google_fonts_preview_page_get_max_waterfall_size (self));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SIZE_RATIO_PROPERTY:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_double (value, font_manager_google_fonts_preview_page_get_waterfall_size_ratio (self));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SELECTED_ITEM_PROPERTY:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_object (value, font_manager_google_fonts_preview_page_get_selected_item (self));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_JUSTIFICATION_PROPERTY:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_enum (value, font_manager_google_fonts_preview_page_get_justification (self));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_MODE_PROPERTY:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_enum (value, font_manager_google_fonts_preview_page_get_preview_mode (self));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SETTINGS_PROPERTY:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_object (value, font_manager_google_fonts_preview_page_get_waterfall_settings (self));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_TEXT_PROPERTY:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		g_value_set_string (value, font_manager_google_fonts_preview_page_get_preview_text (self));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 2956 "PreviewPage.c"
		default:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 2962 "PreviewPage.c"
	}
}

static void
_vala_font_manager_google_fonts_preview_page_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec)
{
	FontManagerGoogleFontsPreviewPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PAGE, FontManagerGoogleFontsPreviewPage);
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
	switch (property_id) {
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREDEFINED_SIZE_PROPERTY:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_predefined_size (self, g_value_get_int (value));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SHOW_LINE_SIZE_PROPERTY:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_show_line_size (self, g_value_get_boolean (value));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_SIZE_PROPERTY:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_preview_size (self, g_value_get_double (value));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MIN_WATERFALL_SIZE_PROPERTY:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_min_waterfall_size (self, g_value_get_double (value));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_MAX_WATERFALL_SIZE_PROPERTY:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_max_waterfall_size (self, g_value_get_double (value));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SIZE_RATIO_PROPERTY:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_waterfall_size_ratio (self, g_value_get_double (value));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_SELECTED_ITEM_PROPERTY:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_selected_item (self, g_value_get_object (value));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_JUSTIFICATION_PROPERTY:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_justification (self, g_value_get_enum (value));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_MODE_PROPERTY:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_preview_mode (self, g_value_get_enum (value));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_WATERFALL_SETTINGS_PROPERTY:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_waterfall_settings (self, g_value_get_object (value));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PAGE_PREVIEW_TEXT_PROPERTY:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		font_manager_google_fonts_preview_page_set_preview_text (self, g_value_get_string (value));
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 3042 "PreviewPage.c"
		default:
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 144 "../src/font-manager/web/google/PreviewPage.vala"
		break;
#line 3048 "PreviewPage.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 69 "../src/font-manager/FontModel.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 3059 "PreviewPage.c"
		gssize i;
#line 69 "../src/font-manager/FontModel.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 69 "../src/font-manager/FontModel.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 69 "../src/font-manager/FontModel.vala"
				destroy_func (((gpointer*) array)[i]);
#line 3067 "PreviewPage.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 69 "../src/font-manager/FontModel.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 69 "../src/font-manager/FontModel.vala"
	g_free (array);
#line 3082 "PreviewPage.c"
}

