/* MainWindow.c generated by valac 0.56.17, the Vala compiler
 * generated from MainWindow.vala, do not modify */

/* MainWindow.vala
 *
 * Copyright (C) 2009-2024 Jerry Casiano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 *
 * If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.
*/

#include "font-manager.h"
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define FONT_MANAGER_FONT_VIEWER_TYPE_MAIN_WINDOW (font_manager_font_viewer_main_window_get_type ())
#define FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_FONT_VIEWER_TYPE_MAIN_WINDOW, FontManagerFontViewerMainWindow))
#define FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_FONT_VIEWER_TYPE_MAIN_WINDOW, FontManagerFontViewerMainWindowClass))
#define FONT_MANAGER_FONT_VIEWER_IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_FONT_VIEWER_TYPE_MAIN_WINDOW))
#define FONT_MANAGER_FONT_VIEWER_IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_FONT_VIEWER_TYPE_MAIN_WINDOW))
#define FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_FONT_VIEWER_TYPE_MAIN_WINDOW, FontManagerFontViewerMainWindowClass))

typedef struct _FontManagerFontViewerMainWindow FontManagerFontViewerMainWindow;
typedef struct _FontManagerFontViewerMainWindowClass FontManagerFontViewerMainWindowClass;
typedef struct _FontManagerFontViewerMainWindowPrivate FontManagerFontViewerMainWindowPrivate;
typedef enum  {
	FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_NOT_INSTALLED,
	FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_INSTALLED,
	FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_SYSTEM_FONT,
	FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_WOULD_DOWNGRADE,
	FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_WOULD_UPGRADE
} FontManagerFontViewerMainWindowFileStatus;

#define FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_TYPE_FILE_STATUS (font_manager_font_viewer_main_window_file_status_get_type ())
enum  {
	FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_0_PROPERTY,
	FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_NUM_PROPERTIES
};
static GParamSpec* font_manager_font_viewer_main_window_properties[FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _FontManagerFontViewerMainWindow {
	FontManagerApplicationWindow parent_instance;
	FontManagerFontViewerMainWindowPrivate * priv;
};

struct _FontManagerFontViewerMainWindowClass {
	FontManagerApplicationWindowClass parent_class;
};

struct _FontManagerFontViewerMainWindowPrivate {
	GFile* current_file;
	GFile* current_target;
	FontManagerFontViewerMainWindowFileStatus file_status;
	GList* installed_files;
	GtkLabel* title_label;
	GtkLabel* subtitle_label;
	GtkStack* stack;
	GtkButton* action_button;
	GtkHeaderBar* headerbar;
	FontManagerPreviewPane* preview_pane;
};

static gint FontManagerFontViewerMainWindow_private_offset;
static gpointer font_manager_font_viewer_main_window_parent_class = NULL;

VALA_EXTERN GType font_manager_font_viewer_main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerFontViewerMainWindow, g_object_unref)
static GType font_manager_font_viewer_main_window_file_status_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
VALA_EXTERN FontManagerFontViewerMainWindow* font_manager_font_viewer_main_window_new (GSettings* settings);
VALA_EXTERN FontManagerFontViewerMainWindow* font_manager_font_viewer_main_window_construct (GType object_type,
                                                                                 GSettings* settings);
static gboolean font_manager_font_viewer_main_window_on_drop (FontManagerFontViewerMainWindow* self,
                                                       GValue* val,
                                                       gdouble x,
                                                       gdouble y);
static gboolean _font_manager_font_viewer_main_window_on_drop_gtk_drop_target_drop (GtkDropTarget* _sender,
                                                                             GValue* value,
                                                                             gdouble x,
                                                                             gdouble y,
                                                                             gpointer self);
VALA_EXTERN void font_manager_font_viewer_main_window_update (FontManagerFontViewerMainWindow* self);
static void _font_manager_font_viewer_main_window_update_font_manager_preview_pane_changed (FontManagerPreviewPane* _sender,
                                                                                     gpointer self);
static void __lambda4_ (FontManagerFontViewerMainWindow* self);
static void ___lambda4__gtk_widget_realize (GtkWidget* _sender,
                                     gpointer self);
static void font_manager_font_viewer_main_window_update_action_button (FontManagerFontViewerMainWindow* self);
VALA_EXTERN gboolean font_manager_font_viewer_main_window_show_uri (FontManagerFontViewerMainWindow* self,
                                                        const gchar* uri,
                                                        gint index);
VALA_EXTERN gboolean font_manager_font_viewer_main_window_open (FontManagerFontViewerMainWindow* self,
                                                    GFile* file,
                                                    gint index);
static FontManagerFontViewerMainWindowFileStatus font_manager_font_viewer_main_window_get_file_status (FontManagerFontViewerMainWindow* self);
static gboolean font_manager_font_viewer_main_window_remove_directory_tree_if_empty (FontManagerFontViewerMainWindow* self,
                                                                              GFile* dir);
VALA_EXTERN void font_manager_font_viewer_main_window_on_action_button_clicked (FontManagerFontViewerMainWindow* self);
static void _font_manager_font_viewer_main_window_on_action_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                        gpointer self);
static void font_manager_font_viewer_main_window_finalize (GObject * obj);
static GType font_manager_font_viewer_main_window_get_type_once (void);

static inline gpointer
font_manager_font_viewer_main_window_get_instance_private (FontManagerFontViewerMainWindow* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerFontViewerMainWindow_private_offset);
}

 G_GNUC_NO_INLINE static GType
font_manager_font_viewer_main_window_file_status_get_type_once (void)
{
	static const GEnumValue values[] = {{FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_NOT_INSTALLED, "FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_NOT_INSTALLED", "not-installed"}, {FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_INSTALLED, "FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_INSTALLED", "installed"}, {FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_SYSTEM_FONT, "FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_SYSTEM_FONT", "system-font"}, {FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_WOULD_DOWNGRADE, "FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_WOULD_DOWNGRADE", "would-downgrade"}, {FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_WOULD_UPGRADE, "FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_WOULD_UPGRADE", "would-upgrade"}, {0, NULL, NULL}};
	GType font_manager_font_viewer_main_window_file_status_type_id;
	font_manager_font_viewer_main_window_file_status_type_id = g_enum_register_static ("FontManagerFontViewerMainWindowFileStatus", values);
	return font_manager_font_viewer_main_window_file_status_type_id;
}

static GType
font_manager_font_viewer_main_window_file_status_get_type (void)
{
	static volatile gsize font_manager_font_viewer_main_window_file_status_type_id__once = 0;
	if (g_once_init_enter (&font_manager_font_viewer_main_window_file_status_type_id__once)) {
		GType font_manager_font_viewer_main_window_file_status_type_id;
		font_manager_font_viewer_main_window_file_status_type_id = font_manager_font_viewer_main_window_file_status_get_type_once ();
		g_once_init_leave (&font_manager_font_viewer_main_window_file_status_type_id__once, font_manager_font_viewer_main_window_file_status_type_id);
	}
	return font_manager_font_viewer_main_window_file_status_type_id__once;
}

static void
_g_free0_ (gpointer var)
{
#line 29 "../src/font-viewer/MainWindow.vala"
	var = (g_free (var), NULL);
#line 179 "MainWindow.c"
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 29 "../src/font-viewer/MainWindow.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 187 "MainWindow.c"
}

static gboolean
_font_manager_font_viewer_main_window_on_drop_gtk_drop_target_drop (GtkDropTarget* _sender,
                                                                    GValue* value,
                                                                    gdouble x,
                                                                    gdouble y,
                                                                    gpointer self)
{
	gboolean result;
	result = font_manager_font_viewer_main_window_on_drop ((FontManagerFontViewerMainWindow*) self, value, x, y);
#line 49 "../src/font-viewer/MainWindow.vala"
	return result;
#line 201 "MainWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 50 "../src/font-viewer/MainWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 209 "MainWindow.c"
}

static void
_font_manager_font_viewer_main_window_update_font_manager_preview_pane_changed (FontManagerPreviewPane* _sender,
                                                                                gpointer self)
{
#line 53 "../src/font-viewer/MainWindow.vala"
	font_manager_font_viewer_main_window_update ((FontManagerFontViewerMainWindow*) self);
#line 218 "MainWindow.c"
}

static void
__lambda4_ (FontManagerFontViewerMainWindow* self)
{
	FontManagerPreviewPane* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
#line 55 "../src/font-viewer/MainWindow.vala"
	_tmp0_ = self->priv->preview_pane;
#line 55 "../src/font-viewer/MainWindow.vala"
	_tmp1_ = font_manager_get_gsettings (FONT_MANAGER_BUS_ID);
#line 55 "../src/font-viewer/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 55 "../src/font-viewer/MainWindow.vala"
	font_manager_preview_pane_restore_state (_tmp0_, _tmp2_);
#line 55 "../src/font-viewer/MainWindow.vala"
	_g_object_unref0 (_tmp2_);
#line 237 "MainWindow.c"
}

static void
___lambda4__gtk_widget_realize (GtkWidget* _sender,
                                gpointer self)
{
#line 54 "../src/font-viewer/MainWindow.vala"
	__lambda4_ ((FontManagerFontViewerMainWindow*) self);
#line 246 "MainWindow.c"
}

FontManagerFontViewerMainWindow*
font_manager_font_viewer_main_window_construct (GType object_type,
                                                GSettings* settings)
{
	FontManagerFontViewerMainWindow * self = NULL;
	GtkDropTarget* target = NULL;
	GtkDropTarget* _tmp0_;
	GtkStack* _tmp1_;
	GtkEventController* _tmp2_;
	GtkStack* _tmp3_;
	FontManagerPreviewPane* _tmp4_;
	GtkButton* _tmp5_;
	FontManagerPreviewPane* _tmp6_;
	FontManagerPreviewPane* _tmp7_;
#line 47 "../src/font-viewer/MainWindow.vala"
	self = (FontManagerFontViewerMainWindow*) g_object_new (object_type, "settings", settings, NULL);
#line 48 "../src/font-viewer/MainWindow.vala"
	_tmp0_ = gtk_drop_target_new (gdk_file_list_get_type (), GDK_ACTION_COPY);
#line 48 "../src/font-viewer/MainWindow.vala"
	target = _tmp0_;
#line 49 "../src/font-viewer/MainWindow.vala"
	g_signal_connect_object (target, "drop", (GCallback) _font_manager_font_viewer_main_window_on_drop_gtk_drop_target_drop, self, 0);
#line 50 "../src/font-viewer/MainWindow.vala"
	_tmp1_ = self->priv->stack;
#line 50 "../src/font-viewer/MainWindow.vala"
	_tmp2_ = _g_object_ref0 ((GtkEventController*) target);
#line 50 "../src/font-viewer/MainWindow.vala"
	gtk_widget_add_controller ((GtkWidget*) _tmp1_, _tmp2_);
#line 51 "../src/font-viewer/MainWindow.vala"
	_tmp3_ = self->priv->stack;
#line 51 "../src/font-viewer/MainWindow.vala"
	gtk_stack_set_visible_child_name (_tmp3_, "PlaceHolder");
#line 52 "../src/font-viewer/MainWindow.vala"
	_tmp4_ = self->priv->preview_pane;
#line 52 "../src/font-viewer/MainWindow.vala"
	_tmp5_ = self->priv->action_button;
#line 52 "../src/font-viewer/MainWindow.vala"
	font_manager_preview_pane_set_action_widget (_tmp4_, (GtkWidget*) _tmp5_, GTK_PACK_END);
#line 53 "../src/font-viewer/MainWindow.vala"
	_tmp6_ = self->priv->preview_pane;
#line 53 "../src/font-viewer/MainWindow.vala"
	g_signal_connect_object (_tmp6_, "changed", (GCallback) _font_manager_font_viewer_main_window_update_font_manager_preview_pane_changed, self, 0);
#line 54 "../src/font-viewer/MainWindow.vala"
	_tmp7_ = self->priv->preview_pane;
#line 54 "../src/font-viewer/MainWindow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp7_, "realize", (GCallback) ___lambda4__gtk_widget_realize, self, 0);
#line 57 "../src/font-viewer/MainWindow.vala"
	font_manager_font_viewer_main_window_update_action_button (self);
#line 46 "../src/font-viewer/MainWindow.vala"
	_g_object_unref0 (target);
#line 46 "../src/font-viewer/MainWindow.vala"
	return self;
#line 301 "MainWindow.c"
}

FontManagerFontViewerMainWindow*
font_manager_font_viewer_main_window_new (GSettings* settings)
{
#line 46 "../src/font-viewer/MainWindow.vala"
	return font_manager_font_viewer_main_window_construct (FONT_MANAGER_FONT_VIEWER_TYPE_MAIN_WINDOW, settings);
#line 309 "MainWindow.c"
}

gboolean
font_manager_font_viewer_main_window_show_uri (FontManagerFontViewerMainWindow* self,
                                               const gchar* uri,
                                               gint index)
{
	GList* _tmp0_;
	FontManagerPreviewPane* _tmp1_;
	gboolean result;
#line 60 "../src/font-viewer/MainWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 60 "../src/font-viewer/MainWindow.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 61 "../src/font-viewer/MainWindow.vala"
	_tmp0_ = font_manager_list_available_font_files ();
#line 61 "../src/font-viewer/MainWindow.vala"
	(self->priv->installed_files == NULL) ? NULL : (self->priv->installed_files = (_g_list_free__g_free0_ (self->priv->installed_files), NULL));
#line 61 "../src/font-viewer/MainWindow.vala"
	self->priv->installed_files = _tmp0_;
#line 62 "../src/font-viewer/MainWindow.vala"
	_tmp1_ = self->priv->preview_pane;
#line 62 "../src/font-viewer/MainWindow.vala"
	result = font_manager_preview_pane_show_uri (_tmp1_, uri, index);
#line 62 "../src/font-viewer/MainWindow.vala"
	return result;
#line 336 "MainWindow.c"
}

gboolean
font_manager_font_viewer_main_window_open (FontManagerFontViewerMainWindow* self,
                                           GFile* file,
                                           gint index)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 65 "../src/font-viewer/MainWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 65 "../src/font-viewer/MainWindow.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 66 "../src/font-viewer/MainWindow.vala"
	_tmp0_ = g_file_get_uri (file);
#line 66 "../src/font-viewer/MainWindow.vala"
	_tmp1_ = _tmp0_;
#line 66 "../src/font-viewer/MainWindow.vala"
	_tmp2_ = font_manager_font_viewer_main_window_show_uri (self, _tmp1_, index);
#line 66 "../src/font-viewer/MainWindow.vala"
	_g_free0 (_tmp1_);
#line 66 "../src/font-viewer/MainWindow.vala"
	result = _tmp2_;
#line 66 "../src/font-viewer/MainWindow.vala"
	return result;
#line 364 "MainWindow.c"
}

static gboolean
font_manager_font_viewer_main_window_on_drop (FontManagerFontViewerMainWindow* self,
                                              GValue* val,
                                              gdouble x,
                                              gdouble y)
{
	GSList* files = NULL;
	void* _tmp0_;
	GSList* _tmp1_;
	gboolean result;
#line 69 "../src/font-viewer/MainWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 69 "../src/font-viewer/MainWindow.vala"
	g_return_val_if_fail (val != NULL, FALSE);
#line 70 "../src/font-viewer/MainWindow.vala"
	_tmp0_ = g_value_get_boxed (val);
#line 70 "../src/font-viewer/MainWindow.vala"
	files = (GSList*) _tmp0_;
#line 71 "../src/font-viewer/MainWindow.vala"
	_tmp1_ = files;
#line 71 "../src/font-viewer/MainWindow.vala"
	if (g_slist_length (_tmp1_) > ((guint) 0)) {
#line 389 "MainWindow.c"
		GSList* _tmp2_;
		gconstpointer _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 72 "../src/font-viewer/MainWindow.vala"
		_tmp2_ = files;
#line 72 "../src/font-viewer/MainWindow.vala"
		_tmp3_ = g_slist_nth_data (_tmp2_, (guint) 0);
#line 72 "../src/font-viewer/MainWindow.vala"
		_tmp4_ = g_file_get_uri ((GFile*) _tmp3_);
#line 72 "../src/font-viewer/MainWindow.vala"
		_tmp5_ = _tmp4_;
#line 72 "../src/font-viewer/MainWindow.vala"
		font_manager_font_viewer_main_window_show_uri (self, _tmp5_, 0);
#line 72 "../src/font-viewer/MainWindow.vala"
		_g_free0 (_tmp5_);
#line 406 "MainWindow.c"
	}
#line 73 "../src/font-viewer/MainWindow.vala"
	result = TRUE;
#line 73 "../src/font-viewer/MainWindow.vala"
	return result;
#line 412 "MainWindow.c"
}

void
font_manager_font_viewer_main_window_update (FontManagerFontViewerMainWindow* self)
{
	FontManagerPreviewPane* _tmp0_;
	FontManagerFont* _tmp1_;
	FontManagerFont* _tmp2_;
	FontManagerFont* _tmp3_;
	gboolean _tmp4_;
	const gchar* _tmp41_ = NULL;
	FontManagerPreviewPane* _tmp42_;
	FontManagerFont* _tmp43_;
	FontManagerFont* _tmp44_;
	FontManagerFont* _tmp45_;
	gboolean _tmp46_;
	GtkStack* _tmp47_;
#line 76 "../src/font-viewer/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/font-viewer/MainWindow.vala"
	_tmp0_ = self->priv->preview_pane;
#line 77 "../src/font-viewer/MainWindow.vala"
	g_object_get (_tmp0_, "font", &_tmp1_, NULL);
#line 77 "../src/font-viewer/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 77 "../src/font-viewer/MainWindow.vala"
	_tmp3_ = _tmp2_;
#line 77 "../src/font-viewer/MainWindow.vala"
	_tmp4_ = _tmp3_ != NULL;
#line 77 "../src/font-viewer/MainWindow.vala"
	_g_object_unref0 (_tmp3_);
#line 77 "../src/font-viewer/MainWindow.vala"
	if (_tmp4_) {
#line 446 "MainWindow.c"
		FontManagerPreviewPane* _tmp5_;
		FontManagerFont* _tmp6_;
		FontManagerFont* _tmp7_;
		FontManagerFont* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GFile* _tmp12_;
		gchar* family = NULL;
		FontManagerPreviewPane* _tmp13_;
		FontManagerFont* _tmp14_;
		FontManagerFont* _tmp15_;
		FontManagerFont* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* style = NULL;
		FontManagerPreviewPane* _tmp20_;
		FontManagerFont* _tmp21_;
		FontManagerFont* _tmp22_;
		FontManagerFont* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		GtkLabel* _tmp27_;
		const gchar* _tmp28_;
		GtkLabel* _tmp29_;
		const gchar* _tmp30_;
#line 83 "../src/font-viewer/MainWindow.vala"
		static const char tt_tmpl[] = "<big><b>%s</b> </big><b>%s</b>";
#line 477 "MainWindow.c"
		GtkHeaderBar* _tmp31_;
		const gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		const gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
#line 78 "../src/font-viewer/MainWindow.vala"
		_tmp5_ = self->priv->preview_pane;
#line 78 "../src/font-viewer/MainWindow.vala"
		g_object_get (_tmp5_, "font", &_tmp6_, NULL);
#line 78 "../src/font-viewer/MainWindow.vala"
		_tmp7_ = _tmp6_;
#line 78 "../src/font-viewer/MainWindow.vala"
		_tmp8_ = _tmp7_;
#line 78 "../src/font-viewer/MainWindow.vala"
		g_object_get (_tmp8_, "filepath", &_tmp9_, NULL);
#line 78 "../src/font-viewer/MainWindow.vala"
		_tmp10_ = _tmp9_;
#line 78 "../src/font-viewer/MainWindow.vala"
		_tmp11_ = _tmp10_;
#line 78 "../src/font-viewer/MainWindow.vala"
		_tmp12_ = g_file_new_for_path (_tmp11_);
#line 78 "../src/font-viewer/MainWindow.vala"
		_g_object_unref0 (self->priv->current_file);
#line 78 "../src/font-viewer/MainWindow.vala"
		self->priv->current_file = _tmp12_;
#line 78 "../src/font-viewer/MainWindow.vala"
		_g_free0 (_tmp11_);
#line 78 "../src/font-viewer/MainWindow.vala"
		_g_object_unref0 (_tmp8_);
#line 79 "../src/font-viewer/MainWindow.vala"
		_tmp13_ = self->priv->preview_pane;
#line 79 "../src/font-viewer/MainWindow.vala"
		g_object_get (_tmp13_, "font", &_tmp14_, NULL);
#line 79 "../src/font-viewer/MainWindow.vala"
		_tmp15_ = _tmp14_;
#line 79 "../src/font-viewer/MainWindow.vala"
		_tmp16_ = _tmp15_;
#line 79 "../src/font-viewer/MainWindow.vala"
		g_object_get (_tmp16_, "family", &_tmp17_, NULL);
#line 79 "../src/font-viewer/MainWindow.vala"
		_tmp18_ = _tmp17_;
#line 79 "../src/font-viewer/MainWindow.vala"
		_tmp19_ = _tmp18_;
#line 79 "../src/font-viewer/MainWindow.vala"
		_g_object_unref0 (_tmp16_);
#line 79 "../src/font-viewer/MainWindow.vala"
		family = _tmp19_;
#line 80 "../src/font-viewer/MainWindow.vala"
		_tmp20_ = self->priv->preview_pane;
#line 80 "../src/font-viewer/MainWindow.vala"
		g_object_get (_tmp20_, "font", &_tmp21_, NULL);
#line 80 "../src/font-viewer/MainWindow.vala"
		_tmp22_ = _tmp21_;
#line 80 "../src/font-viewer/MainWindow.vala"
		_tmp23_ = _tmp22_;
#line 80 "../src/font-viewer/MainWindow.vala"
		g_object_get (_tmp23_, "style", &_tmp24_, NULL);
#line 80 "../src/font-viewer/MainWindow.vala"
		_tmp25_ = _tmp24_;
#line 80 "../src/font-viewer/MainWindow.vala"
		_tmp26_ = _tmp25_;
#line 80 "../src/font-viewer/MainWindow.vala"
		_g_object_unref0 (_tmp23_);
#line 80 "../src/font-viewer/MainWindow.vala"
		style = _tmp26_;
#line 81 "../src/font-viewer/MainWindow.vala"
		_tmp27_ = self->priv->title_label;
#line 81 "../src/font-viewer/MainWindow.vala"
		_tmp28_ = family;
#line 81 "../src/font-viewer/MainWindow.vala"
		gtk_label_set_label (_tmp27_, _tmp28_);
#line 82 "../src/font-viewer/MainWindow.vala"
		_tmp29_ = self->priv->subtitle_label;
#line 82 "../src/font-viewer/MainWindow.vala"
		_tmp30_ = style;
#line 82 "../src/font-viewer/MainWindow.vala"
		gtk_label_set_label (_tmp29_, _tmp30_);
#line 84 "../src/font-viewer/MainWindow.vala"
		_tmp31_ = self->priv->headerbar;
#line 84 "../src/font-viewer/MainWindow.vala"
		_tmp32_ = family;
#line 84 "../src/font-viewer/MainWindow.vala"
		_tmp33_ = g_markup_escape_text (_tmp32_, (gssize) -1);
#line 84 "../src/font-viewer/MainWindow.vala"
		_tmp34_ = _tmp33_;
#line 84 "../src/font-viewer/MainWindow.vala"
		_tmp35_ = style;
#line 84 "../src/font-viewer/MainWindow.vala"
		_tmp36_ = g_strdup_printf (tt_tmpl, _tmp34_, _tmp35_);
#line 84 "../src/font-viewer/MainWindow.vala"
		_tmp37_ = _tmp36_;
#line 84 "../src/font-viewer/MainWindow.vala"
		gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp31_, _tmp37_);
#line 84 "../src/font-viewer/MainWindow.vala"
		_g_free0 (_tmp37_);
#line 84 "../src/font-viewer/MainWindow.vala"
		_g_free0 (_tmp34_);
#line 77 "../src/font-viewer/MainWindow.vala"
		_g_free0 (style);
#line 77 "../src/font-viewer/MainWindow.vala"
		_g_free0 (family);
#line 581 "MainWindow.c"
	} else {
		GtkLabel* _tmp38_;
		GtkLabel* _tmp39_;
		GtkHeaderBar* _tmp40_;
#line 86 "../src/font-viewer/MainWindow.vala"
		_g_object_unref0 (self->priv->current_file);
#line 86 "../src/font-viewer/MainWindow.vala"
		self->priv->current_file = NULL;
#line 87 "../src/font-viewer/MainWindow.vala"
		_tmp38_ = self->priv->title_label;
#line 87 "../src/font-viewer/MainWindow.vala"
		gtk_label_set_label (_tmp38_, _ ("No file selected"));
#line 88 "../src/font-viewer/MainWindow.vala"
		_tmp39_ = self->priv->subtitle_label;
#line 88 "../src/font-viewer/MainWindow.vala"
		gtk_label_set_label (_tmp39_, _ ("Or unsupported filetype."));
#line 89 "../src/font-viewer/MainWindow.vala"
		_tmp40_ = self->priv->headerbar;
#line 89 "../src/font-viewer/MainWindow.vala"
		gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp40_, NULL);
#line 602 "MainWindow.c"
	}
#line 91 "../src/font-viewer/MainWindow.vala"
	_tmp42_ = self->priv->preview_pane;
#line 91 "../src/font-viewer/MainWindow.vala"
	g_object_get (_tmp42_, "font", &_tmp43_, NULL);
#line 91 "../src/font-viewer/MainWindow.vala"
	_tmp44_ = _tmp43_;
#line 91 "../src/font-viewer/MainWindow.vala"
	_tmp45_ = _tmp44_;
#line 91 "../src/font-viewer/MainWindow.vala"
	_tmp46_ = _tmp45_ != NULL;
#line 91 "../src/font-viewer/MainWindow.vala"
	_g_object_unref0 (_tmp45_);
#line 91 "../src/font-viewer/MainWindow.vala"
	if (_tmp46_) {
#line 91 "../src/font-viewer/MainWindow.vala"
		_tmp41_ = "Preview";
#line 620 "MainWindow.c"
	} else {
#line 91 "../src/font-viewer/MainWindow.vala"
		_tmp41_ = "PlaceHolder";
#line 624 "MainWindow.c"
	}
#line 91 "../src/font-viewer/MainWindow.vala"
	_tmp47_ = self->priv->stack;
#line 91 "../src/font-viewer/MainWindow.vala"
	gtk_stack_set_visible_child_name (_tmp47_, _tmp41_);
#line 92 "../src/font-viewer/MainWindow.vala"
	_g_object_unref0 (self->priv->current_target);
#line 92 "../src/font-viewer/MainWindow.vala"
	self->priv->current_target = NULL;
#line 93 "../src/font-viewer/MainWindow.vala"
	self->priv->file_status = font_manager_font_viewer_main_window_get_file_status (self);
#line 94 "../src/font-viewer/MainWindow.vala"
	font_manager_font_viewer_main_window_update_action_button (self);
#line 95 "../src/font-viewer/MainWindow.vala"
	return;
#line 640 "MainWindow.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 659 "MainWindow.c"
}

static FontManagerFontViewerMainWindowFileStatus
font_manager_font_viewer_main_window_get_file_status (FontManagerFontViewerMainWindow* self)
{
	GFile* _tmp0_;
	gchar* current_path = NULL;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GList* _tmp4_;
	const gchar* _tmp5_;
	GCompareFunc _tmp6_;
	GList* _tmp7_;
	GFile* font_dir = NULL;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GFile* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GFile* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gboolean _tmp19_;
	GFile* _tmp22_;
	GFile* _tmp28_;
	GError* _inner_error0_ = NULL;
	FontManagerFontViewerMainWindowFileStatus result;
#line 98 "../src/font-viewer/MainWindow.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 99 "../src/font-viewer/MainWindow.vala"
	_tmp0_ = self->priv->current_file;
#line 99 "../src/font-viewer/MainWindow.vala"
	if (_tmp0_ == NULL) {
#line 100 "../src/font-viewer/MainWindow.vala"
		result = FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_NOT_INSTALLED;
#line 100 "../src/font-viewer/MainWindow.vala"
		return result;
#line 700 "MainWindow.c"
	}
#line 101 "../src/font-viewer/MainWindow.vala"
	_tmp1_ = self->priv->current_file;
#line 101 "../src/font-viewer/MainWindow.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 101 "../src/font-viewer/MainWindow.vala"
	current_path = _tmp2_;
#line 102 "../src/font-viewer/MainWindow.vala"
	_tmp4_ = self->priv->installed_files;
#line 102 "../src/font-viewer/MainWindow.vala"
	_tmp5_ = current_path;
#line 102 "../src/font-viewer/MainWindow.vala"
	_tmp6_ = ((GCompareFunc) g_strcmp0);
#line 102 "../src/font-viewer/MainWindow.vala"
	_tmp7_ = g_list_find_custom (_tmp4_, _tmp5_, _tmp6_);
#line 102 "../src/font-viewer/MainWindow.vala"
	if (_tmp7_ != NULL) {
#line 718 "MainWindow.c"
		const gchar* _tmp8_;
#line 102 "../src/font-viewer/MainWindow.vala"
		_tmp8_ = current_path;
#line 102 "../src/font-viewer/MainWindow.vala"
		_tmp3_ = font_manager_get_file_owner (_tmp8_) != 0;
#line 724 "MainWindow.c"
	} else {
#line 102 "../src/font-viewer/MainWindow.vala"
		_tmp3_ = FALSE;
#line 728 "MainWindow.c"
	}
#line 102 "../src/font-viewer/MainWindow.vala"
	if (_tmp3_) {
#line 103 "../src/font-viewer/MainWindow.vala"
		result = FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_SYSTEM_FONT;
#line 103 "../src/font-viewer/MainWindow.vala"
		_g_free0 (current_path);
#line 103 "../src/font-viewer/MainWindow.vala"
		return result;
#line 738 "MainWindow.c"
	}
#line 104 "../src/font-viewer/MainWindow.vala"
	_tmp9_ = font_manager_get_user_font_directory ();
#line 104 "../src/font-viewer/MainWindow.vala"
	_tmp10_ = _tmp9_;
#line 104 "../src/font-viewer/MainWindow.vala"
	_tmp11_ = g_file_new_for_path (_tmp10_);
#line 104 "../src/font-viewer/MainWindow.vala"
	_tmp12_ = _tmp11_;
#line 104 "../src/font-viewer/MainWindow.vala"
	_g_free0 (_tmp10_);
#line 104 "../src/font-viewer/MainWindow.vala"
	font_dir = _tmp12_;
#line 105 "../src/font-viewer/MainWindow.vala"
	_tmp13_ = self->priv->current_file;
#line 105 "../src/font-viewer/MainWindow.vala"
	_tmp14_ = g_file_get_path (_tmp13_);
#line 105 "../src/font-viewer/MainWindow.vala"
	_tmp15_ = _tmp14_;
#line 105 "../src/font-viewer/MainWindow.vala"
	_tmp16_ = font_dir;
#line 105 "../src/font-viewer/MainWindow.vala"
	_tmp17_ = g_file_get_path (_tmp16_);
#line 105 "../src/font-viewer/MainWindow.vala"
	_tmp18_ = _tmp17_;
#line 105 "../src/font-viewer/MainWindow.vala"
	_tmp19_ = string_contains (_tmp15_, _tmp18_);
#line 105 "../src/font-viewer/MainWindow.vala"
	_g_free0 (_tmp18_);
#line 105 "../src/font-viewer/MainWindow.vala"
	_g_free0 (_tmp15_);
#line 105 "../src/font-viewer/MainWindow.vala"
	if (_tmp19_) {
#line 772 "MainWindow.c"
		GFile* _tmp20_;
		GFile* _tmp21_;
#line 106 "../src/font-viewer/MainWindow.vala"
		_tmp20_ = self->priv->current_file;
#line 106 "../src/font-viewer/MainWindow.vala"
		_tmp21_ = _g_object_ref0 (_tmp20_);
#line 106 "../src/font-viewer/MainWindow.vala"
		_g_object_unref0 (self->priv->current_target);
#line 106 "../src/font-viewer/MainWindow.vala"
		self->priv->current_target = _tmp21_;
#line 783 "MainWindow.c"
	}
#line 107 "../src/font-viewer/MainWindow.vala"
	_tmp22_ = self->priv->current_target;
#line 107 "../src/font-viewer/MainWindow.vala"
	if (_tmp22_ == NULL) {
#line 789 "MainWindow.c"
		{
			GFile* _tmp23_ = NULL;
			GFile* _tmp24_;
			GFile* _tmp25_;
			GFile* _tmp26_;
			GFile* _tmp27_;
#line 109 "../src/font-viewer/MainWindow.vala"
			_tmp24_ = self->priv->current_file;
#line 109 "../src/font-viewer/MainWindow.vala"
			_tmp25_ = font_dir;
#line 109 "../src/font-viewer/MainWindow.vala"
			_tmp26_ = font_manager_get_installation_target (_tmp24_, _tmp25_, FALSE, &_inner_error0_);
#line 109 "../src/font-viewer/MainWindow.vala"
			_tmp23_ = _tmp26_;
#line 109 "../src/font-viewer/MainWindow.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 806 "MainWindow.c"
				goto __catch0_g_error;
			}
#line 109 "../src/font-viewer/MainWindow.vala"
			_tmp27_ = _tmp23_;
#line 109 "../src/font-viewer/MainWindow.vala"
			_tmp23_ = NULL;
#line 109 "../src/font-viewer/MainWindow.vala"
			_g_object_unref0 (self->priv->current_target);
#line 109 "../src/font-viewer/MainWindow.vala"
			self->priv->current_target = _tmp27_;
#line 108 "../src/font-viewer/MainWindow.vala"
			_g_object_unref0 (_tmp23_);
#line 819 "MainWindow.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 108 "../src/font-viewer/MainWindow.vala"
			g_clear_error (&_inner_error0_);
#line 111 "../src/font-viewer/MainWindow.vala"
			result = FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_NOT_INSTALLED;
#line 111 "../src/font-viewer/MainWindow.vala"
			_g_object_unref0 (font_dir);
#line 111 "../src/font-viewer/MainWindow.vala"
			_g_free0 (current_path);
#line 111 "../src/font-viewer/MainWindow.vala"
			return result;
#line 834 "MainWindow.c"
		}
		__finally0:
#line 108 "../src/font-viewer/MainWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 108 "../src/font-viewer/MainWindow.vala"
			_g_object_unref0 (font_dir);
#line 108 "../src/font-viewer/MainWindow.vala"
			_g_free0 (current_path);
#line 108 "../src/font-viewer/MainWindow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 108 "../src/font-viewer/MainWindow.vala"
			g_clear_error (&_inner_error0_);
#line 108 "../src/font-viewer/MainWindow.vala"
			return 0;
#line 849 "MainWindow.c"
		}
	}
#line 114 "../src/font-viewer/MainWindow.vala"
	_tmp28_ = self->priv->current_target;
#line 114 "../src/font-viewer/MainWindow.vala"
	if (g_file_query_exists (_tmp28_, NULL)) {
#line 856 "MainWindow.c"
		gfloat a = 0.0F;
		GFile* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gfloat _tmp32_;
		gfloat b = 0.0F;
		GFile* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gfloat _tmp36_;
#line 115 "../src/font-viewer/MainWindow.vala"
		_tmp29_ = self->priv->current_target;
#line 115 "../src/font-viewer/MainWindow.vala"
		_tmp30_ = g_file_get_path (_tmp29_);
#line 115 "../src/font-viewer/MainWindow.vala"
		_tmp31_ = _tmp30_;
#line 115 "../src/font-viewer/MainWindow.vala"
		_tmp32_ = font_manager_get_font_revision (_tmp31_);
#line 115 "../src/font-viewer/MainWindow.vala"
		_g_free0 (_tmp31_);
#line 115 "../src/font-viewer/MainWindow.vala"
		a = _tmp32_;
#line 116 "../src/font-viewer/MainWindow.vala"
		_tmp33_ = self->priv->current_file;
#line 116 "../src/font-viewer/MainWindow.vala"
		_tmp34_ = g_file_get_path (_tmp33_);
#line 116 "../src/font-viewer/MainWindow.vala"
		_tmp35_ = _tmp34_;
#line 116 "../src/font-viewer/MainWindow.vala"
		_tmp36_ = font_manager_get_font_revision (_tmp35_);
#line 116 "../src/font-viewer/MainWindow.vala"
		_g_free0 (_tmp35_);
#line 116 "../src/font-viewer/MainWindow.vala"
		b = _tmp36_;
#line 117 "../src/font-viewer/MainWindow.vala"
		if (a < b) {
#line 118 "../src/font-viewer/MainWindow.vala"
			result = FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_WOULD_UPGRADE;
#line 118 "../src/font-viewer/MainWindow.vala"
			_g_object_unref0 (font_dir);
#line 118 "../src/font-viewer/MainWindow.vala"
			_g_free0 (current_path);
#line 118 "../src/font-viewer/MainWindow.vala"
			return result;
#line 901 "MainWindow.c"
		} else {
#line 119 "../src/font-viewer/MainWindow.vala"
			if (a > b) {
#line 120 "../src/font-viewer/MainWindow.vala"
				result = FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_WOULD_DOWNGRADE;
#line 120 "../src/font-viewer/MainWindow.vala"
				_g_object_unref0 (font_dir);
#line 120 "../src/font-viewer/MainWindow.vala"
				_g_free0 (current_path);
#line 120 "../src/font-viewer/MainWindow.vala"
				return result;
#line 913 "MainWindow.c"
			} else {
#line 122 "../src/font-viewer/MainWindow.vala"
				result = FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_INSTALLED;
#line 122 "../src/font-viewer/MainWindow.vala"
				_g_object_unref0 (font_dir);
#line 122 "../src/font-viewer/MainWindow.vala"
				_g_free0 (current_path);
#line 122 "../src/font-viewer/MainWindow.vala"
				return result;
#line 923 "MainWindow.c"
			}
		}
	} else {
#line 124 "../src/font-viewer/MainWindow.vala"
		result = FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_NOT_INSTALLED;
#line 124 "../src/font-viewer/MainWindow.vala"
		_g_object_unref0 (font_dir);
#line 124 "../src/font-viewer/MainWindow.vala"
		_g_free0 (current_path);
#line 124 "../src/font-viewer/MainWindow.vala"
		return result;
#line 935 "MainWindow.c"
	}
}

static void
font_manager_font_viewer_main_window_update_action_button (FontManagerFontViewerMainWindow* self)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	GtkButton* _tmp4_;
	FontManagerPreviewPane* _tmp5_;
	FontManagerFont* _tmp6_;
	FontManagerFont* _tmp7_;
	FontManagerFont* _tmp8_;
	FontManagerPreviewPane* _tmp9_;
	FontManagerFont* _tmp10_;
	FontManagerFont* _tmp11_;
	FontManagerFont* _tmp12_;
	gboolean _tmp13_;
#line 127 "../src/font-viewer/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/font-viewer/MainWindow.vala"
	_tmp0_ = self->priv->action_button;
#line 128 "../src/font-viewer/MainWindow.vala"
	gtk_widget_remove_css_class ((GtkWidget*) _tmp0_, FONT_MANAGER_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 129 "../src/font-viewer/MainWindow.vala"
	_tmp1_ = self->priv->action_button;
#line 129 "../src/font-viewer/MainWindow.vala"
	gtk_widget_remove_css_class ((GtkWidget*) _tmp1_, FONT_MANAGER_STYLE_CLASS_SUGGESTED_ACTION);
#line 130 "../src/font-viewer/MainWindow.vala"
	_tmp2_ = self->priv->action_button;
#line 130 "../src/font-viewer/MainWindow.vala"
	gtk_widget_remove_css_class ((GtkWidget*) _tmp2_, FONT_MANAGER_STYLE_CLASS_DIM_LABEL);
#line 131 "../src/font-viewer/MainWindow.vala"
	_tmp3_ = self->priv->action_button;
#line 131 "../src/font-viewer/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp3_, NULL);
#line 132 "../src/font-viewer/MainWindow.vala"
	_tmp4_ = self->priv->action_button;
#line 132 "../src/font-viewer/MainWindow.vala"
	_tmp5_ = self->priv->preview_pane;
#line 132 "../src/font-viewer/MainWindow.vala"
	g_object_get (_tmp5_, "font", &_tmp6_, NULL);
#line 132 "../src/font-viewer/MainWindow.vala"
	_tmp7_ = _tmp6_;
#line 132 "../src/font-viewer/MainWindow.vala"
	_tmp8_ = _tmp7_;
#line 132 "../src/font-viewer/MainWindow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, _tmp8_ != NULL);
#line 132 "../src/font-viewer/MainWindow.vala"
	_g_object_unref0 (_tmp8_);
#line 133 "../src/font-viewer/MainWindow.vala"
	_tmp9_ = self->priv->preview_pane;
#line 133 "../src/font-viewer/MainWindow.vala"
	g_object_get (_tmp9_, "font", &_tmp10_, NULL);
#line 133 "../src/font-viewer/MainWindow.vala"
	_tmp11_ = _tmp10_;
#line 133 "../src/font-viewer/MainWindow.vala"
	_tmp12_ = _tmp11_;
#line 133 "../src/font-viewer/MainWindow.vala"
	_tmp13_ = _tmp12_ == NULL;
#line 133 "../src/font-viewer/MainWindow.vala"
	_g_object_unref0 (_tmp12_);
#line 133 "../src/font-viewer/MainWindow.vala"
	if (_tmp13_) {
#line 134 "../src/font-viewer/MainWindow.vala"
		return;
#line 1004 "MainWindow.c"
	}
#line 135 "../src/font-viewer/MainWindow.vala"
	switch (self->priv->file_status) {
#line 135 "../src/font-viewer/MainWindow.vala"
		case FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_SYSTEM_FONT:
#line 1010 "MainWindow.c"
		{
			GtkButton* _tmp14_;
			GtkButton* _tmp15_;
			GtkButton* _tmp16_;
#line 137 "../src/font-viewer/MainWindow.vala"
			_tmp14_ = self->priv->action_button;
#line 137 "../src/font-viewer/MainWindow.vala"
			gtk_button_set_label (_tmp14_, _ ("System Font"));
#line 138 "../src/font-viewer/MainWindow.vala"
			_tmp15_ = self->priv->action_button;
#line 138 "../src/font-viewer/MainWindow.vala"
			gtk_widget_add_css_class ((GtkWidget*) _tmp15_, FONT_MANAGER_STYLE_CLASS_DIM_LABEL);
#line 139 "../src/font-viewer/MainWindow.vala"
			_tmp16_ = self->priv->action_button;
#line 139 "../src/font-viewer/MainWindow.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp16_, _ ("Selected font file is either installed in a system directory or is not" \
" writable by the current user.\n" \
"\n" \
"If you wish to remove this font from the list of available fonts use t" \
"he system package manager to remove the package containing this font f" \
"ile, ask the system administrator to remove it or use a font managemen" \
"t application to disable it."));
#line 140 "../src/font-viewer/MainWindow.vala"
			break;
#line 1029 "MainWindow.c"
		}
#line 135 "../src/font-viewer/MainWindow.vala"
		case FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_WOULD_DOWNGRADE:
#line 1033 "MainWindow.c"
		{
			GtkButton* _tmp17_;
			GtkButton* _tmp18_;
			GtkButton* _tmp19_;
#line 142 "../src/font-viewer/MainWindow.vala"
			_tmp17_ = self->priv->action_button;
#line 142 "../src/font-viewer/MainWindow.vala"
			gtk_button_set_label (_tmp17_, _ ("Newer version already installed"));
#line 143 "../src/font-viewer/MainWindow.vala"
			_tmp18_ = self->priv->action_button;
#line 143 "../src/font-viewer/MainWindow.vala"
			gtk_widget_add_css_class ((GtkWidget*) _tmp18_, FONT_MANAGER_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 144 "../src/font-viewer/MainWindow.vala"
			_tmp19_ = self->priv->action_button;
#line 144 "../src/font-viewer/MainWindow.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp19_, _ ("Click to overwrite"));
#line 145 "../src/font-viewer/MainWindow.vala"
			break;
#line 1052 "MainWindow.c"
		}
#line 135 "../src/font-viewer/MainWindow.vala"
		case FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_WOULD_UPGRADE:
#line 1056 "MainWindow.c"
		{
			GtkButton* _tmp20_;
			GtkButton* _tmp21_;
			GtkButton* _tmp22_;
#line 147 "../src/font-viewer/MainWindow.vala"
			_tmp20_ = self->priv->action_button;
#line 147 "../src/font-viewer/MainWindow.vala"
			gtk_button_set_label (_tmp20_, _ ("Update Font"));
#line 148 "../src/font-viewer/MainWindow.vala"
			_tmp21_ = self->priv->action_button;
#line 148 "../src/font-viewer/MainWindow.vala"
			gtk_widget_add_css_class ((GtkWidget*) _tmp21_, FONT_MANAGER_STYLE_CLASS_SUGGESTED_ACTION);
#line 149 "../src/font-viewer/MainWindow.vala"
			_tmp22_ = self->priv->action_button;
#line 149 "../src/font-viewer/MainWindow.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp22_, _ ("Click to overwrite"));
#line 150 "../src/font-viewer/MainWindow.vala"
			break;
#line 1075 "MainWindow.c"
		}
#line 135 "../src/font-viewer/MainWindow.vala"
		case FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_INSTALLED:
#line 1079 "MainWindow.c"
		{
			GtkButton* _tmp23_;
			GtkButton* _tmp24_;
#line 152 "../src/font-viewer/MainWindow.vala"
			_tmp23_ = self->priv->action_button;
#line 152 "../src/font-viewer/MainWindow.vala"
			gtk_button_set_label (_tmp23_, _ ("Remove Font"));
#line 153 "../src/font-viewer/MainWindow.vala"
			_tmp24_ = self->priv->action_button;
#line 153 "../src/font-viewer/MainWindow.vala"
			gtk_widget_add_css_class ((GtkWidget*) _tmp24_, FONT_MANAGER_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 154 "../src/font-viewer/MainWindow.vala"
			break;
#line 1093 "MainWindow.c"
		}
		default:
		{
			GtkButton* _tmp25_;
			GtkButton* _tmp26_;
#line 156 "../src/font-viewer/MainWindow.vala"
			_tmp25_ = self->priv->action_button;
#line 156 "../src/font-viewer/MainWindow.vala"
			gtk_button_set_label (_tmp25_, _ ("Install Font"));
#line 157 "../src/font-viewer/MainWindow.vala"
			_tmp26_ = self->priv->action_button;
#line 157 "../src/font-viewer/MainWindow.vala"
			gtk_widget_add_css_class ((GtkWidget*) _tmp26_, FONT_MANAGER_STYLE_CLASS_SUGGESTED_ACTION);
#line 158 "../src/font-viewer/MainWindow.vala"
			break;
#line 1109 "MainWindow.c"
		}
	}
#line 160 "../src/font-viewer/MainWindow.vala"
	return;
#line 1114 "MainWindow.c"
}

static gboolean
font_manager_font_viewer_main_window_remove_directory_tree_if_empty (FontManagerFontViewerMainWindow* self,
                                                                     GFile* dir)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 163 "../src/font-viewer/MainWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 163 "../src/font-viewer/MainWindow.vala"
	g_return_val_if_fail (dir != NULL, FALSE);
#line 1127 "MainWindow.c"
	{
		GFileEnumerator* enumerator = NULL;
		GFileEnumerator* _tmp0_;
		GFileInfo* _tmp1_ = NULL;
		GFileEnumerator* _tmp2_;
		GFileInfo* _tmp3_;
		GFile* parent = NULL;
		GFile* _tmp4_;
		GFile* _tmp5_;
#line 165 "../src/font-viewer/MainWindow.vala"
		_tmp0_ = g_file_enumerate_children (dir, G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 165 "../src/font-viewer/MainWindow.vala"
		enumerator = _tmp0_;
#line 165 "../src/font-viewer/MainWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1143 "MainWindow.c"
			goto __catch0_g_error;
		}
#line 167 "../src/font-viewer/MainWindow.vala"
		_tmp2_ = enumerator;
#line 167 "../src/font-viewer/MainWindow.vala"
		_tmp3_ = g_file_enumerator_next_file (_tmp2_, NULL, &_inner_error0_);
#line 167 "../src/font-viewer/MainWindow.vala"
		_tmp1_ = _tmp3_;
#line 167 "../src/font-viewer/MainWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 167 "../src/font-viewer/MainWindow.vala"
			_g_object_unref0 (enumerator);
#line 1156 "MainWindow.c"
			goto __catch0_g_error;
		}
#line 167 "../src/font-viewer/MainWindow.vala"
		if (_tmp1_ != NULL) {
#line 168 "../src/font-viewer/MainWindow.vala"
			result = FALSE;
#line 168 "../src/font-viewer/MainWindow.vala"
			_g_object_unref0 (_tmp1_);
#line 168 "../src/font-viewer/MainWindow.vala"
			_g_object_unref0 (enumerator);
#line 168 "../src/font-viewer/MainWindow.vala"
			return result;
#line 1169 "MainWindow.c"
		}
#line 169 "../src/font-viewer/MainWindow.vala"
		_tmp4_ = g_file_get_parent (dir);
#line 169 "../src/font-viewer/MainWindow.vala"
		parent = _tmp4_;
#line 170 "../src/font-viewer/MainWindow.vala"
		g_file_delete (dir, NULL, &_inner_error0_);
#line 170 "../src/font-viewer/MainWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 170 "../src/font-viewer/MainWindow.vala"
			_g_object_unref0 (parent);
#line 170 "../src/font-viewer/MainWindow.vala"
			_g_object_unref0 (_tmp1_);
#line 170 "../src/font-viewer/MainWindow.vala"
			_g_object_unref0 (enumerator);
#line 1185 "MainWindow.c"
			goto __catch0_g_error;
		}
#line 171 "../src/font-viewer/MainWindow.vala"
		_tmp5_ = parent;
#line 171 "../src/font-viewer/MainWindow.vala"
		if (_tmp5_ != NULL) {
#line 1192 "MainWindow.c"
			GFile* _tmp6_;
#line 172 "../src/font-viewer/MainWindow.vala"
			_tmp6_ = parent;
#line 172 "../src/font-viewer/MainWindow.vala"
			font_manager_font_viewer_main_window_remove_directory_tree_if_empty (self, _tmp6_);
#line 1198 "MainWindow.c"
		}
#line 173 "../src/font-viewer/MainWindow.vala"
		result = TRUE;
#line 173 "../src/font-viewer/MainWindow.vala"
		_g_object_unref0 (parent);
#line 173 "../src/font-viewer/MainWindow.vala"
		_g_object_unref0 (_tmp1_);
#line 173 "../src/font-viewer/MainWindow.vala"
		_g_object_unref0 (enumerator);
#line 173 "../src/font-viewer/MainWindow.vala"
		return result;
#line 1210 "MainWindow.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 164 "../src/font-viewer/MainWindow.vala"
		e = _inner_error0_;
#line 164 "../src/font-viewer/MainWindow.vala"
		_inner_error0_ = NULL;
#line 175 "../src/font-viewer/MainWindow.vala"
		_tmp7_ = e;
#line 175 "../src/font-viewer/MainWindow.vala"
		_tmp8_ = _tmp7_->message;
#line 175 "../src/font-viewer/MainWindow.vala"
		g_warning ("MainWindow.vala:175: %s", _tmp8_);
#line 164 "../src/font-viewer/MainWindow.vala"
		_g_error_free0 (e);
#line 1230 "MainWindow.c"
	}
	__finally0:
#line 164 "../src/font-viewer/MainWindow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1235 "MainWindow.c"
		gboolean _tmp9_ = FALSE;
#line 164 "../src/font-viewer/MainWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 164 "../src/font-viewer/MainWindow.vala"
		g_clear_error (&_inner_error0_);
#line 164 "../src/font-viewer/MainWindow.vala"
		return _tmp9_;
#line 1243 "MainWindow.c"
	}
#line 177 "../src/font-viewer/MainWindow.vala"
	result = FALSE;
#line 177 "../src/font-viewer/MainWindow.vala"
	return result;
#line 1249 "MainWindow.c"
}

void
font_manager_font_viewer_main_window_on_action_button_clicked (FontManagerFontViewerMainWindow* self)
{
	GFile* font_dir = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 181 "../src/font-viewer/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 182 "../src/font-viewer/MainWindow.vala"
	_tmp0_ = font_manager_get_user_font_directory ();
#line 182 "../src/font-viewer/MainWindow.vala"
	_tmp1_ = _tmp0_;
#line 182 "../src/font-viewer/MainWindow.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 182 "../src/font-viewer/MainWindow.vala"
	_tmp3_ = _tmp2_;
#line 182 "../src/font-viewer/MainWindow.vala"
	_g_free0 (_tmp1_);
#line 182 "../src/font-viewer/MainWindow.vala"
	font_dir = _tmp3_;
#line 183 "../src/font-viewer/MainWindow.vala"
	switch (self->priv->file_status) {
#line 183 "../src/font-viewer/MainWindow.vala"
		case FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_SYSTEM_FONT:
#line 1279 "MainWindow.c"
		{
			gchar* directory = NULL;
			GFile* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			GFile* file = NULL;
			const gchar* _tmp9_;
			GFile* _tmp10_;
			GtkFileLauncher* launcher = NULL;
			GFile* _tmp11_;
			GtkFileLauncher* _tmp12_;
			GtkFileLauncher* _tmp13_;
#line 185 "../src/font-viewer/MainWindow.vala"
			_tmp4_ = self->priv->current_file;
#line 185 "../src/font-viewer/MainWindow.vala"
			_tmp5_ = g_file_get_path (_tmp4_);
#line 185 "../src/font-viewer/MainWindow.vala"
			_tmp6_ = _tmp5_;
#line 185 "../src/font-viewer/MainWindow.vala"
			_tmp7_ = g_path_get_dirname (_tmp6_);
#line 185 "../src/font-viewer/MainWindow.vala"
			_tmp8_ = _tmp7_;
#line 185 "../src/font-viewer/MainWindow.vala"
			_g_free0 (_tmp6_);
#line 185 "../src/font-viewer/MainWindow.vala"
			directory = _tmp8_;
#line 186 "../src/font-viewer/MainWindow.vala"
			_tmp9_ = directory;
#line 186 "../src/font-viewer/MainWindow.vala"
			_tmp10_ = g_file_new_for_path (_tmp9_);
#line 186 "../src/font-viewer/MainWindow.vala"
			file = _tmp10_;
#line 187 "../src/font-viewer/MainWindow.vala"
			_tmp11_ = file;
#line 187 "../src/font-viewer/MainWindow.vala"
			_tmp12_ = gtk_file_launcher_new (_tmp11_);
#line 187 "../src/font-viewer/MainWindow.vala"
			launcher = _tmp12_;
#line 188 "../src/font-viewer/MainWindow.vala"
			_tmp13_ = launcher;
#line 188 "../src/font-viewer/MainWindow.vala"
			gtk_file_launcher_launch (_tmp13_, NULL, NULL, NULL, NULL);
#line 189 "../src/font-viewer/MainWindow.vala"
			_g_object_unref0 (launcher);
#line 189 "../src/font-viewer/MainWindow.vala"
			_g_object_unref0 (file);
#line 189 "../src/font-viewer/MainWindow.vala"
			_g_free0 (directory);
#line 189 "../src/font-viewer/MainWindow.vala"
			break;
#line 1332 "MainWindow.c"
		}
#line 183 "../src/font-viewer/MainWindow.vala"
		case FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_FILE_STATUS_INSTALLED:
#line 1336 "MainWindow.c"
		{
			{
				GFile* parent = NULL;
				GFile* _tmp14_;
				GFile* _tmp15_;
				GFile* _tmp16_;
				GFile* _tmp17_;
				FontManagerPreviewPane* _tmp18_;
#line 192 "../src/font-viewer/MainWindow.vala"
				_tmp14_ = self->priv->current_target;
#line 192 "../src/font-viewer/MainWindow.vala"
				_tmp15_ = g_file_get_parent (_tmp14_);
#line 192 "../src/font-viewer/MainWindow.vala"
				parent = _tmp15_;
#line 193 "../src/font-viewer/MainWindow.vala"
				_tmp16_ = self->priv->current_target;
#line 193 "../src/font-viewer/MainWindow.vala"
				g_file_delete (_tmp16_, NULL, &_inner_error0_);
#line 193 "../src/font-viewer/MainWindow.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 193 "../src/font-viewer/MainWindow.vala"
					_g_object_unref0 (parent);
#line 1359 "MainWindow.c"
					goto __catch0_g_error;
				}
#line 194 "../src/font-viewer/MainWindow.vala"
				_tmp17_ = parent;
#line 194 "../src/font-viewer/MainWindow.vala"
				font_manager_font_viewer_main_window_remove_directory_tree_if_empty (self, _tmp17_);
#line 195 "../src/font-viewer/MainWindow.vala"
				_tmp18_ = self->priv->preview_pane;
#line 195 "../src/font-viewer/MainWindow.vala"
				g_object_set (_tmp18_, "font", NULL, NULL);
#line 196 "../src/font-viewer/MainWindow.vala"
				font_manager_font_viewer_main_window_update (self);
#line 191 "../src/font-viewer/MainWindow.vala"
				_g_object_unref0 (parent);
#line 1374 "MainWindow.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GFile* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
#line 191 "../src/font-viewer/MainWindow.vala"
				g_clear_error (&_inner_error0_);
#line 198 "../src/font-viewer/MainWindow.vala"
				_tmp19_ = self->priv->current_target;
#line 198 "../src/font-viewer/MainWindow.vala"
				_tmp20_ = g_file_get_path (_tmp19_);
#line 198 "../src/font-viewer/MainWindow.vala"
				_tmp21_ = _tmp20_;
#line 198 "../src/font-viewer/MainWindow.vala"
				g_critical ("MainWindow.vala:198: Failed to remove %s", _tmp21_);
#line 198 "../src/font-viewer/MainWindow.vala"
				_g_free0 (_tmp21_);
#line 1394 "MainWindow.c"
			}
			__finally0:
#line 191 "../src/font-viewer/MainWindow.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 191 "../src/font-viewer/MainWindow.vala"
				_g_object_unref0 (font_dir);
#line 191 "../src/font-viewer/MainWindow.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 191 "../src/font-viewer/MainWindow.vala"
				g_clear_error (&_inner_error0_);
#line 191 "../src/font-viewer/MainWindow.vala"
				return;
#line 1407 "MainWindow.c"
			}
#line 200 "../src/font-viewer/MainWindow.vala"
			break;
#line 1411 "MainWindow.c"
		}
		default:
		{
			{
				GFile* _tmp22_;
				GFile* _tmp23_;
#line 203 "../src/font-viewer/MainWindow.vala"
				_tmp22_ = self->priv->current_file;
#line 203 "../src/font-viewer/MainWindow.vala"
				_tmp23_ = font_dir;
#line 203 "../src/font-viewer/MainWindow.vala"
				font_manager_install_file (_tmp22_, _tmp23_, &_inner_error0_);
#line 203 "../src/font-viewer/MainWindow.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1426 "MainWindow.c"
					goto __catch1_g_error;
				}
#line 204 "../src/font-viewer/MainWindow.vala"
				font_manager_font_viewer_main_window_update (self);
#line 1431 "MainWindow.c"
			}
			goto __finally1;
			__catch1_g_error:
			{
				GFile* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
#line 202 "../src/font-viewer/MainWindow.vala"
				g_clear_error (&_inner_error0_);
#line 206 "../src/font-viewer/MainWindow.vala"
				_tmp24_ = self->priv->current_file;
#line 206 "../src/font-viewer/MainWindow.vala"
				_tmp25_ = g_file_get_path (_tmp24_);
#line 206 "../src/font-viewer/MainWindow.vala"
				_tmp26_ = _tmp25_;
#line 206 "../src/font-viewer/MainWindow.vala"
				g_critical ("MainWindow.vala:206: Failed to install %s", _tmp26_);
#line 206 "../src/font-viewer/MainWindow.vala"
				_g_free0 (_tmp26_);
#line 1451 "MainWindow.c"
			}
			__finally1:
#line 202 "../src/font-viewer/MainWindow.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 202 "../src/font-viewer/MainWindow.vala"
				_g_object_unref0 (font_dir);
#line 202 "../src/font-viewer/MainWindow.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 202 "../src/font-viewer/MainWindow.vala"
				g_clear_error (&_inner_error0_);
#line 202 "../src/font-viewer/MainWindow.vala"
				return;
#line 1464 "MainWindow.c"
			}
#line 208 "../src/font-viewer/MainWindow.vala"
			break;
#line 1468 "MainWindow.c"
		}
	}
#line 210 "../src/font-viewer/MainWindow.vala"
	_g_object_unref0 (font_dir);
#line 210 "../src/font-viewer/MainWindow.vala"
	return;
#line 1475 "MainWindow.c"
}

static void
_font_manager_font_viewer_main_window_on_action_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                   gpointer self)
{
#line 24 "../src/font-viewer/MainWindow.vala"
	font_manager_font_viewer_main_window_on_action_button_clicked ((FontManagerFontViewerMainWindow*) self);
#line 1484 "MainWindow.c"
}

static void
font_manager_font_viewer_main_window_class_init (FontManagerFontViewerMainWindowClass * klass,
                                                 gpointer klass_data)
{
#line 24 "../src/font-viewer/MainWindow.vala"
	font_manager_font_viewer_main_window_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/font-viewer/MainWindow.vala"
	g_type_class_adjust_private_offset (klass, &FontManagerFontViewerMainWindow_private_offset);
#line 24 "../src/font-viewer/MainWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = font_manager_font_viewer_main_window_finalize;
#line 24 "../src/font-viewer/MainWindow.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/github/FontManager/FontManager/ui/font-viewer-main-window.ui");
#line 24 "../src/font-viewer/MainWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "title_label", FALSE, FontManagerFontViewerMainWindow_private_offset + G_STRUCT_OFFSET (FontManagerFontViewerMainWindowPrivate, title_label));
#line 24 "../src/font-viewer/MainWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "subtitle_label", FALSE, FontManagerFontViewerMainWindow_private_offset + G_STRUCT_OFFSET (FontManagerFontViewerMainWindowPrivate, subtitle_label));
#line 24 "../src/font-viewer/MainWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "stack", FALSE, FontManagerFontViewerMainWindow_private_offset + G_STRUCT_OFFSET (FontManagerFontViewerMainWindowPrivate, stack));
#line 24 "../src/font-viewer/MainWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "action_button", FALSE, FontManagerFontViewerMainWindow_private_offset + G_STRUCT_OFFSET (FontManagerFontViewerMainWindowPrivate, action_button));
#line 24 "../src/font-viewer/MainWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "headerbar", FALSE, FontManagerFontViewerMainWindow_private_offset + G_STRUCT_OFFSET (FontManagerFontViewerMainWindowPrivate, headerbar));
#line 24 "../src/font-viewer/MainWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "preview_pane", FALSE, FontManagerFontViewerMainWindow_private_offset + G_STRUCT_OFFSET (FontManagerFontViewerMainWindowPrivate, preview_pane));
#line 24 "../src/font-viewer/MainWindow.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_action_button_clicked", G_CALLBACK(_font_manager_font_viewer_main_window_on_action_button_clicked_gtk_button_clicked));
#line 1513 "MainWindow.c"
}

static void
font_manager_font_viewer_main_window_instance_init (FontManagerFontViewerMainWindow * self,
                                                    gpointer klass)
{
#line 24 "../src/font-viewer/MainWindow.vala"
	self->priv = font_manager_font_viewer_main_window_get_instance_private (self);
#line 24 "../src/font-viewer/MainWindow.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1524 "MainWindow.c"
}

static void
font_manager_font_viewer_main_window_finalize (GObject * obj)
{
	FontManagerFontViewerMainWindow * self;
#line 24 "../src/font-viewer/MainWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_FONT_VIEWER_TYPE_MAIN_WINDOW, FontManagerFontViewerMainWindow);
#line 26 "../src/font-viewer/MainWindow.vala"
	_g_object_unref0 (self->priv->current_file);
#line 27 "../src/font-viewer/MainWindow.vala"
	_g_object_unref0 (self->priv->current_target);
#line 29 "../src/font-viewer/MainWindow.vala"
	(self->priv->installed_files == NULL) ? NULL : (self->priv->installed_files = (_g_list_free__g_free0_ (self->priv->installed_files), NULL));
#line 24 "../src/font-viewer/MainWindow.vala"
	G_OBJECT_CLASS (font_manager_font_viewer_main_window_parent_class)->finalize (obj);
#line 1541 "MainWindow.c"
}

 G_GNUC_NO_INLINE static GType
font_manager_font_viewer_main_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerFontViewerMainWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_font_viewer_main_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerFontViewerMainWindow), 0, (GInstanceInitFunc) font_manager_font_viewer_main_window_instance_init, NULL };
	GType font_manager_font_viewer_main_window_type_id;
	font_manager_font_viewer_main_window_type_id = g_type_register_static (font_manager_application_window_get_type (), "FontManagerFontViewerMainWindow", &g_define_type_info, 0);
	FontManagerFontViewerMainWindow_private_offset = g_type_add_instance_private (font_manager_font_viewer_main_window_type_id, sizeof (FontManagerFontViewerMainWindowPrivate));
	return font_manager_font_viewer_main_window_type_id;
}

GType
font_manager_font_viewer_main_window_get_type (void)
{
	static volatile gsize font_manager_font_viewer_main_window_type_id__once = 0;
	if (g_once_init_enter (&font_manager_font_viewer_main_window_type_id__once)) {
		GType font_manager_font_viewer_main_window_type_id;
		font_manager_font_viewer_main_window_type_id = font_manager_font_viewer_main_window_get_type_once ();
		g_once_init_leave (&font_manager_font_viewer_main_window_type_id__once, font_manager_font_viewer_main_window_type_id);
	}
	return font_manager_font_viewer_main_window_type_id__once;
}

